# This Python file uses the following encoding: iso-8859-1
# All Music Guide music scrpaer
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import convertArtist
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):

    classical = 0
    i = string.find(source, "\"genre\": [")

    if i != -1:
        genre = searchForPlus(source, "\"genre\": [")
        i = string.find(genre, "],")
        genre = stripText(genre)
        i = string.find(source, "\"Classical\"")

        if i != -1:
            print "CLASSICAL ALBUM FOUND"
            classical = 1;


    # Main Extraction
    # Find Artist
    tag = "class=\"album-artist\""
    i = string.find(source, tag)

    if i == -1:
        tag = "class=\"release-artist\""
        i = string.find(source, tag)

    if i != -1:
        artist = searchForPlus(source, tag)
        artist = searchForPlus(artist, "<span")
        artist = searchForPlus(artist, "\">")
        artist = stripText(artist)

        if artist.startswith("<a href=") == 1:
            artist = searchForPlus(artist, "\">")

        i = string.find(artist, "<")
        artist = stripText(artist[0:i])
        artist = cleanup(artist)
        aw.setArtist(artist)


    # Find Title
    tag = "class=\"release-title\""
    i = string.find(source, tag)

    if i == -1:
        tag = "class=\"album-title\""
        i = string.find(source, tag)

    if i != -1:
        title = searchForPlus(source, tag)
        title = searchForPlus(title, ">")
        i = string.find(title, "<")
        title = stripText(title[0:i])
        title = cleanup(title)
        aw.setTitle(title)


    # Find Image
    tag = "class=\"album-cover"
    i = string.find(source, tag)

    if i == -1:
        tag = "class=\"release-cover\""
        i = string.find(source, tag)

    if i != -1:
        images = searchForPlus(source, tag)
        i = string.find(images, "</div>")
        images = stripText(images[0:i])

        i = string.find(images, " src=\"")

        if i != -1:
            image = searchForPlus(images, " src=\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])

            i = string.find(image, "/JPG_400/")

            if i != -1:
                image = string.replace(image, "/JPG_400/", "/JPG_250/")

            # Getting SSL exception fetching image, but http works
            image = string.replace(image, "https://", "http://")
            aw.setImage1(image)

            image = string.replace(image, "/JPG_250/", "/JPG_500/")
            aw.setLargeImage1(image)
        else:
            i = string.find(images, "\"url\":")

            if i != -1:
                image = searchForPlus(images, "\"url\":")
                image = searchForPlus(image, "\"")
                i = string.find(image, "\"")
                image = stripText(image[0:i])
                image = string.replace(image, "\\", "")
                aw.setImage1(image)
                aw.setLargeImage1(image)

            i = string.find(images, "\"zoomURL\":")

            if i != -1:
                image = searchForPlus(images, "\"zoomURL\":")
                image = searchForPlus(image, "\"")
                i = string.find(image, "\"")
                image = stripText(image[0:i])
                image = string.replace(image, "\\", "")
                aw.setLargeImage1(image)


    # Find Rating
    i = string.find(source, "class=\"allmusic-rating")

    if i != -1:
        rating = searchForPlus(source, "class=\"allmusic-rating")
        i = string.find(source, "itemprop=\"ratingValue\">")

        if i != -1:
            rating = searchForPlus(rating, "itemprop=\"ratingValue\">")
            i = string.find(rating, "<")
            rating = stripText(rating[0:i])
            aw.setMyRating(rating)


    # Find Date
    i = string.find(source, "class=\"release-date\">")

    if i != -1:
        date = searchForPlus(source, "class=\"release-date\">")
        date = searchForPlus(date, "<span>")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        aw.setReleaseDate(date)
        aw.setCopyrightDate(date)


    # Find Running Time
    i = string.find(source, "class=\"duration\">")

    if i != -1:
        time = searchForPlus(source, "class=\"duration\">")
        time = searchForPlus(time, "<span>")
        i = string.find(time, "<")
        aw.setRunningTime(stripText(time[0:i]))


    # Find Category
    i = string.find(source, "class=\"genre\"")

    if i != -1:
        category = searchForPlus(source, "class=\"genre\"")
        category = searchForPlus(category, "<div>")
        category = searchForPlus(category, "\">")
        i = string.find(category, "<")
        aw.setCategory1(stripText(category[0:i]))


    # Find Keywords (Styes)
    i = string.find(source, "class=\"styles\"")

    if i != -1:
        keywords = ""
        temp = searchForPlus(source, "class=\"styles\"")
        temp = searchForPlus(temp, "<div>")
        i = string.find(temp, "</div>")
        temp = stripText(temp[0:i])

        while (searchFor(temp, "<a href=\"") != None):
            temp = searchForPlus(temp, "<a href=\"")
            temp = searchForPlus(temp, "\">")
            i = string.find(temp, "<")

            if keywords == "":
                keywords = stripText(temp[0:i])
            else:
                keywords = keywords + ", " + stripText(temp[0:i])

        aw.setKeywords(keywords)


    # Find AMG ID
    i = string.find(source, "class=\"metadata-ids\"")

    if i != -1:
        amgid = searchForPlus(source, "class=\"metadata-ids\"")

        if string.find(amgid, "AMG Pop ID") != -1:
            amgid = searchForPlus(amgid, "AMG Pop ID")
            amgid = searchForPlus(amgid, "<span>")
            i = string.find(amgid, "<")
            aw.setExternalID(stripText(amgid[0:i]))

        if string.find(amgid, "AMG Classical ID") != -1:
            amgid = searchForPlus(amgid, "AMG Classical ID")
            amgid = searchForPlus(amgid, "<span>")
            i = string.find(amgid, "<")
            aw.setExternalID(stripText(amgid[0:i]))


    # Find Comments
    i = string.find(source, "class=\"review read-more\"")

    if i != -1:
        comment = searchForPlus(source, "class=\"review read-more\"")
        comment = searchForPlus(comment, "\">")

        i = string.find(comment, "class=\"review-author headline\">")

        if i != -1:
            comment = searchForPlus(comment, "class=\"review-author headline\">")
            i = string.find(comment, "</h3>")
            comments = stripText(comment[0:i])
        else:
            i = string.find(comment, "</div")
            comments = stripText(comment[0:i])

        comment = searchForPlus(comment, "class=\"text\"")
        comment = searchForPlus(comment, "<p>")
        i = string.find(comment, "</section>")
        comment = stripText(comment[0:i])
        comments = appendComment(comments, comment)

        comments = cleanup(comments)
        aw.setProductInfo(comments)


    # Find Tracks
    i = string.find(source, "class=\"track-listing\"")

    if i != -1:
        disks = searchForPlus(source, "class=\"track-listing\"")
        i = string.find(disks, "</section>")
        disks = stripText(disks[0:i])
        diskNum = 0
        diskTag = "class=\"disc\""

        while (searchFor(disks, diskTag) != None):
            diskNum = diskNum + 1
            disks = searchForPlus(disks, diskTag)
            tracks = disks
            i = string.find(tracks, "</table>")
            tracks = stripText(tracks[0:i])

            work = ""
            trackNum = 0
            trackTag = "<tr class=\"track"
            value = "true"

            while (value):
                # while (searchFor(tracks, trackTag) != None):
                i = string.find(tracks, "class=\"performance-title\"")
                j = string.find(tracks, trackTag)

                if j == -1:
                    break

                if i != -1:
                    if i < j:
                        work = searchForPlus(tracks, "class=\"performance-title\"")
                        work = searchForPlus(work, "href=")
                        work = searchForPlus(work, ">")
                        i = string.find(work, "<")
                        work = stripText(work[0:i])

                tracks = searchForPlus(tracks, trackTag)
                trackNum = trackNum + 1

                # tracks = searchForPlus(tracks, trackTag)
                i = string.find(tracks, "</tr>")
                track = stripText(tracks[0:i])

                title = searchForPlus(track, "class=\"title\"")
                title = searchForPlus(title, ">")
                title = searchForPlus(title, "\">")
                i = string.find(title, "<")
                title = stripText(title[0:i])

                songwriter = ""
                i = string.find(track, "class=\"composer\"")

                if i != -1:
                    writers = searchForPlus(track, "class=\"composer\"")
                    i = string.find(writers, "</td>")
                    writers = stripText(writers[0:i])

                    while (searchFor(writers, "href=") != None):
                        writers = searchForPlus(writers, "href=")
                        writers = searchForPlus(writers, "\">")
                        i = string.find(writers, "<")

                        if songwriter == "":
                            songwriter = stripText(writers[0:i])
                        else:
                            songwriter = songwriter + " / " + stripText(writers[0:i])

                artist = ""
                i = string.find(track, "class=\"primary\"")

                if i != -1:
                    artist = searchForPlus(track, "class=\"primary\"")
                    artist = searchForPlus(artist, "\">")
                    i = string.find(artist, "<")
                    artist = stripText(artist[0:i])

                time = ""
                i = string.find(track, "class=\"time\"")

                if i != -1:
                    time = searchForPlus(track, "class=\"time\"")
                    time = searchForPlus(time, ">")
                    i = string.find(time, "<")
                    time = stripText(time[0:i])

                if classical == 0:
                    aw.setTrack(diskNum, trackNum, title, songwriter=songwriter, artist=artist, time=time)
                else:
                    aw.setTrack(diskNum, trackNum, title, composer=songwriter, artist=artist, time=time, work=work)



    # Find Copyright Date
    i = string.find(source, "Name=\"RLS\"")

    if (i != -1):
        source = searchForPlus(source, "Name=\"RLS\"")
        source = searchForPlus(source, "WIDTH=71>")
        i = string.find(source, "<")
        aw.setCopyrightDate(stripText(source[0:i]))


def cleanup(comment):
    # Fixed in 3.22
    comment = string.replace(comment, "\xC3\xA1", "")
    comment = string.replace(comment, "\xC3\xA3", "")
    comment = string.replace(comment, "\xC3\xA7", "")
    comment = string.replace(comment, "\xC3\xAA", "")
    comment = string.replace(comment, "\xC3\xB3", "")
    comment = string.replace(comment, "\xC3\xB4", "")
    comment = string.replace(comment, "\xC3\xBA", "")
    comment = string.replace(comment, "\xCC\xA3", "")
    comment = string.replace(comment, "\xCC\xA4", "")
    comment = string.replace(comment, "\xCC\xA9", "")
    comment = string.replace(comment, "\xCC\xAB", "")
    comment = string.replace(comment, "\xCC\xC1", "")
    return comment


try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
