# This Python file uses the following encoding: iso-8859-1
# Amazon API scraper
#
# Copyright  1999-2019 Readerware Corporation.  All Rights Reserved.
#
# This will be called once the media object has been built using the Amazon API.
#
# This is a chance to adjust the extracted data.

import  os
import  string

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    java.lang import String
from    java.util import Date

import  aw


def apiextract(source):
    print "Amazon API album extraction script..."

    if source == "None":
        print "No source object received."
        return

    # Find Comments
    tag = "Editorial Reviews"
    comments = "Editorial Reviews<BR>"

    if string.find(source, tag) == -1:
        # Amazon UK comments
        tag = "Product description"
        comments = ""

    if string.find(source, tag) != -1:
        reviews = searchForPlus(source, tag)
        reviews = searchForPlus(reviews, ">")

        i = string.find(reviews, "<style")

        if i != -1:
            reviews = stripText(reviews[0:i])

        while (searchFor(reviews, "id=\"productDescription\"") != None):
            reviews = searchForPlus(reviews, "id=\"productDescription\"")
            reviews = searchForPlus(reviews, ">")
            i = string.find(reviews, "</div>")
            comment = stripText(reviews[0:i])

            comments = appendComment(comments, comment)

        while (searchFor(reviews, "class=\"productDescriptionWrapper\"") != None):
            reviews = searchForPlus(reviews, "class=\"productDescriptionWrapper\"")
            reviews = searchForPlus(reviews, ">")
            i = string.find(reviews, "</div>")
            comment = stripText(reviews[0:i])

            comments = appendComment(comments, comment)


        aw.setProductInfo(comments)


    # Find Tracks
    i = string.find(source, ">Listen to Samples and Buy MP3s<")
    gotTracks = 0

    if gotTracks == 0 and i != -1:
        gotTracks = 1
        disks = searchForPlus(source, ">Listen to Samples and Buy MP3s<")
        disks = searchForPlus(disks, "id='albumTrackList'")
        i = string.find(disks, "id=\"productDetails\"")
        disks = stripText(disks[0:i])

        disks = "id=\"dmusic_tracklist_player_disc_1" + disks

        diskCount = 0

        while (searchFor(disks, "id=\"dmusic_tracklist_player_disc_") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, "id=\"dmusic_tracklist_player_disc_")

            i = string.find(disks, "id=\"dmusic_tracklist_player_disc_")

            if i != -1:
                tracks = stripText(disks[0:i])
            else:
                tracks = disks

            trackCount = 0

            while (searchFor(tracks, "class=\"titleCol\"") != None):
                trackCount = trackCount + 1
                tracks = searchForPlus(tracks, "class=\"titleCol\"")
                tracks = searchForPlus(tracks, " href=\"")
                tracks = searchForPlus(tracks, ">")
                i = string.find(tracks, "<")
                title = stripText(tracks[0:i])

                i = string.rfind(title, "(")

                if i >= 1:
                    title = stripText(title[0:i])

                artist = ""
                i = string.find(tracks, "class=\"titleCol\"")

                if i != -1 and i < 100:
                    tracks = searchForPlus(tracks, "class=\"titleCol\"")
                    tracks = searchForPlus(tracks, " href=\"")
                    tracks = searchForPlus(tracks, ">")
                    i = string.find(tracks, "<")
                    artist = stripText(tracks[0:i])

                tracks = searchForPlus(tracks, "class=\"runtimeCol\"")
                tracks = searchForPlus(tracks, ">")
                i = string.find(tracks, "<")
                time = stripText(tracks[0:i])

                bonus = ""

                aw.setTrack(diskCount, trackCount, title, artist=artist, time=time, bonus=bonus)


    tag = ">Track Listings<"
    i = string.find(source, tag)

    if i == -1:
        tag = "Track Listings"
        i = string.find(source, tag)

    if gotTracks == 0 and i != -1:
        gotTracks = 1
        disks = searchForPlus(source, tag)
        i = string.find(disks, "<hr no")
        disks = stripText(disks[0:i])
        i = string.find(disks, "ref=dp_tracks_all_1")

        if i == -1:
            i = string.find(disks, "/ref=dp_tracks_all_full")

        if i == -1:
            i = string.find(disks, " tracks on this disc<")

        if i == -1:
            i = string.find(disks, ">See all items<")

        if i != -1:
            disks = stripText(disks[i-175:])
            disks = searchForPlus(disks, "<a href=\"")
            i = string.find(disks, "\">")
            url = "" + stripText(disks[0:i])
            http = HTTPConnection()
            http.resetReferer();
            http.blockForLoad();
            disks = http.getContents(url)
            disks = searchForPlus(disks, tag)
            i = string.find(disks, "<hr no")
            disks = stripText(disks[0:i])
            

        if string.find(disks, "Disc: ") == -1:
            disks = ">Disc: 1<" + disks

        diskCount = 0

        while (searchFor(disks, "Disc: ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, "Disc: ")
            i = string.find(disks, "</table>")
            tracks = stripText(disks[0:i])

            i = string.find(tracks, "Disc: ")

            if i != -1:
                tracks = stripText(tracks[0:i])

            i = string.find(tracks, "<div id=\"")

            if i != -1:
                tracks = stripText(tracks[0:i])

            trackCount = 0
            title = ""
            artist = ""
            time = ""
            bonus = ""

            while (searchFor(tracks, ". ") != None):
                trackCount = trackCount + 1
                tracks = searchForPlus(tracks, ". ")

                if (tracks[0:1] == "<"):
                    i = string.find(tracks, "<A HREF=")

                    if (i == 0):
                      i = string.find(tracks, ">")
                      tracks = stripText(tracks[i+1:])

                i = string.find(tracks, "<")

                if i != -1:
                    title = stripText(tracks[0:i])
                    j = string.find(title, ">")

                    if (j != -1):
                        title = stripText(title[j+1:])

                    j = string.find(title, " - ")

                    if (j != -1):
                        artist = stripText(title[j+3:])
                        title = stripText(title[0:j])

                tracks = tracks[i+1:]
                aw.setTrack(diskCount, trackCount, title, artist=artist, time=time, bonus=bonus)


    # Find Tracks
    i = string.find(source, "class=\"headerTitle\">MP3 Songs")

    if gotTracks == 0 and i != -1:
        gotTracks = 1
        # Intentionally searching for another key so that we get the >Disc tag
        source = searchForPlus(source, "id='albumTrackList'")
        disks = stripText(source)

        if string.find(disks, ">Disc ") == -1:
            disks = ">Disc 1<" + disks

        diskCount = 0

        while (searchFor(disks, ">Disc ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disc ")
            disks = searchForPlus(disks, "class=\"columnHeader\"")

            i = string.find(disks, "</table>")
            tracks = stripText(disks[0:i])

            trackCount = 0

            while (searchFor(tracks, "class=\"titleCol\"") != None):
                trackCount = trackCount + 1
                tracks = searchForPlus(tracks, "class=\"titleCol\"")
                tracks = searchForPlus(tracks, " href=\"")
                tracks = searchForPlus(tracks, ">")
                i = string.find(tracks, "<")
                title = stripText(tracks[0:i])

                i = string.rfind(title, "(")

                if i >= 1:
                    title = stripText(title[0:i])

                artist = ""
                i = string.find(tracks, "class=\"titleCol\"")

                if i != -1 and i < 100:
                    tracks = searchForPlus(tracks, "class=\"titleCol\"")
                    tracks = searchForPlus(tracks, " href=\"")
                    tracks = searchForPlus(tracks, ">")
                    i = string.find(tracks, "<")
                    artist = stripText(tracks[0:i])

                tracks = searchForPlus(tracks, "class=\"runtimeCol\"")
                tracks = searchForPlus(tracks, ">")
                i = string.find(tracks, "<")
                time = stripText(tracks[0:i])

                aw.setTrack(diskCount, trackCount, title, artist=artist, time=time)


    # Find Tracks - Amazon US MP3
    i = string.find(source, "id=\"dmusic_tracklist_player\"")

    if gotTracks == 0 and i != -1:
        gotTracks = 1
        disks = searchForPlus(source, "id=\"dmusic_tracklist_player\"")
        i = string.find(disks, "id=\"purchase-sims-feature\"")
        disks = stripText(disks[0:i])

        disks = "id=\"dmusic_tracklist_player_disc_1" + disks

        diskCount = 0

        while (searchFor(disks, "id=\"dmusic_tracklist_player_disc_") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, "id=\"dmusic_tracklist_player_disc_")

            i = string.find(disks, "id=\"dmusic_tracklist_player_disc_")

            if i != -1:
                tracks = stripText(disks[0:i])
            else:
                tracks = disks

            trackCount = 0

            while (searchFor(tracks, "\"dmusic_tracklist_track_title") != None):
                trackCount = trackCount + 1
                tracks = searchForPlus(tracks, "\"dmusic_tracklist_track_title")
                tracks = searchForPlus(tracks, " href=\"")
                tracks = searchForPlus(tracks, "\">")
                i = string.find(tracks, "<")
                title = stripText(tracks[0:i])

                if title == "Terms of Use":
                    continue

                i = string.rfind(title, "(")

                if i >= 1:
                    title = stripText(title[0:i])

                artist = ""
                i = string.find(tracks, "dmusic_tracklist_artist_name_")

                if i != -1:
                    tracks = searchForPlus(tracks, "dmusic_tracklist_artist_name_")
                    tracks = searchForPlus(tracks, " title=\"")
                    i = string.find(tracks, "\"")
                    artist = stripText(tracks[0:i])

                i = string.find(tracks, " ArtistLink\"")

                if i != -1:
                    tracks = searchForPlus(tracks, " ArtistLink\"")
                    tracks = searchForPlus(tracks, " href=\"")
                    tracks = searchForPlus(tracks, "\">")
                    i = string.find(tracks, "<")
                    artist = stripText(tracks[0:i])

                time = ""
                i = string.find(tracks, "id=\"dmusic_tracklist_duration")

                if i != -1:
                    tracks = searchForPlus(tracks, "id=\"dmusic_tracklist_duration")
                    tracks = searchForPlus(tracks, "<span ")
                    tracks = searchForPlus(tracks, ">")
                    i = string.find(tracks, "<")
                    time = stripText(tracks[0:i])

                aw.setTrack(diskCount, trackCount, title, artist=artist, time=time)


    # Find Tracks (Amazon UK MP3)
    i = string.find(source, "class=\"mp3Header\">MP3 Songs")

    if gotTracks == 0 and i != -1:
        gotTracks = 1
        source = searchForPlus(source, "class=\"mp3Header\">MP3 Songs")
        disks = stripText(source)

        if string.find(disks, ">Disc ") == -1:
            disks = ">Disc 1<" + disks

        diskCount = 0

        while (searchFor(disks, ">Disc ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disc ")

            i = string.find(disks, "class=\"mp3Tracks\"")

            if i != -1:
                disks = searchForPlus(disks, "class=\"mp3Tracks\"")

            i = string.find(disks, "</table>")
            tracks = stripText(disks[0:i])

            trackCount = 0

            while (searchFor(tracks, "<td class=\"songTitle\"") != None):
                trackCount = trackCount + 1
                tracks = searchForPlus(tracks, "<td class=\"songTitle\"")
                tracks = searchForPlus(tracks, " href=\"")
                tracks = searchForPlus(tracks, ">")
                i = string.find(tracks, "<")
                title = stripText(tracks[0:i])

                i = string.rfind(title, "(")

                if i >= 1:
                    title = stripText(title[0:i])

                artist = ""
                i = string.find(tracks, "class=\"artist\"")

                if i != -1 and i < 100:
                    tracks = searchForPlus(tracks, "class=\"artist\"")
                    tracks = searchForPlus(tracks, " href=\"")
                    tracks = searchForPlus(tracks, ">")
                    i = string.find(tracks, "<")
                    artist = stripText(tracks[0:i])

                tracks = searchForPlus(tracks, "class=\"runtimeCol\"")
                tracks = searchForPlus(tracks, ">")
                tracks = stripText(tracks)

                if tracks.startswith("<meta") == 1:
                    tracks = searchForPlus(tracks, ">")

                i = string.find(tracks, "<")
                time = stripText(tracks[0:i])

                aw.setTrack(diskCount, trackCount, title, artist=artist, time=time)


try:
    aw.setAlbumObject(Album)
    apiextract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()

