# This Python file uses the following encoding: iso-8859-1
#  ArkivMusic.com music scrpaer
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    aw.setCurrencySymbol("$")

    # Find Title
    source = searchForPlus(source, "ALBUM DETAIL SECTION BEGINS HERE")
    title = searchForPlus(source, "class=\"product-basicinfo\"")
    title = searchForPlus(title, "<h1>")
    i = string.find(title, "<")
    title = stripText(title[0:i])
    aw.setTitle(title)


    # Find Image
    i = string.find(source, "class=\"product-maincover\"")

    if i != -1:
        image = searchForPlus(source, "class=\"product-maincover\"")
        image = searchForPlus(image, " SRC=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "music-no-image")

        if i == -1:
            aw.setImage1(image)


    # Find Date
    i = string.find(source, ">Release Date:")

    if i != -1:
        date = searchForPlus(source, ">Release Date:")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        date = stripText(string.replace(date, "&nbsp;", " "))

        aw.setReleaseDate(date)


    # Find Label
    i = string.find(source, ">Label:<")

    if i != -1:
        label = searchForPlus(source, ">Label:<")
        label = searchForPlus(source, "CLASS=\"noline\"")
        label = searchForPlus(label, ">")
        i = string.find(label, "<")
        label = stripText(label[0:i])
        aw.setLabel(label)


    # Find Composer
    i = string.find(source, ">Composer:")

    if i != -1:
        composer = searchForPlus(source, ">Composer:")
        composer = searchForPlus(composer, "CLASS=\"noline\"")
        composer = searchForPlus(composer, ">")
        i = string.find(composer, "<")
        composer = stripText(composer[0:i])
        aw.setComposer(composer)


    # Find Conductor
    i = string.find(source, ">Conductor:")

    if i != -1:
        conductor = searchForPlus(source, ">Conductor:")
        conductor = searchForPlus(conductor, "CLASS=\"noline\"")
        conductor = searchForPlus(conductor, ">")
        i = string.find(conductor, "<")
        conductor = stripText(conductor[0:i])
        aw.setConductor(conductor)


    # Find Orchestra
    i = string.find(source, ">Orchestra/Ensemble:")

    if i != -1:
        artist = searchForPlus(source, ">Orchestra/Ensemble:")
        artist = searchForPlus(artist, "CLASS=\"noline\"")
        artist = searchForPlus(artist, ">")
        i = string.find(artist, "<")
        artist = stripText(artist[0:i])
        aw.setOrchestra(artist)


    # Find Performer
    i = string.find(source, ">Performer:")

    if i != -1:
        artist = searchForPlus(source, ">Performer:")
        artist = searchForPlus(artist, "CLASS=\"noline\"")
        artist = searchForPlus(artist, ">")
        i = string.find(artist, "<")
        artist = stripText(artist[0:i])
        aw.setSoloist(artist)


    # Find Sound
    i = string.find(source, ">Recorded in:")

    if i != -1:
        sound = searchForPlus(source, ">Recorded in:")
        sound = searchForPlus(sound, ">")
        i = string.find(sound, "<")
        sound = stripText(sound[0:i])
        sound = stripText(string.replace(sound, "&nbsp;", " "))
        i = string.find(source, ">Spars Code:")

        if i != -1:
            temp = searchForPlus(source, ">Spars Code:")
            temp = searchForPlus(temp, ">")
            i = string.find(temp, "<")
            temp = stripText(temp[0:i])
            temp = stripText(string.replace(temp, "&nbsp;", " "))
            if temp != "n/a":
                sound = sound + " (" + temp + ")"

        aw.setSound(sound)
       


    # Find Price
    i = string.find(source, "<!-- forsale:")

    if i != -1:
        value = searchForPlus(source, "<!-- forsale:")
        value = searchFor(value, "$")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        aw.setItemValue(value)

        aw.setPurchasePrice(aw.getItemValue())
        aw.setPurchaseDate(Date())
        aw.setPurchasePlace(aw.getSource())


    # Find Format
    i = string.find(source, "<!-- forsale:")

    if i != -1:
        format = searchForPlus(source, "<!-- forsale:")
        tag = "class=\"format\""
        i = string.find(format, tag)

        if i == -1:
            tag = "class=\"import\""
            i = string.find(format, tag)

        if i != -1:
            format = searchForPlus(format, tag)
            format = searchForPlus(format, ">")
            i = string.find(format, "<")
            format = stripText(format[0:i])

            i = string.find(format, ":")

            if i != -1:
                format = stripText(format[0:i])
            
            aw.setFormat(format)


    # Find Comments
    comments = ""
    i = string.find(source, "<!-- ALBUM NOTE-->")

    if i != -1:
        temp = searchForPlus(source, "<!-- ALBUM NOTE-->")
        i = string.find(temp, "<!-- ALBUM DETAIL SECTION ENDS HERE -->")
        temp = stripText(temp[0:i])

        while (searchFor(temp, "<a id=\"review\"") != None):
            temp = searchForPlus(temp, "<a id=\"review\"")
            temp = searchForPlus(temp, ">")
            i = string.find(temp, "<a id=\"review\"")

            if i != -1:
                comment = stripText(temp[0:i])
            else:
                comment = stripText(temp)

            i = string.find(comment, "id=\"bio-full\"")

            if i != -1:
                comment = searchForPlus(comment, "id=\"bio-excerpt\"")
                comment = searchForPlus(comment, ">")
                i = string.find(comment, "<a id=\"bio-read-more\"")

                if i == -1:
                    i = string.find(comment, "<span id")
                    comment = stripText(comment[0:i])
                else:
                    comment1 = stripText(comment[0:i])

                    comment = searchForPlus(comment, "id=\"bio-full\"")
                    comment = searchForPlus(comment, ">")
                    i = string.find(comment, "<a id=\"bio-read-less\"")
                    comment2 = stripText(comment[0:i])
                    comment = comment1 + " " + comment2

            comments = appendComment(comments, comment)

        aw.setProductInfo(comments)


    # Find Tracks
    i = string.find(source, "<!-- TRACK DETAILS SECTION BEGINS HERE -->")

    if i != -1:
        source = searchForPlus(source, "<!-- TRACK DETAILS SECTION BEGINS HERE -->")
        source = searchForPlus(source, "<a id=\"details\">")
        i = string.find(source, "<a id=")
        disks = stripText(source[0:i])
            

        if string.find(disks, ">Disc: ") == -1:
            disks = ">Disc: 1<" + disks

        diskCount = 0

        while (searchFor(disks, ">Disc: ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disc: ")
            i = string.find(disks, "<")
            diskid = "%02d" % int(stripText(disks[0:i]))

            i = string.find(disks, ">Individual Track Details:<")

            if i != -1:
                tracks = searchForPlus(disks, ">Individual Track Details:<")
                trackNum = 0

                while (searchFor(tracks, ".</FONT") != None):
                    tracks = searchForPlus(tracks, ".</FONT")
                    track = searchForPlus(tracks, "CLASS=\"piecename\">")
                    i = string.find(track, "<")
                    track = stripText(track[0:i])

                    i = string.find(tracks, "> by <")
                    composer = ""

                    if i != -1:
                        composer = searchForPlus(tracks, "> by <")
                        composer = searchForPlus(composer, ">")
                        i = string.find(composer, "<")
                        composer = stripText(composer[0:i])

                    i = string.find(tracks, ">Performer:<")
                    soloist = ""

                    if i != -1:
                        soloist = searchForPlus(tracks, ">Performer:<")
                        soloist = searchForPlus(soloist, ">")
                        i = string.find(soloist, "<FONT ")

                    i = string.find(tracks, ">Orchestra/Ensemble:<")
                    orchestra = ""

                    if i != -1:
                        orchestra = searchForPlus(tracks, ">Orchestra/Ensemble:<")
                        orchestra = searchForPlus(orchestra, ">")
                        i = string.find(orchestra, "<")
                        orchestra = stripText(orchestra[0:i])

                    trackNum = trackNum + 1

                    i = string.find(tracks, "CLASS=\"text\"")

                    if i != -1:
                        tracks = searchForPlus(tracks, "CLASS=\"text\"")

                    aw.setTrack(diskCount, trackNum, track, artist=artist, composer=composer, soloist=soloist, orchestra=orchestra)


            i = string.find(disks, ">Works on This Recording<")

            if i != -1:
                tracks = searchForPlus(disks, ">Works on This Recording<")
                trackNum = 0

                while (searchFor(tracks, "CLASS=\"piecedata\"") != None):
                    tracks = searchForPlus(tracks, "CLASS=\"piecedata\"")
                    track = searchForPlus(tracks, "<strong>")
                    i = string.find(track, "<")
                    title = stripText(track[0:i])

                    i = string.find(track, "<em>by")
                    composer = ""

                    if i != -1:
                        composer = searchForPlus(track, "<em>by")
                        i = string.find(composer, "<")
                        composer = stripText(composer[0:i])

                    i = string.find(track, ">Performer:<")
                    soloist = ""

                    if i != -1:
                        soloist = searchForPlus(track, ">Performer:<")
                        soloist = searchForPlus(soloist, ">")
                        i = string.find(soloist, "<")
                        soloist = stripText(soloist[0:i])

                        i = string.find(soloist, ",")

                        if i != -1:
                            soloist = stripText(soloist[0:i])

                        i = string.find(soloist, "(")

                        if i != -1:
                            soloist = stripText(soloist[0:i])

                    i = string.find(track, ">Orchestra/Ensemble:<")
                    orchestra = ""

                    if i != -1:
                        orchestra = searchForPlus(track, ">Orchestra/Ensemble:<")
                        orchestra = searchForPlus(orchestra, ">")
                        i = string.find(orchestra, "<")
                        orchestra = stripText(orchestra[0:i])

                    i = string.find(track, ">Conductor:<")
                    conductor = ""

                    if i != -1:
                        conductor = searchForPlus(track, ">Conductor:<")
                        conductor = searchForPlus(conductor, ">")
                        i = string.find(conductor, "<")
                        conductor = stripText(conductor[0:i])

                    trackNum = trackNum + 1

                    aw.setAltTrack(diskCount, trackNum, title, composer=composer, soloist=soloist, orchestra=orchestra, conductor=conductor)
                    tracks = searchForPlus(tracks, "CLASS=\"piecedata\"")




try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
