# This Python file uses the following encoding: iso-8859-1
# Acoustic Sounds music scrpaer
#
# Copyright  1999-2015 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import convertArtist
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):


    # Main Extraction (Rock)
    # Find Artist
    tag = "<H1 style"
    i = string.find(source, tag)

    if i != -1:
        artist = searchForPlus(source, tag)
        artist = searchForPlus(artist, "HREF=\"")
        artist = searchForPlus(artist, "\">")
        i = string.find(artist, "<")
        artist = stripText(artist[0:i])
        aw.setArtist(artist)


    # Find Title
    tag = "> -"
    i = string.find(source, tag)

    if i != -1:
        title = searchForPlus(source, tag)
        i = string.find(title, "<")
        title = stripText(title[0:i])
        aw.setTitle(title)


    # Find Comments
    tag = "<H2 style"
    i = string.find(source, tag)

    if i != -1:
        title = searchForPlus(source, tag)
        title = searchForPlus(title, "\">")
        i = string.find(title, "<")
        title = stripText(title[0:i])
        aw.setMyComments(title)


    # Find Image
    tag = "<IMG SRC=\"http://store.acousticsounds.com/images/medium/"
    i = string.find(source, tag)

    if i != -1:
        image = searchFor(source, tag)
        image = searchForPlus(image, "SRC=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])
        aw.setImage1(image)

        image = string.replace(image, "/medium/", "/large/")
        aw.setLargeImage1(image)


    # Find Label
    tag = ">Label:<"
    i = string.find(source, tag)

    if i != -1:
        label = searchForPlus(source, tag)
        label = searchForPlus(label, "<H3 ")
        label = searchForPlus(label, "\">")
        i = string.find(label, "<")
        label = stripText(label[0:i])
        aw.setLabel(label)


    # Find Category
    tag = ">Genre:<"
    i = string.find(source, tag)

    if i != -1:
        category = searchForPlus(source, tag)
        category = searchForPlus(category, "<H3 ")
        category = searchForPlus(category, "\">")
        i = string.find(category, "<")
        category = stripText(category[0:i])
        aw.setCategory1(category)


    # Find Format
    tag = ">Category:<"
    i = string.find(source, tag)

    if i != -1:
        format = searchForPlus(source, tag)
        format = searchForPlus(format, "<H3 ")
        format = searchForPlus(format, "\">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        aw.setFormat(format)


    # Find Price
    tag = "start includes/price.cfm"
    i = string.find(source, tag)

    if i != -1:
        price = searchForPlus(source, tag)
        price = searchForPlus(price, "\">")
        i = string.find(price, "<")
        price = stripText(price[0:i])
        aw.setItemValue(price)
        aw.setPurchasePrice(aw.getItemValue())
        aw.setPurchaseDate(Date())
        aw.setPurchasePlace(aw.getSource())


    # Find album info
    tag = "id=\"description\""
    i = string.find(source, tag)

    if i != -1:
        comment = searchForPlus(source, tag)

        i = string.find(comment, "CLASS=\"blurb\"")

        if i != -1:
            comment = searchForPlus(comment, "CLASS=\"blurb\"")
            comment = searchForPlus(comment, ">")
            i = string.find(comment, "</SPAN>")
            comment = stripText(comment[0:i])
            aw.setProductInfo(comment)


    # Find Rating
    i = string.find(source, ">Customer Reviews<")

    if i != -1:
        rating = searchForPlus(source, ">Customer Reviews<")
        rating = searchForPlus(rating, "CLASS=\"blurb2\"")
        rating = searchForPlus(rating, "(")
        i = string.find(rating, ")")
        rating = stripText(rating[0:i])
        aw.setMyRating(rating)


    # Find Tracks
    i = string.find(source, "id=\"tracks\"")

    if i != -1:
        disks = searchForPlus(source, "id=\"tracks\"")
        i = string.find(disks, "</table>")
        disks = stripText(disks[0:i])
        diskNum = 0
        diskTag = "<b>LP"

        i = string.find(disks, diskTag)

        if i == -1:
            disks = "<td nowrap><br><b>LP 1:  	</td>" + disks

        while (searchFor(disks, diskTag) != None):
            print "DISKS=",disks[0:500]
            diskNum = diskNum + 1
            disks = searchForPlus(disks, diskTag)
            tracks = disks
            i = string.find(tracks, diskTag)
            tracks = stripText(tracks[0:i])

            trackNum = 0
            trackTag = "<td nowrap>"

            while (searchFor(tracks, trackTag) != None):
                trackNum = trackNum + 1

                tracks = searchForPlus(tracks, trackTag)
                i = string.find(tracks, "<")
                track = stripText(tracks[0:i])
                print "TRACK=",track

                if track == "":
                    continue;

                if track.startswith("<b>Side ") == 1:
                    continue;

                if track.startswith("<br><b>Side ") == 1:
                    continue;

                i = string.find(track, ".")

                if i != -1 and i < 3:
                    track = searchForPlus(track, ".")

                aw.setTrack(diskNum, trackNum, track)




try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
