# This Python file uses the following encoding: iso-8859-1
# bandcamp music scrpaer
#
# Copyright  1999-2017 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import convertArtist
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):


    # Main Extraction


    # Find Title
    tag = "id=\"name-section\""
    i = string.find(source, tag)

    if i != -1:
        title = searchForPlus(source, tag)
        title = searchForPlus(title, "\">")
        i = string.find(title, "<")
        title = stripText(title[0:i])
        aw.setTitle(title)

    # Find Artist
    tag = "<h3 style=\"margin:0px;\">by"
    i = string.find(source, tag)

    if i != -1:
        artist = searchForPlus(source, tag)
        artist = searchForPlus(artist, "\">")
        i = string.find(artist, "<")
        artist = stripText(artist[0:i])
        aw.setArtist(artist)


    # Find Image
    tag = "id=\"tralbumArt\""
    i = string.find(source, tag)

    if i != -1:
        images = searchFor(source, tag)
        i = string.find(images, "</div>")
        images = stripText(images[0:i])

        i = string.find(images, "src=\"")

        if i != -1:
            image = searchForPlus(images, "src=\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])
            aw.setImage1(image)

        i = string.find(images, "href=\"")

        if i != -1:
            image = searchForPlus(images, "href=\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])
            aw.setLargeImage1(image)


    # Find Album info
    infos = ""
    tag = "class=\"about-label\""
    i = string.find(source, tag)

    if i != -1:
        info = searchForPlus(source, tag)
        info = searchForPlus(info, "class=\"tralbumData tralbum-about\"")
        info = searchForPlus(info, ">")
        i = string.find(info, "</div>")
        info = stripText(info[0:i])
        infos = info

    tag = "class=\"credits-label\""
    i = string.find(source, tag)

    if i != -1:
        info = searchForPlus(source, tag)
        info = searchForPlus(info, "class=\"tralbumData tralbum-credits\"")
        info = searchForPlus(info, ">")
        i = string.find(info, "</div>")
        info = "Credits<BR>" + stripText(info[0:i])
        infos = appendComment(infos, info)

    i = string.find(infos, "<meta")
    infos = infos + "     "

    if i != -1:
        j = string.find(infos[i:], ">")
        infos = infos[0:i] + infos[i+j+1:]

    aw.setProductInfo(stripText(infos))


    # Find Release date
    tag = "itemprop=\"datePublished\""
    i = string.find(source, tag)

    if i != -1:
        date = searchForPlus(source, tag)
        date = searchForPlus(date, "content=\"")
        i = string.find(date, "\"")
        date = stripText(date[0:i])
        date = date[0:4] + "-" + date[4:6] + "-" + date[6:]
        aw.setReleaseDate(date)


    # Find Label
    tag = "Released by:"
    i = string.rfind(source, tag)

    if i != -1:
        label = stripText(source[i:])
        label = searchForPlus(label, tag)
        i = string.find(label, "<")
        label = stripText(label[0:i])
        aw.setLabel(label)


    # Find Category
    tag = "class=\"tags-label\""
    i = string.find(source, tag)

    if i != -1:
        cats = searchForPlus(source, tag)
        i = string.find(cats, "</div>")
        cats = stripText(cats[0:i])

        ccount = 1

        while (searchFor(cats, "href=\"") != None):
            cats = searchForPlus(cats, "href=\"")
            cats = searchForPlus(cats, ">")
            i = string.find(cats, "<")
            cat = stripText(cats[0:i])

            if cat == "Music":
                continue

            if cat == "CDs & Vinyl":
                continue

            if ccount == 1:
                aw.setCategory1(cat)
            elif ccount == 2:
                aw.setCategory2(cat)
            else:
                aw.setCategory3(cat)
                break

            ccount = ccount + 1


    # Find Tracks
    i = string.find(source, "class=\"track_list track_table\"")

    if i != -1:
        disks = searchForPlus(source, "class=\"track_list track_table\"")
        i = string.find(disks, "</table>")
        disks = stripText(disks[0:i])
        diskNum = 0
        diskTag = "<b>LP"

        i = string.find(disks, diskTag)

        if i == -1:
            disks = "<td nowrap><br><b>LP 1:  	</td>" + disks

        while (searchFor(disks, diskTag) != None):
            diskNum = diskNum + 1
            disks = searchForPlus(disks, diskTag)
            tracks = disks
            i = string.find(tracks, diskTag)
            tracks = stripText(tracks[0:i])

            trackNum = 0
            trackTag = "class=\"title\""

            while (searchFor(tracks, trackTag) != None):
                trackNum = trackNum + 1

                tracks = searchForPlus(tracks, trackTag)
                i = string.find(tracks, "</div>")
                track = stripText(tracks[0:i])

                i = string.find(track, "class=\"track-title\"")

                if i != -1:
                    title = searchForPlus(track, "class=\"track-title\"")
                    title = searchForPlus(title, ">")
                    i = string.find(title, "<")
                    title = stripText(title[0:i])

                time = ""
                i = string.find(track, "class=\"time secondaryText\"")

                if i != -1:
                    time = searchForPlus(track, "class=\"time secondaryText\"")
                    time = searchForPlus(time, ">")
                    i = string.find(time, "<")
                    time = stripText(time[0:i])

                aw.setTrack(diskNum, trackNum, title, time=time)




try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
