# This Python file uses the following encoding: iso-8859-1
# Discogs music scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Find Buyer Waiting
    i = string.find(source, ">Add to Wantlist<")

    if i != -1:
        buyerwaiting = searchForPlus(source, ">Add to Wantlist<")
        buyerwaiting = searchForPlus(buyerwaiting, "\">")
        i = string.find(buyerwaiting, " ")
        buyerwaiting = stripText(buyerwaiting[0:i])

        if buyerwaiting == "0":
            aw.setBuyerWaiting("false")
        else:
            aw.setBuyerWaiting("true")


    # Main Extraction

    # Find Discogs ID
    i = string.find(source, "}, \"id\": ")

    if i != -1:
        amgid = searchForPlus(source, "}, \"id\": ")
        amgid = searchForPlus(amgid, "\"")
        i = string.find(amgid, "\"")
        amgid = stripText(amgid[0:i])

        if amgid.startswith("r") == 1:
            amgid = stripText(amgid[1:])

        aw.setExternalID(amgid)


    source = searchForPlus(source, "class=\"body\"")


    # Find Image, first try
    imageTag = "class=\"image_gallery"
    i = string.find(source, imageTag)

    if i != -1:
        images = searchForPlus(source, imageTag)

        i = string.find(images, "data-images=")

        if i != -1:
            images = searchForPlus(images, "data-images=")
            i = string.find(images, "}]")
            images = stripText(images[0:i])

            i = string.find(images, "\"thumb\": \"")

            if i != -1:
                image = searchForPlus(images, "\"thumb\": \"")
                i = string.find(image, "\"")
                image = stripText(image[0:i])
                aw.setRefImage1(image, "http://www.discogs.com/")

            i = string.find(images, "\"full\": \"")

            if i != -1:
                image = searchForPlus(images, "\"full\": \"")
                i = string.find(image, "\"")
                image = stripText(image[0:i])
                aw.setRefLargeImage1(image, "http://www.discogs.com/")


    # Find Image, second try
    if aw.getImage1() == None:
        imageTag = "class=\"image_gallery"
        i = string.find(source, imageTag)

        if i != -1:
            source = searchForPlus(source, imageTag)
            i = string.find(source, " src=\"")

            if i != -1:
                image = searchForPlus(source, " src=\"")
                i = string.find(image, "\"")
                image = stripText(image[0:i])

                i = string.find(image, "music-no-image")

                if i == -1:
                    aw.setRefImage1(image, "http://www.discogs.com/")

            i = string.find(source, "href=\"/viewimages")

            if i != -1:
                url = searchForPlus(source, "href=\"")
                i = string.find(url, "\"")
                url = stripText("http://www.discogs.com" + url[0:i])

                http = HTTPConnection()
                http.resetReferer();
                http.setGenericUserAgent()
                http.blockForLoad();
                images = http.getContents(url)
                t2 = open(aw.getLogsDir() + "trace2.html", "w")
                t2.write(images)
                t2.close()

                i = string.find(images, "id=\"page\"")

                if i != -1:
                    image = searchForPlus(images, "id=\"page\"")
                    image = searchForPlus(image, " src=\"")
                    i = string.find(image, "\"")
                    image = stripText(image[0:i])
                    aw.setRefLargeImage1(image, "http://www.discogs.com/")


    # Find Artist
    i = string.find(source, "\"/artist/")

    if i != -1:
        source = searchForPlus(source, "\"/artist/")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        artist = stripText(source[0:i])
        aw.setArtist(artist)


    # Find Title
    source = searchForPlus(source, "&ndash;")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])
    aw.setTitle(title)


    # Find UPC
    i = string.find(source, "Barcode and Other Identifiers")

    if i != -1:
        numbers = searchForPlus(source, "Barcode and Other Identifiers")
        i = string.find(numbers, "</ul>")
        numbers = stripText(numbers[0:i])

        while (searchFor(numbers, "<li>") != None):
            numbers = searchForPlus(numbers, "<li>")
            i = string.find(numbers, "</li>")
            number = stripText(numbers[0:i])

            i = string.find(number, "Barcode")

            if i == -1:
                continue

            i = string.find(number, ": ")
            number = stripText(number[i+1:])
            i = string.find(number, "<")

            if i != -1:
                number = stripText(number[0:i])

            number = string.replace(number, " ", "")
            number = string.replace(number, "-", "")
            numberl = len(number)

            if numberl < 12 or numberl > 13:
                continue

            aw.setUPC(number)
            break

        

    # Find Label
    i = string.find(source, ">Label:")

    if i != -1:
        label = searchForPlus(source, ">Label:")
        label = searchForPlus(label, "class=\"content\"")
        label = searchForPlus(label, "\">")
        i = string.find(label, "<")
        label = stripText(label[0:i])
        aw.setLabel(label)


    # Find Catalog Number
    i = string.find(source, ">Label:")

    if i != -1:
        label = searchForPlus(source, ">Label:")
        label = searchForPlus(label, "&lrm;&ndash;")
        i = string.find(label, "<")
        label = stripText(label[0:i])
        aw.setCatalogNumber(label)


    # Find Format
    i = string.find(source, ">Format:<")

    if i != -1:
        format = searchForPlus(source, ">Format:<")
        format = searchForPlus(format, "class=\"content\"")
        format = searchForPlus(format, "<a href=\"")
        format = searchForPlus(format, "\">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        aw.setFormat(format)


    # Find Date
    tag = ">Year:"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Released:"
        i = string.find(source, tag)

    if i != -1:
        date = searchForPlus(source, tag)
        date = searchForPlus(date, "class=\"content\"")
        date = searchForPlus(date, ">")
        date = stripText(date[0:i])

        if date.startswith("<a ") == 1:
            date = searchForPlus(date, ">")

        i = string.find(date, "<")
        date = stripText(date[0:i])

        aw.setReleaseDate(date)


    # Find Category
    i = string.find(source, ">Genre:<")

    if i != -1:
        categories = searchForPlus(source, ">Genre:<")
        categories = searchForPlus(categories, "class=\"content\"")
        categories = searchForPlus(categories, ">")
        i = string.find(categories, "</div>")
        categories = stripText(categories[0:i])

        ccount = 1

        while (searchFor(categories, "href=\"") != None):
            categories = searchForPlus(categories, "href=\"")
            categories = searchForPlus(categories, "\">")
            i = string.find(categories, "<")
            category = stripText(categories[0:i])

            if ccount == 1:
                aw.setCategory1(category)
            elif ccount == 2:
                aw.setCategory2(category)
            else:
                aw.setCategory3(category)
                break

            ccount = ccount + 1


    # Find Keywords
    keywordList = ""
    i = string.find(source, ">Style:<")

    if i != -1:
        keywords = searchForPlus(source, ">Style:<")
        keywords = searchForPlus(keywords, "class=\"content\"")
        keywords = searchForPlus(keywords, ">")
        i = string.find(keywords, "</div>")
        keywords = stripText(keywords[0:i])

        ccount = 1

        while (searchFor(keywords, "href=\"") != None):
            keywords = searchForPlus(keywords, "href=\"")
            keywords = searchForPlus(keywords, "\">")
            i = string.find(keywords, "<")
            keyword = stripText(keywords[0:i])

            if ccount == 1:
                keywordList = keyword
            else:
                keywordList = keywordList + ", " + keyword

            ccount = ccount + 1

        aw.setKeywords(keywordList)


    # Find Format keywords
    i = string.find(source, ">Format:<")

    if i != -1:
        format = searchForPlus(source, ">Format:<")
        format = searchForPlus(format, "class=\"content\"")
        format = searchForPlus(format, ">")
        i = string.find(format, "<br />")
        format = stripText(format[0:i])

        if keywordList == "":
            keywordList = format
        else:
            keywordList = keywordList + ", " + format

        aw.setKeywords(keywordList)


    # Find Comments
    comments = ""
    i = string.find(source, "data-for=\".notes\"")

    if i != -1:
        comments = searchForPlus(source, "data-for=\".notes\"")
        comments = searchForPlus(comments, "class=\"section_content toggle_section_content\"")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</div>")
        comments = stripText(comments[0:i])

        i = string.find(comments, "<!--")

        if i != -1:
            comments = stripText(comments[0:i])


    # Find Comments
    i = string.find(source, "data-for=\".credits\"")

    if i != -1:
        comment = searchForPlus(source, "data-for=\".credits\"")
        comment = searchForPlus(comment, "class=\"section_content toggle_section_content\"")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "</div>")
        comment = stripText(comment[0:i])
        comments = appendComment(comments, comment)

    aw.setProductInfo(comments)


    # Find Tracks
    i = string.find(source, "id=\"tracklist\"")

    if i != -1:
        tracks = searchForPlus(source, "id=\"tracklist\"")
        i = string.find(tracks, "</table>")
        tracks = stripText(tracks[0:i])

        trackList = []
        artistList = []
        timeList = []
        diskNumber = 0
        trackNumber = 0
        trackCount = 0
        discogsFound = "";

        while (searchFor(tracks, "<tr class=") != None):
            tracks = searchForPlus(tracks, "<tr class=")
            i = string.find(tracks, "</tr>")
            track = stripText(tracks[0:i])

            i = string.find(track, "class=\"tracklist_track_pos\"")

            if i != -1:
                position = searchForPlus(track, "class=\"tracklist_track_pos\"")
                position = searchForPlus(position, ">")
                i = string.find(position, "<")
                position = stripText(position[0:i])
                position = string.replace(position, "CD-", "1-")
                position = string.replace(position, "DVD-", "2-")

                if position == "":
                    # Not really a track, classical albums often have non track data.
                    continue

            artist = ""

            i = string.find(track, "class=\"tracklist_track_artists\">")
                
            if i != -1:
                track = stripText(searchForPlus(track, "class=\"tracklist_track_artists\">"))
                i = string.find(track, "</td>")
                artists = stripText(track[0:i])

                while (searchFor(artists, "href=") != None):
                    artists = searchForPlus(artists, "href=")
                    artists = searchForPlus(artists, "\">")
                    i = string.find(artists, "<")

                    if artist == "":
                        artist = stripText(artists[0:i])
                    else:
                        artist = artist + ", " + stripText(artists[0:i])

            track = searchForPlus(track, "class=\"tracklist_track_title\"")
            track = searchForPlus(track, ">")
            i = string.find(track, "<")
            title = stripText(track[0:i])
            trackCount = trackCount + 1

            writer = ""
            saveTrack = track

            tag = "Written By"
            i = string.find(track, tag)

            if i == -1:
                tag = "Written-By"
                i = string.find(track, tag)
                
            if i != -1:
                track = searchForPlus(track, tag)
                i = string.find(track, "</td>")
                writers = stripText(track[0:i])

                while (searchFor(writers, "<a href=") != None):
                    writers = searchForPlus(writers, "<a href=")
                    writers = searchForPlus(writers, "\">")
                    i = string.find(writers, "<")

                    if writer == "":
                        writer = stripText(writers[0:i])
                    else:
                        writer = writer + " / " + stripText(writers[0:i])

                track = saveTrack

                i = string.find(track, "Written By &ndash;")
                
                if i != -1:
                    track = searchFor(track, "Written By &ndash;")
                    i = string.find(track, "</td>")
                    writers = stripText(track[0:i])

                    while (searchFor(writers, "Written By &ndash;") != None):
                        writers = searchForPlus(writers, "Written By &ndash;")
                        i = string.find(writers, "<")

                        if writer == "":
                            writer = stripText(writers[0:i])
                        else:
                            writer = writer + " / " + stripText(writers[0:i])
            else:
                i = string.find(track, "Words By")
                
                if i != -1:
                    track = searchForPlus(track, "Words By")
                    i = string.find(track, "</td>")
                    writers = stripText(track[0:i])

                    while (searchFor(writers, "<a href=") != None):
                        writers = searchForPlus(writers, "<a href=")
                        writers = searchForPlus(writers, "\">")
                        i = string.find(writers, "<")

                        if writer == "":
                            writer = stripText(writers[0:i])
                        else:
                            writer = writer + " / " + stripText(writers[0:i])


            composer = ""
            tag = "Composed By"
            i = string.find(track, tag)

            if i != -1:
                composer = searchForPlus(track, tag)
                composer = searchForPlus(composer, "<a href=")
                composer = searchForPlus(composer, "\">")
                i = string.find(composer, "<")
                composer = stripText(composer[0:i])


            time = ""

            i = string.find(track, "class=\"tracklist_track_duration\"")
                
            if i != -1:
                track = searchForPlus(track, "class=\"tracklist_track_duration\"")
                track = searchForPlus(track, "<span>")
                i = string.find(track, "<")
                time = stripText(track[0:i])

            discogs = "";
            i = string.find(position, ".")
            j = string.find(position, "-")

            if i != -1 and j != -1: 
                # Has position of 1-11.1, 1-11.2 etc. drop the last part
                position = stripText(position[0:i])

            i = string.find(position, ".")
            
            if i != -1:
                diskNumber = int(stripText(position[0:i]))
                trackNumber = int(stripText(position[i+1:]))
            else:
                i = string.find(position, "-")
            
                if i != -1:
                    diskNumber = int(stripText(position[0:i]))
                    trackNumber = int(stripText(position[i+1:]))
                else:
                    diskNumber = int(1)

                    try:
                        trackNumber = int(position)
                    except:
                        trackNumber = trackCount
                        discogs = position
                        discogsFound = discogs

            aw.setTrack(diskNumber, trackNumber, title, time=time, artist=artist, songwriter=writer, composer=composer, discogs=discogsFound)



try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
