# This Python file uses the following encoding: iso-8859-1
# Discogs music scraper
#
# Copyright  1999-2018 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):


    i = string.find(source, "\"resource_url\":")

    if i != -1:
        discogsID =searchForPlus(source, "\"id\": ")
        i = string.find(discogsID, "}")
        discogsID = stripText(discogsID[0:i])
        i = string.find(discogsID, ",")

        if i != -1:
            discogsID = stripText(discogsID[0:i])

        source = searchForPlus(source, "\"resource_url\":")
        source = searchForPlus(source, "\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url, "UTF-8")
        t2 = open(aw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()
    else:
        return


    # Main Extraction
    aw.setExternalID(discogsID)


    # Find Title
    #
    # Discogs cam embed videos which use the same title tag, so skip ober embeds
    # (602547650825)
    #    
    intro = source

    while (string.find(intro, "\"embed\": true") != -1):
        intro = searchForPlus(intro, "\"embed\": true")
        intro = searchForPlus(intro, "}")

    #
    # Had a situation where the album title appeared after all the track titles.
    # We picked up the first track title as the album title. (011105065924)
    # If we have items for sale, that tag appears with the album title
    #    
    if string.find(intro, "\"num_for_sale\":") != -1:
        intro = searchForPlus(intro, "\"num_for_sale\":")

    title = searchForPlus(intro, "\"title\": ")
    title = searchForPlus(title, "\"")
    i = string.find(title, "\",")
    title = stripText(title[0:i])
    title = getQuotedData(title)
    aw.setTitle(title)

    i = string.find(source, "\"thumb\": ")

    if i != -1:
        title = searchForPlus(source, "\"thumb\": ")
        i = string.find(title, "\"title\": ")

        if i != -1:
            title = searchForPlus(title, "\"title\": ")
            title = searchForPlus(title, "\"")
            i = string.find(title, "\",")
            title = stripText(title[0:i])
            title = getQuotedData(title)
            aw.setTitle(title)


    # Find Artist
    artistList = []
    i = string.find(source, "\"artists\": ")

    if i != -1:
        artists = searchForPlus(source, "\"artists\": ")
        artists = searchForPlus(artists, "[{")
        i = string.find(artists, "}]")
        artists = stripText(artists[0:i])

        while (searchFor(artists, "\"name\": ") != None):
            artists = searchForPlus(artists, "\"name\": ")
            artist = searchForPlus(artists, "\"")
            i = string.find(artist, "\",")
            artist = stripText(artist[0:i])
            artist = getQuotedData(artist)
            artist = stripContributor(artist)
                
            if artist != "":
                artistList.append(artist)

        aw.setArtists(artistList)


    # Find Label
    i = string.find(source, "\"labels\": ")

    if i != -1:
        label = searchForPlus(source, "\"labels\": ")
        label = searchForPlus(label, "\"name\": ")
        label = searchForPlus(label, "\"")
        i = string.find(label, "\"")
        label = stripText(label[0:i])
        aw.setLabel(label)


    # Find Catalog Number
    i = string.find(source, "\"catno\": ")

    if i != -1:
        catno = searchForPlus(source, "\"catno\": ")
        catno = searchForPlus(catno, "\"")
        i = string.find(catno, "\"")
        catno = stripText(catno[0:i])
        aw.setCatalogNumber(catno)


    # Find Format
    i = string.find(source, "\"formats\": ")

    if i != -1:
        format = searchForPlus(source, "\"formats\": ")
        format = searchForPlus(format, "\"name\": ")
        format = searchForPlus(format, "\"")
        i = string.find(format, "\"")
        format = stripText(format[0:i])
        aw.setFormat(format)


    # Find Release date
    i = string.find(source, "\"released\": ")

    if i != -1:
        date = searchForPlus(source, "\"released\": ")
        date = searchForPlus(date, "\"")
        i = string.find(date, "\"")
        date = stripText(date[0:i])

        if date.endswith("-00") == 1:
            date = string.replace(date, "-00", "-01")

        aw.setReleaseDate(date)


    # Find Category
    i = string.find(source, "\"genres\": ")

    if i != -1:
        categories = searchForPlus(source, "\"genres\": ")
        categories = searchForPlus(categories, "[")
        i = string.find(categories, "]")
        categories = stripText(categories[0:i])

        ccount = 1

        while (searchFor(categories, "\"") != None):
            categories = searchForPlus(categories, "\"")
            i = string.find(categories, "\"")
            category = stripText(categories[0:i])
            categories = searchForPlus(categories, "\"")

            if ccount == 1:
                aw.setCategory1(category)
            elif ccount == 2:
                aw.setCategory2(category)
            else:
                aw.setCategory3(category)
                break

            ccount = ccount + 1


    # Find small Image
    i = string.find(source, "\"thumb\": ")

    if i != -1:
        image = searchForPlus(source, "\"thumb\": ")
        image = searchForPlus(image, "\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])
        aw.setDiscogsImage1(image)


    # Find large Image
    i = string.find(source, "\"images\": ")

    if i != -1:
        image = searchForPlus(source, "\"images\": ")
        image = searchForPlus(image, "\"uri\": ")
        image = searchForPlus(image, "\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])
        aw.setDiscogsLargeImage1(image)

        if aw.getImage1() == None:
            aw.setDiscogsImage1(image)


    # Find Keywords
    keywordList = ""
    i = string.find(source, "\"styles\": ")

    if i != -1:
        keywords = searchForPlus(source, "\"styles\": ")
        keywords = searchForPlus(keywords, "[")
        i = string.find(keywords, "]")
        keywords = stripText(keywords[0:i])
        keywords = string.replace(keywords, "\"", "")
        keywordList = keywords
        aw.setKeywords(keywordList)


    # Find Format keywords
    i = string.find(source, "\"formats\": ")

    if i != -1:
        format = searchForPlus(source, "\"formats\": ")

        i = string.find(format, "\"descriptions\": ")

        if i != -1:
            format = searchForPlus(format, "\"descriptions\": ")
            format = searchForPlus(format, "[")
            i = string.find(format, "]")
            format = stripText(format[0:i])
            format = string.replace(format, "\"", "")

            if keywordList == "":
                keywordList = format
            else:
                keywordList = keywordList + ", " + format

            aw.setKeywords(keywordList)


    # Find Comments
    comments = ""
    i = string.find(source, "\"notes\": ")

    if i != -1:
        comments = searchForPlus(source, "\"notes\": ")
        comments = searchForPlus(comments, "\"")
        i = string.find(comments, "\"")
        comments = stripText(comments[0:i])


    # Find Comments
    i = string.find(source, "\"extraartists\": ")

    if i != -1:
        allcredits = ""
        credits = searchForPlus(source, "\"extraartists\": ")
        credits = searchForPlus(credits, "[")
        i = string.find(credits, "]")
        credits = stripText(credits[0:i])

        while (searchFor(credits, "\"name\": ") != None):
            credits = searchForPlus(credits, "\"name\": ")
            credits = searchForPlus(credits, "\"")
            i = string.find(credits, "\"")
            credit = stripText(credits[0:i])
            credits = searchForPlus(credits, "\"role\": ")
            credits = searchForPlus(credits, "\"")
            i = string.find(credits, "\"")
            credit = credit + " (" + stripText(credits[0:i]) + ")<br>"
            allcredits = allcredits + credit

        comments = appendComment(comments, allcredits)

    aw.setProductInfo(comments)


    # Find Tracks
    i = string.find(source, "\"tracklist\": ")

    if i != -1:
        tracks = searchForPlus(source, "\"tracklist\": ")

        trackList = []
        artistList = []
        timeList = []
        diskNumber = 0
        trackNumber = 0
        trackCount = 0
        discogsFound = "";

        while (searchFor(tracks, "{\"") != None):
            #
            # Within the basic delimiters, look for a type of track
            # and skip all other types
            tracks = searchFor(tracks, "{\"")
            i = string.find(tracks, "\"title\": ")
            j = string.find(tracks[i:], "}, ")
            k = string.find(tracks[i:], "}], ")

            if k < j:
                j = k;

            if j == -1:
                tracks = "End of tracks"
                continue

            i = i + j

            if i != -1:
                track = stripText(tracks[0:i+3])
                tracks = stripText(tracks[i+1:])

                if string.find(track, "\"type_\": \"track\",") == -1:
                    continue

                i = string.find(track, "[")
                    
                if i != -1:
                    if track[i:].startswith("[{\"join\":") == 0:
                        track = stripText(track[i+1:])

                track = getQuotedData(track)
                print "Track=",track
            else:
                track = tracks
                tracks = "end of tracks"

            i = string.find(track, "\"duration\": ")

            if i != -1:
                duration = searchForPlus(track, "duration\": ")
                duration = searchForPlus(duration, "\"")
                i = string.find(duration, "\"")
                duration = stripText(duration[0:i])
            else:
                continue

            i = string.find(track, "\"position\": ")

            if i != -1:
                position = searchForPlus(track, "\"position\": ")
                position = searchForPlus(position, "\"")
                i = string.find(position, "\"")
                position = stripText(position[0:i])

            trackCount = trackCount + 1

            i = string.find(track, "\"title\": ")

            if i != -1:
                title = track[i:]
                title = searchForPlus(title, "\"title\": ")
                title = searchForPlus(title, "\"")
                i = string.find(title, "\"}")
                title = stripText(title[0:i])

                i = string.find(title, "\", \"duration\":")
                    
                if i != -1:
                    title = stripText(title[0:i])

            artist = ""

            i = string.find(track, "\"artists\": ")

            if i != -1:
                artist = searchForPlus(track, "\"artists\": ")
                artist = searchForPlus(artist, "\"name\": ")
                artist = searchForPlus(artist, "\"")
                i = string.find(artist, "\"")
                artist = stripText(artist[0:i])
                artist = stripContributor(artist)

            discogs = "";
            writer = ""

            while (searchFor(track, "{\"join\"") != None):
                track = searchForPlus(track, "{\"join\"")
                i = string.find(track, "}")
                join = stripText(track[0:i])
                i = string.find(join, "\"role\": \"Written-By\"")
                
                if i == -1:
                    continue

                join = searchForPlus(join, "\"name\": ")
                join = searchForPlus(join, "\"")
                i = string.find(join, "\"")
                join = stripText(join[0:i])
                join = stripContributor(join)

                if writer == "":
                    writer = join
                else:
                    writer = writer + " / " + join

            i = string.find(position, ".")
            
            if i != -1:
                diskNumber = int(stripText(position[0:i]))
                trackNumber = int(stripText(position[i+1:]))
            else:
                i = string.find(position, "-")
            
                if i != -1:
                    diskNumber = int(stripText(position[0:i]))
                    trackNumber = int(stripText(position[i+1:]))
                else:
                    diskNumber = int(1)

                    try:
                        trackNumber = int(position)
                    except:
                        trackNumber = trackCount
                        discogs = position
                        discogsFound = discogs

            print "P=",position,"D=",diskNumber,"T=",trackNumber,"TITLE=",title
            aw.setTrack(diskNumber, trackNumber, title, time=duration, artist=artist, songwriter=writer, discogs=discogsFound)



def getQuotedData(data):
    i = string.find(data, "\"")

    if i == -1:
        return data

    while string.find(data, "\\\"") != -1:
        data = string.replace(data, "\\\"", "Readerware")

    
    data = string.replace(data, "Readerware", "\"")

    return data



def stripContributor(contributor):
    if contributor[len(contributor)-3:].startswith("(") == 1:
        contributor = contributor[0:len(contributor)-3:]
        contributor = stripText(contributor)

    return contributor

try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
