# This Python file uses the following encoding: iso-8859-1
# LOC [2] music scrpaer
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import appendComment
from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    aw.setCurrencySymbol("$")
    aw.setFormat("LP")
    aw.setSound("Stereo")


    # Main extraction
    # Determine page format
    i = string.find(source, "view1a.gif")

    if (i != -1):
        source = searchForPlus(source, "view2.gif")
        source = searchForPlus(source, "<A HREF=\"")
        i = string.find(source, "\"")
        url = "http://catalog.loc.gov" + stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(aw.getLogsDir() + "trace.html", "w")
        t2.write(source)
        t2.close()


    # Find LCCN
    i = string.find(source, ">LC control no.:")
    
    if i != -1:
        lccn = searchForPlus(source, ">LC control no.:")
        lccn = searchForPlus(lccn, "<TD ")
        lccn = searchForPlus(lccn, ">")
        i = string.find(lccn, "</TD>")
        lccn = stripText(lccn[0:i])
        aw.setLCCN(lccn)


    # Find Artist
    artistTag = ">Personal name:"
    i = string.find(source, artistTag)

    if i == -1:
        artistTag = ">Related names:<"
        i = string.find(source, artistTag)

    if i != -1:
        artist = searchForPlus(source, artistTag)
        artist = searchForPlus(artist, "<TD ")
        artist = searchForPlus(artist, ">")
        i = string.find(artist, "</TD>")
        artist = stripText(artist[0:i])
        i = string.find(artist, "<A HREF=")

        if i != -1:
            artist = searchForPlus(artist, "\">")
            i = string.find(artist, "</A>")
            artist = stripText(artist[0:i])

        i = string.find(artist, " prf")

        if i != -1:
            artist = stripText(artist[0:i])

        i = string.find(artist, " [")

        if i != -1:
            artist = stripText(artist[0:i])

        # Remove dates, if present
        if (string.count(artist, ",") > 1):
            i = string.find(artist, ",")
            i = string.find(artist, ",", i+1)
            artist = artist[0:i]

        aw.setArtist(artist)


    # Find Title
    i = string.find(source, ">Main title:<")

    if i != -1:
        title = searchForPlus(source, ">Main title:<")
        title = searchForPlus(title, "<TD ")
        title = searchForPlus(title, ">")
        i = string.find(title, "</TD>")
        title = stripText(title[0:i])

        i = string.find(title, " [")

        if i != -1:
            title = stripText(title[0:i])

        aw.setTitle(title)


    # Find Label/Date
    i = string.find(source, ">Published/Created:<")

    if i != -1:
        label = searchForPlus(source, ">Published/Created:<")
        label = searchForPlus(label, "<TD ")
        label = searchForPlus(label, ">")
        i = string.find(label, "</TD>")
        label = stripText(label[0:i])

        i = string.find(label, " : ")

        if i != -1:
            label = searchForPlus(label, " : ")

        i = string.find(label, ", ")

        if i != -1:
            date = stripText(label[i+1:])
            label = stripText(label[0:i])

            i = string.find(date, "p")    

            if i != -1:
                date = stripText(date[i+1:])

            i = string.find(date, ".")    

            if i != -1:
                date = stripText(date[0:i])

            aw.setReleaseDate(date)
            aw.setCopyrightDate(date)
            
        aw.setLabel(label)


    # Find UPC
    i = string.find(source, ">UPC/EAN:<")

    if i != -1:
        upc = searchForPlus(source, ">UPC/EAN:<")
        upc = searchForPlus(upc, "<TD ")
        upc = searchForPlus(upc, ">")
        i = string.find(upc, "</TD>")
        upc = stripText(upc[0:i])
        aw.setUPC(upc)


    # Find Comments
    comments = ""
    i = string.find(source, ">Publisher no.:<")

    if i != -1:
        comment = searchForPlus(source, ">Publisher no.:<")
        comment = searchForPlus(comment, "\">")
        i = string.find(comment, "<")
        comment = stripText(comment[0:i])
        aw.setCatalogNumber(comment)
        comments = appendComment(comments, "Publisher no.: " + comment)

    i = string.find(source, ">Notes:<")

    if i != -1:
        comment = searchForPlus(source, ">Notes:<")
        comment = searchForPlus(comment, ">")
        comment = searchForPlus(comment, "<TD ")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "</TD>")
        comment = stripText(comment[0:i])
        comments = appendComment(comments, comment)

    i = string.find(source, ">Cast:<")

    if i != -1:
        comment = searchForPlus(source, ">Cast:<")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "<TH ")
        comment = stripText(comment[0:i])
        comments = appendComment(comments, "Cast:<br>" + comment)

    aw.setProductInfo(comments)


    # Find Tracks
    i = string.find(source, ">Contents:<")

    if i != -1:
        source = searchForPlus(source, ">Contents:<")
        source = searchForPlus(source, "<TD ")
        source = searchForPlus(source, ">")
        i = string.find(source, "</TD>")
        disks = stripText(source[0:i])

        if string.find(disks, ">Disc: ") == -1:
            disks = ">Disc: 1<" + disks

        diskCount = 0

        while (searchFor(disks, ">Disc: ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disc: ")
            i = string.find(disks, "<")
            diskid = "%02d" % int(stripText(disks[0:i]))

            tracks = stripText(disks[i+1:]) + "--"
            trackCount = 0

            while (searchFor(tracks, "--") != None):
                trackCount = trackCount + 1
                i = string.find(tracks, "--")
                track = stripText(tracks[0:i])

                aw.setTrack(diskCount, trackCount, track)
                tracks = searchForPlus(tracks, "--")


    # Find Category
    i = string.find(source, ">Subjects:<")

    if i != -1:
        category = searchForPlus(source, ">Subjects:<")
        category = searchForPlus(category, "<TD ")
        category = searchForPlus(category, ">")
        i = string.find(category, "</TD>")
        category = category[0:i]
        i = string.find(category, "<A HREF=")

        if i != -1:
            category = searchForPlus(category, "\">")
            i = string.find(category, "<")
            category = stripText(category[0:i])

        aw.setCategory1(category)


    # Find Call Number
    i = string.find(source, ">CALL NUMBER:<")

    if i != -1:
        num = searchForPlus(source, ">CALL NUMBER:<")
        num = searchForPlus(num, "<TD ")
        num = searchForPlus(num, ">")
        i = string.find(num, "</TD>")
        num = num[0:i]
        i = string.find(num, "<A HREF=")

        if i != -1:
            num = searchForPlus(num, "\">")
            i = string.find(num, "<")
            num = stripText(num[0:i])

        aw.setCallNumber(num)





try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
