# -*- coding: iso-8859-15 -*-
# MusicBrainz scraper
#
# Copyright  1999-2020 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import convertArtist
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    aw.setCurrencySymbol("$")

    # Find Image
    i = string.find(source, "\"image\"")

    if i != -1:
        image = searchForPlus(source, "\"image\"")
        image = searchForPlus(image, "\"contentUrl\"")
        image = searchForPlus(image, "\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])
        aw.setRefImage1("https:" + image, "https://musicbrainz.org")
        aw.setRefLargeImage1("https:" + image, "https://musicbrainz.org")
    else:
        i = string.find(source, "class=\"cover-art\"")

        if i != -1:
            image = searchForPlus(source, "class=\"cover-art\"")
            image = searchForPlus(image, "src=\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])
            aw.setRefImage1(image, "https://musicbrainz.org")
            aw.setRefLargeImage1(image, "https://musicbrainz.org")


    # Find Title
    title = searchForPlus(source, "href=\"/release/")
    title = searchForPlus(title, "<bdi>")
    i = string.find(title, "<")
    title = stripText(title[0:i])
    aw.setTitle(title)


    # Find Artist
    i = string.find(source, "href=\"/artist/")

    if i != -1:
        artist = searchForPlus(source, "href=\"/artist/")
        artist = searchForPlus(artist, "<bdi>")
        i = string.find(artist, "<")
        artist = stripText(artist[0:i])
        artist = convertArtist(artist)
    else:
        artist = "Various Artists"

    aw.setArtist(artist)


    # Find UPC
    i = string.find(source, "class=\"barcode\"")

    if i != -1:
        upc = searchForPlus(source, "class=\"barcode\"")
        upc = searchForPlus(upc, ">")
        i = string.find(upc, "<")
        upc = stripText(upc[0:i])
        aw.setUPC(upc)


    # Find Format
    i = string.find(source, "class=\"format\"")

    if i != -1:
        format = searchForPlus(source, "class=\"format\"")
        format = searchForPlus(format, ">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        aw.setFormat(format);


    # Find release date
    i = string.find(source, "class=\"release-events\"")

    if i != -1:
        date = searchForPlus(source, "class=\"release-events\"")
        date = searchForPlus(date, "class=\"release-date\"")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        aw.setReleaseDate(stripText(date[0:i]))


    # Find Label
    i = string.find(source, ">Labels<")

    if i != -1:
        label = searchForPlus(source, ">Labels<")
        label = searchForPlus(label, "<li>")
        label = searchForPlus(label, "<bdi>")
        i = string.find(label, "<")
        label = stripText(label[0:i])
        aw.setLabel(label)


    # Find Catalog Number
    i = string.find(source, "class=\"catalog-number\"")

    if i != -1:
        num = searchForPlus(source, "class=\"catalog-number\"")
        num = searchForPlus(num, ">")
        i = string.find(num, "<")
        num = stripText(num[0:i])
        aw.setCatalogNumber(num)


    # Find Tracks
    i = string.find(source, "class=\"tracklist\"")
    diskCount = 0

    if i != -1:
        disks = searchForPlus(source, "class=\"tracklist\"")
        disks = searchForPlus(disks, "<tbody>")
        i = string.find(disks, "</tbody>")
        disks = stripText(disks[0:i])

        if string.find(disks, ">Disc") == -1:
            disks = ">Disc 1<" + disks

        while (searchFor(disks, ">Disc") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disc")
            i = string.find(disks, "<")
            diskid = "%02d" % int(stripText(disks[0:i]))
            trackNum = 0

            tracks = stripText(disks)

            while (searchFor(tracks, "class=\"pos t\"") != None):
                trackNum = trackNum + 1
                tracks = searchForPlus(tracks, "class=\"pos t\"")
                tracks = stripText(searchForPlus(tracks, "<bdi>"))

                i = string.find(tracks, "<")
                title = stripText(tracks[0:i])

                artist = ""
                i = string.find(tracks, "&nbsp;- ")

                if i != -1 and i <= 100:
                    tracks = searchForPlus(tracks, "&nbsp;- ")
                    i = string.find(tracks, "<")
                    artist = stripText(tracks[0:i])
                else:
                    i = string.find(tracks, "> / ")

                    if i != -1 and i <= 100:
                        artist = searchForPlus(tracks, "> / ")
                        i = string.find(artist, "<")
                        artist = stripText(artist[0:i])

                        i = string.find(artist, ":")

                        if i != -1:
                            i = string.rfind(artist, " ")
                            artist = stripText(artist[0:i])

                time = ""
                i = string.find(tracks, "class=\"treleases\"")

                if i != -1:
                    time = searchForPlus(tracks, "class=\"treleases\"")
                    time = searchForPlus(time, ">")
                    i = string.find(time, "<")
                    time = stripText(time[0:i])

                songwriter = ""
                i = string.find(tracks, ">lyricist and composer:<")

                if i != -1:
                    songwriter = searchForPlus(tracks, ">lyricist and composer:<")
                    songwriter = searchForPlus(songwriter, "<bdi>")
                    i = string.find(songwriter, "<")
                    songwriter = stripText(songwriter[0:i])

                aw.setTrack(diskCount, trackNum, title, time=time, songwriter=songwriter)


    # Find Comments
    comments = ""

    i = string.rfind(source, ">Overview</h2>")

    if i != -1:
        comment = searchForPlus(source, ">Overview</h2>")
        comment = searchForPlus(comment, "\">")
        i = string.find(comment, "<div ")
        comment = stripText(comment[0:i])

        comments = appendComment(comments, comment)


    i = string.rfind(source, "<h2>Editorial Reviews")

    if i != -1:
        comment = searchFor(source, "<h2>Editorial Reviews")
        i = string.find(comment, "</section>")
        comment = stripText(comment[0:i])

        i = string.find(comment, "<aside")

        if i != -1:
            comment = stripText(comment[0:i])

        i = string.find(comment, "<p class=\"read-more fade\">")

        if i != -1:
            comment = stripText(comment[0:i])

        comments = appendComment(comments, comment)

    comments = string.replace(comments, "<article>", "")
    comments = string.replace(comments, "</article>", "<br><br>")

    if comments != "":
        aw.setProductInfo(comments)


    # Find Rating
    i = string.find(source, "section_updateRating")

    if i != -1:
        rating = stripText(source[i-15:])
        rating = searchForPlus(rating, "=\"")
        i = string.find(rating, " ")
        rating = stripText(rating[0:i])
        rating = searchForPlus(rating, "avg-")

        if rating.endswith("h") == 1:
            rating = stripText(rating[0:len(rating)-1]) + ".5"

        aw.setMyRating(rating)


try:
    aw.setAlbumObject(Album)
    extract(source)

finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
