# This Python file uses the following encoding: iso-8859-1
# Amazon US, UK, CA  book scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string
import  time

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setDefaultPublicationPlace("US")
    rw.setDefaultLanguage("English")
    cSymbol = "$"

    store = rw.getSource()

    i = string.find(store, "[UK]")

    if i != -1:
        rw.setPublicationPlace("UK")

    i = string.find(store, "[CA]")

    if i != -1:
        rw.setPublicationPlace("Canada")

    if string.find(source, "\243") != -1:
        cSymbol = "\243"

    rw.setCurrencySymbol(cSymbol)


    tag = "class=\"a-size-mini a-spacing-none a-color-base s-line-clamp-2\""

    if string.find(source, tag) == -1:
        tag = "class=\"listView\""

    if string.find(source, tag) == -1:
        tag = "class=\"resultCount\""

    if string.find(source, tag) == -1:
        tag = "class=resultCount"

    if string.find(source, tag) == -1:
        tag = "id=\"result_0\""

    if string.find(source, tag) == -1:
        tag = "class=\"s-result-list sg-row\""

    i = string.find(source, tag)

    if i != -1:
        # Amazon search results page, follow link
        source = searchForPlus(source, tag)
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        url = string.replace(url, "&#x2F;", "/")
        http = HTTPConnection()
        
        try:
            http.setGenericUserAgent()
        except:
            print "Unable to set UA"

        http.blockForLoad();
        source = http.getContents(url)
        c = 0

        while (string.find(source, "HTTP response code: 503") != -1):
            print "Sleeping",c,"..."
            time.sleep(5)
            source = http.getContents(url)

            c = c + 1

            if c > 3:
                break
        
        try:
            t = open(rw.getLogsDir() + "trace2.html", "w")
            t.write(source)
            t.close()
        except:
            print "Unable to create trace.html"

    i = string.find(source, "class=\"sans\"> Customers who viewed this item...")

    if i != -1:
        # Sometimes Amazon returns the multiple item referral page.
        # Get detail page.
        i = string.find(source, ">Read More<")
        source = stripText(source[i-200:])
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        source = stripText(source[0:i])
        http = HTTPConnection()
        http.blockForLoad();
        source = http.getContents(source)
        try:
            t = open(rw.getLogsDir() + "trace.html", "w")
            t.write(source)
            t.close()
        except:
            print "Unable to create trace.html"

    # If Amazon lists other editions, remove them.
    # complicates price extraction
    i = string.find(source, ">Other Editions")

    if i != -1:
        j = string.find(source[i:], "</table")
        source = source[0:i+1] + source[i+j:]

    i = string.find(source, "class=\"otherEditions\"")

    if i != -1:
        j = string.find(source[i:], "</table")
        source = source[0:i+1] + source[i+j:]


    # Out of print
    i = string.find(source, "<span class=\"availRed\">Out of Print--Limited Availability.</span>")

    if i != -1:
        rw.setOutOfPrint("true")


    # First try at used pricing
    if rw.getUsedPrice() == "$0.00":
        i = string.find(source, ">Listings start at")

        if i != -1:
            used = searchForPlus(source, ">Listings start at")
            used = searchForPlus(used, cSymbol)
            i = string.find(used, "<")
            rw.setUsedPrice(used[0:i])
            rw.setNewPrice(used[0:i])


    # Find Image
    image = ""
    i = string.find(source, "registerImage(\"original_image\"")

    if i != -1:
        images = searchForPlus(source, "registerImage(\"original_image\"")
        images = searchForPlus(images, "\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "no-image")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                image = stripText(image[0:i] + image[i+j+1:])

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                rw.setImage1(image)
            else:
                rw.setImage1(image)


    # Find Image
    tag = "id=\"main_image_0\""

    i = string.find(source, tag)

    if i == -1:
        tag = "id=\"main-image-nonjs\""
        i = string.find(source, tag)

    if i != -1:
        images = searchForPlus(source, tag)
        images = searchForPlus(images, "src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "no-image")

        if i == -1:
            i = string.find(image, "/loadIndicators/")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                k = string.find(image[i+j:], "_")

                if k != -1:
                    j = j + (k - 1)

                imagex = stripText(image[0:i] + image[i+j+1:])

                if string.find(imagex, "_SY") == -1 & string.find(imagex, "_AA") == -1:
                    imagex = stripText(image[0:i] + "_SY300" + image[i+j+1:])

                image = imagex
                

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                rw.setImage1(image)

            tag = "_SY300_"
            i = string.find(image, tag)

            if i == -1:
                tag = "_SX225_"
                i = string.find(image, tag)

            if i != -1:
                large = string.replace(image, tag, "_SY500_")
                rw.setLargeImage1(large)
                rw.setImage1(image)
            else:
                rw.setImage1(image)

    if rw.getLargeImage1() == None:
        i = string.find(source, "class=\"quorus-product-photo\"")

        if i != -1:
            images = stripText(source[i-200:])
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])

            i = string.find(image, "_SL")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)


    # Find Keywords
    i = string.find(source, "name=\"field+keywords\"")

    if i != -1:
        extracted = ""
        keywords = searchFor(source, "name=\"field+keywords\"")

        while (searchFor(keywords, "name=\"field+keywords\"") != None):
            keywords = searchForPlus(keywords, "name=\"field+keywords\"")
            keywords = searchForPlus(keywords, "value=\"")
            i = string.find(keywords, "\"")
            keyword = stripText(keywords[0:i])

            if extracted == "":
                extracted = keyword
            else:
                extracted = extracted + ", " + keyword

        rw.setKeywords(extracted)


    # Find value
    i = string.find(source, "class=\"priceLarge\"")

    if i != -1:
        value = searchForPlus(source, "class=\"priceLarge\"")
        value = searchForPlus(value, cSymbol)
        i = string.find(value, "<")
        rw.setItemValue(value[0:i])
        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())

    tt = 1

    if string.find(source, "Fiction") == -1:
        tt = 0


    # Find Title
    source = searchForPlus(source, "\"btAsinTitle\"")
    source = searchForPlus(source, ">")
    source = stripText(source)

    if source.startswith("<span") == 1:
        source = searchForPlus(source, ">")

    i = string.find(source, "<")
    title = stripText(source[0:i])

    if tt == 1:
        i = string.rfind(title, "(")

        if i != -1:
            title = stripText(title[0:i])

    rw.setTitle(title)

    i = string.rfind(source, ">[Kindle Edition]<")

    if i > 0 and i < 250:
        rw.setFormat("Kindle")


    # Find rating
    i = string.find(source, "class=\"crAvgStars\"")

    if i != -1 and i <= 5000:
        rating = searchForPlus(source, "class=\"crAvgStars\"")
        rating = searchForPlus(rating, "title=\"")
        i = string.find(rating, " ")
        rw.setMyRating(rating[0:i])


    # Find Authors
    authorList = []
    tag = "href=\""

    i = string.find(source, tag)

    if i != -1 and i <= 2500:
        source = searchFor(source, tag)
        i = string.find(source, "\n")
        authors = stripText(source[0:i])
        hold = ""

        while (searchFor(authors, tag) != None):
            authors = searchForPlus(authors, tag)
            authors = searchForPlus(authors, "\">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])

            if author == "these sellers":
                break

            if author == "Be the first to review this item":
                break

            authors = searchForPlus(authors, "</a>")
            authors = stripText(authors)

            if authors.startswith("<span class=\"byLinePipe\">") == 1:
                authors = searchForPlus(authors, "<span class=\"byLinePipe\">")

            if authors.startswith("(") == 1:
                i = string.find(authors, ")")
                role = stripText(authors[0:i+1])

                if role == "(Illustrator)":
                    rw.setIllustrator(author)
                    author = ""
                elif role == "(Translator)":
                    rw.setTranslator(author)
                    author = ""
                elif role == "(Editor)":
                    rw.setEditor(author)
                    author = ""
                elif role == "(Foreword)":
                    hold = author
                    author = ""
                
            if author != "":
                authorList.append(author)
                
        if hold != "":
            authorList.append(hold)

    rw.setAuthors(authorList)


    # Find List price
    i = string.find(source, "class=\"listprice\"")

    if i != -1:
        value = searchForPlus(source, "class=\"listprice\"")
        value = searchForPlus(value, cSymbol)
        i = string.find(value, "<")
        rw.setListPrice(value[0:i])


    # Find value
    newCopy = 0
    i = string.find(source, "class=\"priceLarge\"")

    if i != -1:
        value = searchForPlus(source, "class=\"priceLarge\"")
        value = searchForPlus(value, cSymbol)
        i = string.find(value, "<")
        rw.setItemValue(value[0:i])
        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())
        newCopy = 1


    # Find new price/count
    i = string.find(source, "&condition=new")

    if i != -1:
        new = searchForPlus(source, "&condition=new")
        new = searchForPlus(new, ">")
        i = string.find(new, "&")
        rw.setNewCount(new[0:i])

        new = searchForPlus(new, cSymbol)
        i = string.find(new, "<")
        rw.setNewPrice(new[0:i])


    # Find used price/count
    i = string.find(source, "&condition=used")

    if i != -1:
        used = searchForPlus(source, "&condition=used")
        used = searchForPlus(used, ">")
        i = string.find(used, "&")
        rw.setUsedCount(used[0:i])

        used = searchForPlus(used, cSymbol)
        i = string.find(used, "<")
        rw.setUsedPrice(used[0:i])


    # Find collectible price/count
    i = string.find(source, "&condition=collectible")

    if i != -1:
        col = searchForPlus(source, "&condition=collectible")
        col = searchForPlus(col, ">")
        i = string.find(col, "&")
        rw.setCollectibleCount(col[0:i])

        col = searchForPlus(col, cSymbol)
        i = string.find(col, "<")
        rw.setCollectiblePrice(col[0:i])

    if newCopy == 0:
        rw.setItemValue(rw.getUsedPrice())


    # Find Comments
    comments = ""
    tag = "<h2>Book Description</h2>"

    if string.find(source, tag) != -1:
        comments = "Book Description<BR>"
        reviews = searchForPlus(source, tag)
        reviews = searchForPlus(reviews, "<div id=\"postBodyPS\">")
        i = string.find(reviews, "</div>")
        reviews = stripText(reviews[0:i])
        comments = appendComment(comments, reviews)

    tag = ">Editorial Reviews<"
    header = "Editorial Reviews<BR>"

    if string.find(source, tag) == -1:
        # Amazon UK comments
        tag = ">Product Description<"
        header = ""

    if string.find(source, tag) != -1:
        comments = appendComment(comments, header)
        reviews = searchForPlus(source, tag)
        reviews = searchForPlus(reviews, "\">")
        i = string.find(reviews, "</div>  </div>")
        reviews = stripText(reviews[0:i])

        i = string.find(reviews, "<div class=\"seeAll\">")

        if i != -1:
            reviews = stripText(reviews[0:i])

        while (searchFor(reviews, "class=\"productDescriptionSource\"") != None):
            reviews = searchForPlus(reviews, "class=\"productDescriptionSource\"")
            reviews = searchForPlus(reviews, ">")
            i = string.find(reviews, "</h")
            comment = stripText(reviews[0:i])

            reviews = searchForPlus(reviews, "class=\"productDescriptionWrapper\"")
            reviews = searchForPlus(reviews, ">")
            i = string.find(reviews, "<div class=\"emptyClear\">")
            comment = comment + "<br>" + stripText(reviews[0:i])

            # Added because of a malformed URL, after B6 this is fixed in 
            # the program so this could be deleted.
            i = string.find(comment, "<b>Streaming Video</b>")

            if i != -1:
                comment = stripText(comment[0:i])
            i = string.find(comment, "<strong>Sneak Preview:")

            if i != -1:
                comment = stripText(comment[0:i])

            comments = appendComment(comments, comment)

        comments =  string.replace(comments, "</DIV>", "<BR>")
        comments =  string.replace(comments, "<b >", "<b>")
        comments =  string.replace(comments, "<i >", "<i>")

    rw.setProductInfo(comments)


    # Find Reading level
    i = string.find(source, ">Reading level:<")

    if i != -1:
        rlvl = searchForPlus(source, ">Reading level:<")
        rlvl = searchForPlus(rlvl, ">")
        i = string.find(rlvl, "<")
        rw.setReadingLevel(rlvl[0:i])


    # Find Format/Pages
    i = string.find(source, ">Product Details<")

    if i != -1:
        source = searchForPlus(source, ">Product Details<")

    i = string.find(source, ">Product details<")

    if i != -1:
        source = searchForPlus(source, ">Product details<")

    i = string.find(source, ">Hardcover")

    if i != -1 and i<500:
        rw.setFormat("Hardcover")
        pages = searchForPlus(source, ">Hardcover")
        pages = stripText(searchForPlus(pages, ">"))
        i = string.find(pages, " ")
        rw.setPages(pages[0:i])

    i = string.find(source, ">Paperback")

    if i != -1 and i<500:
        rw.setFormat("Paperback")
        pages = searchForPlus(source, ">Paperback")
        pages = stripText(searchForPlus(pages, ">"))
        i = string.find(pages, " ")
        rw.setPages(pages[0:i])

    i = string.find(source, ">Paperback<")

    if i != -1 and i<500:
        rw.setFormat("Paperback")
        pages = searchForPlus(source, ">Paperback<")
        pages = stripText(searchForPlus(pages, ">"))
        i = string.find(pages, " ")
        rw.setPages(pages[0:i])

    i = string.find(source, ">Mass Market Paperback")

    if i != -1 and i<500:
        rw.setFormat("Mass Market Paperback")
        pages = searchForPlus(source, ">Mass Market Paperback")
        pages = stripText(searchForPlus(pages, ">"))
        i = string.find(pages, " ")
        rw.setPages(pages[0:i])

    i = string.find(source, ">Perfect Paperback")

    if i != -1 and i<500:
        rw.setFormat("Perfect Paperback")
        pages = searchForPlus(source, ">Perfect Paperback")
        pages = stripText(searchForPlus(pages, ">"))
        i = string.find(pages, " ")
        rw.setPages(pages[0:i])

    i = string.find(source, ">Spiral-bound")

    if i != -1 and i<500:
        rw.setFormat("Spiral-bound")
        pages = searchForPlus(source, ">Spiral-bound")
        pages = stripText(searchForPlus(pages, ">"))
        i = string.find(pages, " ")
        rw.setPages(pages[0:i])

    i = string.find(source, ">Leather Bound:")

    if i != -1 and i<500:
        rw.setFormat("Leather Bound")
        pages = searchForPlus(source, ">Leather Bound:")
        pages = stripText(searchForPlus(pages, ">"))
        i = string.find(pages, " ")
        rw.setPages(pages[0:i])

    i = string.find(source, ">Calendar")

    if i != -1 and i<500:
        rw.setFormat("Calendar")
        pages = searchForPlus(source, ">Calendar")
        pages = stripText(searchForPlus(pages, ">"))
        i = string.find(pages, " ")
        rw.setPages(pages[0:i])

    i = string.find(source, "> Kindle Edition<")

    if i != -1 and i<500:
        rw.setFormat("Kindle")
        i = string.find(source, ">Print Length:<")

        if i != -1:
            pages = searchForPlus(source, "> Kindle Edition<")
            pages = searchForPlus(pages, ">Print Length:<")
            pages = stripText(searchForPlus(pages, ">"))
            i = string.find(pages, " ")
            rw.setPages(pages[0:i])

    i = string.find(source, ">Audio CD")

    if i != -1 and i<500:
        rw.setFormat("Audio Book")

    i = string.find(source, ">MP3 CD<")

    if i != -1 and i<500:
        rw.setFormat("Audio Book")

    i = string.find(source, ">Audio Cassette")

    if i != -1 and i<500:
        rw.setFormat("Audio Book")

    i = string.find(source, ">Audio Download")

    if i != -1 and i<500:
        rw.setFormat("Audio Book")

    i = string.find(source, ">CD-ROM")

    if i != -1 and i<500:
        rw.setFormat("CD-ROM")

    i = string.find(source, ">DVD-ROM")

    if i != -1 and i<500:
        rw.setFormat("DVD-ROM")

    i = string.find(source, ">Digital")

    if i != -1 and i<500:
        rw.setFormat("eBook")
        pages = searchForPlus(source, ">Digital")
        pages = stripText(searchForPlus(pages, ">"))
        i = string.find(pages, " ")
        rw.setPages(pages[0:i])

    if rw.getFormat() == "Kindle":
        i = string.find(source, ">Print Length:<")

        if i != -1:
            pages = searchForPlus(source, ">Print Length:<")
            pages = stripText(searchForPlus(pages, ">"))
            i = string.find(pages, " ")
            rw.setPages(pages[0:i])


    # Find Publisher/Date
    i = string.find(source, ">Publisher:<")

    if i != -1:
        publisher = searchForPlus(source, ">Publisher:<")
        publisher = searchForPlus(publisher, ">")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])

        i = string.rfind(publisher, "(")

        if i != -1:
            relDate = stripText(publisher[i+1:])
            publisher = stripText(publisher[0:i])
            
            i = string.rfind(relDate, ")")

            if i != -1:
                relDate = stripText(relDate[0:i])
            
            rw.setReleaseDate(relDate)

        i = string.rfind(publisher, ";")

        if i != -1:
            publisher = stripText(publisher[0:i])

        rw.setPublisher(publisher)


    # Find Language
    i = string.find(source, ">Language:<")

    if i != -1:
        language = searchForPlus(source, ">Language:<")
        language = searchForPlus(language, ">")
        i = string.find(language, "<")
        rw.setLanguage(language[0:i])


    # Find ISBN
    i = string.find(source, ">ISBN-13:<")

    if i != -1:
        isbn = searchForPlus(source, ">ISBN-13:<")
        isbn = searchForPlus(isbn, ">")
        i = string.find(isbn, "<")
        rw.setISBN(isbn[0:i])


    # Find ASIN
    i = string.find(source, ">ASIN:<")

    if i != -1:
        asin = searchForPlus(source, ">ASIN:<")
        asin = searchForPlus(asin, ">")
        i = string.find(asin, "<")
        rw.setASIN(asin[0:i])
    else:
        i = string.find(source, ">ISBN-10:<")

        if i != -1:
            asin = searchForPlus(source, ">ISBN-10:<")
            asin = searchForPlus(asin, ">")
            i = string.find(asin, "<")
            rw.setASIN(asin[0:i])


    # Find Dimensions
    i = string.find(source, "Product Dimensions:")

    if i != -1:
        dimensions = searchForPlus(source, "Product Dimensions:")
        dimensions = searchForPlus(dimensions, ">")
        i = string.find(dimensions, "<")
        rw.setDimensions(dimensions[0:i])


    # Find Dimensions (Kindle file size)
    i = string.find(source, ">File Size:<")

    if i != -1:
        dimensions = searchForPlus(source, ">File Size:<")
        dimensions = searchForPlus(dimensions, ">")
        i = string.find(dimensions, "<")
        rw.setDimensions(dimensions[0:i])


    # Find Weight
    i = string.find(source, ">Shipping Weight:<")

    if i != -1:
        weight = searchForPlus(source, ">Shipping Weight:<")
        weight = searchForPlus(weight, ">")
        i = string.find(weight, "<")
        weight = stripText(weight[0:i])

        i = string.find(weight, "(")

        if i != -1:
            weight = stripText(weight[0:i])

        rw.setWeight(weight)


    # Find Sales Rank
    tag = "Sales Rank:<"

    if string.find(source, tag) == -1:
        tag = " Bestsellers Rank:<"

    if string.find(source, tag) == -1:
        tag = " Best Sellers Rank:"

    i = string.find(source, tag)

    if i != -1:
        rank = searchForPlus(source, tag)
        rank = searchForPlus(rank, ">")
        i = string.find(rank, "<")
        rank = stripText(rank[0:i])

        i = string.find(rank, " ")

        if i != -1:
            rank = stripText(rank[0:i])

        if rank.startswith("#") == 1:
            rank = stripText(rank[1:])

        rw.setSalesRank(rank)


    # Find Category
    tag = "Similar Items by Category<"

    if string.find(source, tag) == -1:
        # Amazon UK
        tag = ">Look for similar items by category<"

    if string.find(source, tag) != -1:
        cats = searchForPlus(source, tag)
        i = string.find(cats, "</ul>")
        cats = stripText(cats[0:i])

        i = string.find(cats, "</li>")

        if i != -1:
            cats = stripText(cats[0:i])

        ccount = 1

        while (searchFor(cats, "href=\"") != None):
            cats = searchForPlus(cats, "href=\"")
            cats = searchForPlus(cats, "\">")
            i = string.find(cats, "<")
            cat = stripText(cats[0:i])

            if cat == "Books":
                continue

            if cat == "Kindle Store":
                continue

            if cat == "Kindle eBooks":
                continue

            if ccount == 1:
                rw.setCategory1(cat)
            elif ccount == 2:
                rw.setCategory2(cat)
            else:
                rw.setCategory3(cat)
                break

            ccount = ccount + 1


try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
