# This Python file uses the following encoding: iso-8859-1
# amazon.fr scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    rw.setCurrencySymbol("[[EUR]]")
    rw.setDefaultPublicationPlace("Spain")
    rw.setDefaultLanguage("[[ES]]")


    i = string.find(source, "id=\"result_0\"")

    if i != -1:
        source = searchForPlus(source, "id=\"result_0\"")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        url = string.replace(url, "&#x2F;", "/")
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(rw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    # Find Image
    tag = "id=\"ebooksImageBlock\""
    i = string.find(source, tag)

    if i == -1:
        tag = "id='imageBlock'"
        i = string.find(source, tag)

    if i == -1:
        tag = "id=\"imageBlock\""
        i = string.find(source, tag)

    if i != -1:
        images = searchForPlus(source, tag)
        images = searchForPlus(images, "src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "data:")

        if i != -1:
            image = ""

        i = string.find(image, "no-img")

        if i == -1:
            i = string.find(image, "/loadIndicators/")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                k = string.find(image[i+j:], "_")

                if k != -1:
                    j = j + (k - 1)

                imagex = stripText(image[0:i] + image[i+j+1:])

                if string.find(imagex, "_SY") == -1 & string.find(imagex, "_AA") == -1:
                    imagex = stripText(image[0:i] + "_SY300" + image[i+j+1:])

                image = imagex
                

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                rw.setImage1(image)

            tag = "_SY300_"
            i = string.find(image, tag)

            if i == -1:
                tag = "_SX225_"
                i = string.find(image, tag)

            if i != -1:
                large = string.replace(image, tag, "_SY500_")
                rw.setLargeImage1(large)
                rw.setImage1(image)
            else:
                rw.setImage1(image)

    if rw.getLargeImage1() == None:
        i = string.find(source, "class=\"quorus-product-photo\"")

        if i != -1:
            images = stripText(source[i-200:])
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])

            i = string.find(image, "_SL")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)

    if rw.getImage1() == None:
        tag = "'imageGalleryData'"
        i = string.find(source, tag)

        if i != -1:
            images = searchForPlus(source, tag)
            i = string.find(source, "mainUrl\":\"")

            if i != -1:
                images = searchForPlus(images, "mainUrl\":\"")
                i = string.find(images, "\"")
                image = stripText(images[0:i])
                rw.setImage1(image)
                rw.setLargeImage1(image)


    tt = 1

    if string.find(source, "Fiction") == -1:
        tt = 0

    # Find Title
    tag = "id='title'"

    if string.find(source, tag) == -1:
        tag = "<h1 id=\"title\""

    source = searchForPlus(source, tag)
    source = searchForPlus(source, "roductTitle\"")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])

    if tt == 1:
        i = string.rfind(title, "(")

        if i != -1:
            title = stripText(title[0:i])

    rw.setTitle(title)

    i = string.rfind(source, ">[Kindle Edition]<")

    if i > 0 and i < 250:
        rw.setFormat("Kindle")


    # Find Author
    authorList = []
    tag = "field-author="

    i = string.find(source, tag)

    if i != -1 and i <= 5000:
        source = searchFor(source, tag)

        i = string.find(source, "\n")
        authors = stripText(source[0:i])
        authorList = []

        while (searchFor(authors, tag) != None):
            authors = searchForPlus(authors, tag)
            authors = searchForPlus(authors, "\">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            i = string.find(authors, "class=\"byLinePipe\">")

            if i != -1:
                authors = searchForPlus(authors, "class=\"byLinePipe\">")
                authors = stripText(authors)

                if authors.startswith("(") == 1:
                    i = string.find(authors, ")")
                    role = stripText(authors[0:i+1])

                    if role == "(Illustrator)":
                        rw.setIllustrator(author)
                        author = ""
                    elif role == "(bersetzer)":
                        rw.setTranslator(author)
                        author = ""
                    elif role == "(Editor)":
                        rw.setEditor(author)
                        author = ""
                
            if author != "":
                authorList.append(author)

        rw.setAuthors(authorList)


    # Find List price
    i = string.find(source, "class=\"listprice\"")

    if i != -1:
        listprice = searchForPlus(source,  "class=\"listprice\"")
        listprice = searchForPlus(listprice,  "EUR ")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])
        rw.setListPrice(listprice)


    # Find value
    i = string.find(source, "class=\"a-button a-button-selected a-spacing-mini a-button-toggle format\"")

    if i != -1:
        value = searchForPlus(source,  "class=\"a-button a-button-selected a-spacing-mini a-button-toggle format\"")
        value = searchForPlus(value,  "EUR ")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        rw.setItemValue(value)
    else:
        rw.setItemValue(rw.getListPrice())

    rw.setPurchasePrice(rw.getItemValue())
    rw.setPurchaseDate(Date())
    rw.setPurchasePlace(rw.getSource())


    # Find Comments
    tag = "id=\"productDescription\""
    i = string.find(source, tag)

    if i != -1:
        comments = searchForPlus(source, tag)
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</div>")
        comments = stripText(comments[0:i])

        i = string.find(comments, "<script")

        if i != -1:
            comments = stripText(comments[0:i])

        rw.setProductInfo(comments)


    i = string.find(source, ">Detalles del producto<")

    if i != -1:
        attributes = searchForPlus(source, ">Detalles del producto<")
        i = string.find(attributes, "</ul>")
        attributes = attributes[0:i]

        # Find Format
        format = searchForPlus(attributes, "<b>")

        if format.startswith("Formato:") == 1:
            format = searchForPlus(format, ">")

        i = string.find(format, "<")
        format = stripText(format[0:i])
        i = string.find(format, ":")

        if i != -1:
            format = stripText(format[0:i])

        rw.setFormat(format)
    

        # Find Pages
        attributes = searchForPlus(attributes, "</b>")
        i = string.find(attributes, "ginas")

        if i != -1:
            pages = stripText(attributes[0:i-3])
            rw.setPages(pages)

        # Find Publisher
        attributes = searchForPlus(attributes,"<b>Editor")
        attributes = searchForPlus(attributes, ">")
        i = string.find(attributes, "<")
        publisher = stripText(attributes[0:i])

        i = string.find(publisher, "\n")

        if i != -1:
            pub1 = stripText(publisher[0:i])
            pub2 = stripText(publisher[i+1:])
            publisher = pub1 + " " + pub2

        i = string.find(publisher, "\n")

        if i != -1:
            publisher = stripText(publisher[0:i])

        i = string.find(publisher, "(")

        if i != -1:
            date = stripText(publisher[i+1:])
            publisher = stripText(publisher[0:i])
            i = string.find(date, ")")
            date = stripText(date[0:i])
            rw.setReleaseDate(date)

        i = string.find(publisher, ";")

        if i != -1:
            publisher = stripText(publisher[0:i])

        i = string.find(publisher, "&nbsp")

        if (i != -1):
            publisher = stripText(publisher[0:i])
                
        rw.setPublisher(publisher)


        # Find language if any
        i = string.find(attributes, ">Idioma:")

        if i != -1:
            attributes = searchForPlus(attributes, ">Idioma:")
            attributes = searchForPlus(attributes, ">")
            i = string.find(attributes, "<")
            language = stripText(attributes[0:i])
            rw.setLanguage(language)

    
        # Find ISBN
        i = string.find(attributes, "ISBN-13:")

        if i != -1:
            attributes = searchForPlus(attributes, "ISBN-13:")
            attributes = searchForPlus(attributes, ">")
            i = string.find(attributes, "<")
            isbn = stripText(attributes[0:i])
            rw.setISBN(isbn)

    # Find Dimensions
    i = string.find(source, "Dimensions (en&nbsp;cm)&nbsp;:")

    if i != -1:
       source = searchForPlus(source, "Dimensions (en&nbsp;cm)&nbsp;:")
       source = searchForPlus(source, ">")
       i = string.find(source, "<")
       # sometimes this is left blank. Only include for non-null
       if i>1:
           dimensions = stripText(source[0:i]) + " cm"

       rw.setDimensions(dimensions)


    # Find category
    i = string.find(source, "<b>Parcourir les")

    if (i != -1):
        source = searchForPlus(source, "<b>Parcourir les")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        category = stripText(source[0:i])
        rw.setCategory(category)


try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
