# This Python file uses the following encoding: iso-8859-1
# amazon.fr scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    rw.setDefaultPublicationPlace("France")
    rw.setDefaultLanguage("[[FR]]")
    rw.setCurrencySymbol("[[EUR]]")


    tag = "class=\"a-size-mini a-spacing-none a-color-base s-line-clamp-2\""

    if string.find(source, tag) == -1:
        tag = "class=resultCount"

    if string.find(source, tag) == -1:
        tag = "id=\"result_0\""

    if string.find(source, tag) == -1:
        tag = "class=\"searchresults\""

    if string.find(source, tag) == -1:
        tag = "class=\"s-main-slot s-result-list s-search-results sg-row\""

    i = string.find(source, tag)

    if i != -1:
        # Amazon search results page, follow link
        source = searchForPlus(source, tag)
        source = searchForPlus(source, "a-link-normal")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])

        i = string.find(url, "ebook")

        if i != -1:
            source = searchForPlus(source, "class=\"a-size-base a-link-normal a-text-bold\"")
            source = searchForPlus(source, "href=\"")
            i = string.find(source, "\"")
            url = stripText(source[0:i])

        url = string.replace(url, "&#x2F;", "/")

        if url.startswith("http") != 1:
            url = "https://www.amazon.fr" + url

        http = HTTPConnection()
        
        #try:
        #    http.setGenericUserAgent()
        #except:
        #    print "Unable to set UA"

        http.blockForLoad();
        source = http.getContents(url, "UTF-8")
        t2 = open(rw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()

        i = string.find(source, "\"btAsinTitle\"")

        if i != -1:
            print "OLD FORMAT"
            extractOld(source)
            return


    # Find Image
    tag = "id='imageBlock'"
    i = string.find(source, tag)

    if i == -1:
        tag = "id=\"imageBlock\""
        i = string.find(source, tag)

    if i != -1:
        images = searchForPlus(source, tag)
        images = searchForPlus(images, "src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "data:")

        if i != -1:
            image = ""

        i = string.find(image, "no-img")

        if i == -1:
            i = string.find(image, "/loadIndicators/")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                k = string.find(image[i+j:], "_")

                if k != -1:
                    j = j + (k - 1)

                imagex = stripText(image[0:i] + image[i+j+1:])

                if string.find(imagex, "_SY") == -1 & string.find(imagex, "_AA") == -1:
                    imagex = stripText(image[0:i] + "_SY300" + image[i+j+1:])

                image = imagex
                

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                rw.setImage1(image)

            tag = "_SY300_"
            i = string.find(image, tag)

            if i == -1:
                tag = "_SX225_"
                i = string.find(image, tag)

            if i != -1:
                large = string.replace(image, tag, "_SY500_")
                rw.setLargeImage1(large)
                rw.setImage1(image)
            else:
                rw.setImage1(image)

    if rw.getLargeImage1() == None:
        i = string.find(source, "class=\"quorus-product-photo\"")

        if i != -1:
            images = stripText(source[i-200:])
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])

            i = string.find(image, "_SL")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)

    if rw.getImage1() == None:
        tag = "'imageGalleryData'"
        i = string.find(source, tag)

        if i != -1:
            images = searchForPlus(source, tag)
            i = string.find(source, "mainUrl\":\"")

            if i != -1:
                images = searchForPlus(images, "mainUrl\":\"")
                i = string.find(images, "\"")
                image = stripText(images[0:i])
                rw.setImage1(image)
                rw.setLargeImage1(image)


    # Find new price/count
    i = string.find(source, "olp-new olp-link")

    if i != -1:
        new = searchForPlus(source, "olp-new olp-link")
        new = searchForPlus(new, "condition=new")
        new = searchForPlus(new, ">")
        new = stripText(new)
        i = string.find(new, " ")
        rw.setNewCount(new[0:i])

        if rw.getNewCount() != "0":
            new = searchForPlus(new, "</span>")
            i = string.find(new, " ")
            rw.setNewPrice(new[0:i])


    # Find used price/count
    i = string.find(source, "olp-used olp-link")

    if i != -1:
        used = searchForPlus(source, "olp-used olp-link")
        used = searchForPlus(used, "condition=used")
        used = searchForPlus(used, ">")
        used = stripText(used)
        i = string.find(used, " ")
        rw.setUsedCount(used[0:i])

        if rw.getUsedCount() != "0":
            used = searchForPlus(used, "</span>")
            i = string.find(used, " ")
            rw.setUsedPrice(used[0:i])


    # Find collectible price/count
    i = string.find(source, "olp-collectible olp-link")

    if i != -1:
        col = searchForPlus(source, "olp-collectible olp-link")
        col = searchForPlus(col, "condition=collectible")
        col = searchForPlus(col, ">")
        col = stripText(col)
        i = string.find(col, " ")
        rw.setCollectibleCount(col[0:i])

        if rw.getCollectibleCount() != "0":
            col = searchForPlus(col, "</span>")
            i = string.find(col, " ")
            rw.setCollectiblePrice(col[0:i])

    tt = 1

    if string.find(source, "Fiction") == -1:
        tt = 0


    # Find Title
    tag = "id='title'"

    if string.find(source, tag) == -1:
        tag = "<h1 id=\"title\""

    source = searchForPlus(source, tag)
    source = searchForPlus(source, "id=\"productTitle\"")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])

    if tt == 1:
        i = string.rfind(title, "(")

        if i != -1:
            title = stripText(title[0:i])

    rw.setTitle(title)

    i = string.rfind(source, ">[Kindle Edition]<")

    if i > 0 and i < 250:
        rw.setFormat("Kindle")


    # Find Author
    authorList = []
    tag = "contributorNameID"

    i = string.find(source, tag)

    if i == -1:
        tag = "class=\"author notFaded\""
        i = string.find(source, tag)

    if i != -1:
        source = searchFor(source, tag)

        i = string.find(source, "</span>")
        authors = stripText(source[0:i])
        authorList = []

        while (searchFor(authors, "href=\"") != None):
            authors = searchForPlus(authors, "href=\"")
            authors = searchForPlus(authors, "\">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            i = string.find(authors, "class=\"byLinePipe\">")

            if i != -1:
                authors = searchForPlus(authors, "class=\"byLinePipe\">")
                authors = stripText(authors)

                if authors.startswith("(") == 1:
                    i = string.find(authors, ")")
                    role = stripText(authors[0:i+1])

                    if role == "(Illustrator)":
                        rw.setIllustrator(author)
                        author = ""
                    elif role == "(Traduction)":
                        rw.setTranslator(author)
                        author = ""
                    elif role == "(Editor)":
                        rw.setEditor(author)
                        author = ""
                
            if author != "":
                authorList.append(author)

        rw.setAuthors(authorList)


    # Find List price
    i = string.find(source, "class=\"listprice\"")

    if i != -1:
        listprice = searchForPlus(source,  "class=\"listprice\"")
        listprice = searchForPlus(listprice,  "EUR ")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])
        rw.setListPrice(listprice)


    # Find value
    i = string.find(source, "class=\"a-button a-button-selected a-spacing-mini a-button-toggle format\"")

    if i != -1:
        value = searchForPlus(source,  "class=\"a-button a-button-selected a-spacing-mini a-button-toggle format\"")
        value = searchForPlus(value,  "class=\"a-size-base a-color-price a-color-price\"")
        value = searchForPlus(value,  ">")
        i = string.find(value, " ")
        value = stripText(value[0:i])
        rw.setItemValue(value)
    else:
        rw.setItemValue(rw.getListPrice())

    rw.setPurchasePrice(rw.getItemValue())
    rw.setPurchaseDate(Date())
    rw.setPurchasePlace(rw.getSource())


    # Find Comments
    tag = "id=\"bookDescription_feature_div\""
    i = string.find(source, tag)

    if i != -1:
        comments = searchForPlus(source, tag)
        comments = searchForPlus(comments, "<div")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</div")
        comments = stripText(comments[0:i])

        i = string.find(comments, "<script")

        if i != -1:
            comments = stripText(comments[0:i])

        rw.setProductInfo(comments)


    i = searchForPlus(source, "tails sur le produit")

    if i != -1:
        attributes = searchForPlus(source, "tails sur le produit")
        # first item of the description data; should be the format
        attributes = searchForPlus(attributes, "<li><b>")
        i = string.find(attributes, "</ul>")
        attributes = attributes[0:i]
        i = string.find(attributes, ":</b>")
        formatline = attributes[0:i]
        format = "Unknown Binding"

        i = searchForPlus(formatline, "Poche")
        if (i != None):
            format = "Mass Market Paperback"
       
        j = searchForPlus(formatline, "Broch")
        if (j != None):
            format = "Paperback"
       
        k = searchForPlus(formatline, "Cartonn")
        if (k != None):
            format = "Hardback"
       
        l = searchForPlus(formatline, "Album")
        if (l != None):
            format = "Hardback"
       
        l = searchForPlus(formatline, "Kindle")
        if (l != None):
            format = "Kindle"

        rw.setFormat(format)
    
        if format != "Unknown Binding":
            # Find Pages
            attributes = searchForPlus(attributes, "</b>")
            i = string.find(attributes, "pages")

            if i != -1:
                pages = stripText(attributes[0:i-1])
                rw.setPages(pages)


        # Find Publisher
        tag = "<b>Editeur"

        attributes = searchForPlus(attributes, tag)
        attributes = searchForPlus(attributes, ">")
        i = string.find(attributes, "<")
        publisher = stripText(attributes[0:i])

        i = string.rfind(publisher, "(")

        if i != -1:
            date = stripText(publisher[i+1:])
            publisher = stripText(publisher[0:i])
            i = string.find(date, ")")
            date = stripText(date[0:i])
            rw.setReleaseDate(date)

        i = string.find(publisher, ";")

        if i != -1:
            publisher = stripText(publisher[0:i])

        i = string.find(publisher, "&nbsp")

        if (i != -1):
            publisher = stripText(publisher[0:i])
                
        rw.setPublisher(publisher)


        # Find Publication date, (may have got it with publisher, but might not)
        tag = "dition&#160;"
        i = string.find(attributes, tag)

        if i != -1:
            attributes = searchForPlus(attributes, tag)
            attributes = searchForPlus(attributes, ">")
            i = string.find(attributes, "<")
            publisher = stripText(attributes[0:i])

            i = string.rfind(publisher, "(")

            if i != -1:
                date = stripText(publisher[i+1:])
                i = string.find(date, ")")
                date = stripText(date[0:i])
                rw.setReleaseDate(date)


    # Find series if any
    i = string.find(attributes, ">Collection&")

    if i != -1:
        attributes = searchForPlus(attributes, ">Collection&")
        attributes = searchForPlus(attributes, ">")
        i = string.find(attributes, "<")
        series = stripText(attributes[0:i])
        rw.setSeries(series)


    # Find Language
    i = string.find(attributes, ">Langue&nbsp;:")

    if i != -1:
        attributes = searchForPlus(attributes, ">Langue&nbsp;:")
        attributes = searchForPlus(attributes, ">")
        i = string.find(attributes, "<")
        language = stripText(attributes[0:i])
        rw.setLanguage(language)

    
    # Find ISBN
    i = string.find(attributes, ">ISBN-13")

    if i != -1:
        attributes = searchForPlus(attributes, ">ISBN-13")
        attributes = searchForPlus(attributes, ">")
        i = string.find(attributes, "<")
        isbn = stripText(attributes[0:i])
        rw.setISBN(isbn)

    # Find Dimensions
    i = string.find(source, "Dimensions (en&nbsp;cm)&nbsp;:")

    if i != -1:
       source = searchForPlus(source, "Dimensions (en&nbsp;cm)&nbsp;:")
       source = searchForPlus(source, ">")
       i = string.find(source, "<")
       # sometimes this is left blank. Only include for non-null
       if i>1:
           dimensions = stripText(source[0:i]) + " cm"

       rw.setDimensions(dimensions)


    # Find category
    i = string.find(source, "<b>Parcourir les")

    if (i != -1):
        source = searchForPlus(source, "<b>Parcourir les")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        category = stripText(source[0:i])
        rw.setCategory1(category)


def extractOld(source):
    rw.setCurrencySymbol("")
    rw.setPublicationPlace("France")
    rw.setLanguage("French")


    i = string.find(source, "id=\"s-result-count\"")

    if i != -1:
        source = searchForPlus(source, "id=\"s-result-count\"")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        
        try:
            http.setGenericUserAgent()
        except:
            print "Unable to set UA"

        http.blockForLoad();
        source = http.getContents(url, "UTF-8")
        t2 = open(rw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    # Find Image (first try)
    image = ""
    i = string.find(source, "registerImage(\"original_image\"")

    if i != -1:
        tempdata = searchForPlus(source, "registerImage(\"original_image\"")
        tempdata = searchForPlus(tempdata, "\"")
        i = string.find(tempdata, "\"")
        image = stripText(tempdata[0:i])

        i = string.find(image, "no-image")

        if i != -1:
            image = ""

        i = string.find(image, ",")

        if i != -1:
            j = string.rfind(image[i:], ",")
            image = stripText(image[0:i] + image[i+j+1:])

        i = string.find(image, "_AA")

        if i != -1:
            image = stripText(image[0:i] + "_SL" + image[i+3:])

        rw.setImage1(image)


    # Find Image
    tag = "id=\"main_image_0\""

    i = string.find(source, tag)

    if i == -1:
        tag = "id=\"main-image-nonjs\""
        i = string.find(source, tag)

    if i != -1:
        images = searchForPlus(source, tag)
        images = searchForPlus(images, "src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "no-image")

        if i == -1:
            i = string.find(image, "/loadIndicators/")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                k = string.find(image[i+j:], "_")

                if k != -1:
                    j = j + (k - 1)

                imagex = stripText(image[0:i] + image[i+j+1:])

                if string.find(imagex, "_SY") == -1 & string.find(imagex, "_AA") == -1:
                    imagex = stripText(image[0:i] + "_SY300" + image[i+j+1:])

                image = imagex
                

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                rw.setImage1(image)

            tag = "_SY300_"
            i = string.find(image, tag)

            if i == -1:
                tag = "_SX225_"
                i = string.find(image, tag)

            if i != -1:
                large = string.replace(image, tag, "_SY500_")
                rw.setLargeImage1(large)
                rw.setImage1(image)
            else:
                rw.setImage1(image)

    if rw.getLargeImage1() == None:
        i = string.find(source, "class=\"quorus-product-photo\"")

        if i != -1:
            images = stripText(source[i-200:])
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])

            i = string.find(image, "_SL")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)


    # Find new price/count
    i = string.find(source, "dp_olp_new")

    if i != -1:
        new = searchForPlus(source, "dp_olp_new")
        new = searchForPlus(new, "condition=new")
        new = searchForPlus(new, ">")
        new = stripText(new)
        i = string.find(new, "&nbsp;")
        rw.setNewCount(new[0:i])

        if rw.getNewCount() != "0":
            new = searchForPlus(new, "EUR")
            i = string.find(new, "<")
            rw.setNewPrice(new[0:i])


    # Find used price/count
    i = string.find(source, "ref=dp_olp_used")

    if i != -1:
        used = searchForPlus(source, "ref=dp_olp_used")
        used = searchForPlus(used, "condition=used")
        used = searchForPlus(used, ">")
        used = stripText(used)
        i = string.find(used, "&nbsp;")
        rw.setUsedCount(used[0:i])

        if rw.getUsedCount() != "0":
            used = searchForPlus(used, "EUR")
            i = string.find(used, "<")
            rw.setUsedPrice(used[0:i])


    # Find collectible price/count
    i = string.find(source, "olp-collectible olp-link")

    if i != -1:
        col = searchForPlus(source, "olp-collectible olp-link")
        col = searchForPlus(col, "condition=collectible")
        col = searchForPlus(col, ">")
        col = stripText(col)
        i = string.find(col, "&nbsp;")
        rw.setCollectibleCount(col[0:i])

        if rw.getCollectibleCount() != "0":
            col = searchForPlus(col, "EUR")
            i = string.find(col, "<")
            rw.setCollectiblePrice(col[0:i])


    # Find Title
    source = searchForPlus(source, "\"btAsinTitle\"")
    source = searchForPlus(source, ">")
    source = stripText(source)

    if source.startswith("<span") == 1:
        source = searchForPlus(source, ">")

    i = string.find(source, "<")
    title = stripText(source[0:i])

    i = string.rfind(title, "(")

    if i != -1:
        title = stripText(title[0:i])

    rw.setTitle(title)


    # Find Author
    authorList = []
    tag = "href=\""

    i = string.find(source, tag)

    if i != -1 and i <= 2500:
        source = searchFor(source, tag)

        i = string.find(source, "\n")
        authors = stripText(source[0:i])
        authorList = []

        while (searchFor(authors, tag) != None):
            authors = searchForPlus(authors, tag)
            authors = searchForPlus(authors, "\">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            i = string.find(authors, "class=\"byLinePipe\">")

            if i != -1:
                authors = searchForPlus(authors, "class=\"byLinePipe\">")
                authors = stripText(authors)

                if authors.startswith("(") == 1:
                    i = string.find(authors, ")")
                    role = stripText(authors[0:i+1])

                    if role == "(Illustrator)":
                        rw.setIllustrator(author)
                        author = ""
                    elif role == "(Traduction)":
                        rw.setTranslator(author)
                        author = ""
                    elif role == "(Editor)":
                        rw.setEditor(author)
                        author = ""
                
            if author != "":
                authorList.append(author)

        rw.setAuthors(authorList)


    # Find List price
    i = string.find(source, "class=\"listprice\"")

    if i != -1:
        listprice = searchForPlus(source,  "class=\"listprice\"")
        listprice = searchForPlus(listprice,  "EUR ")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])
        rw.setListPrice(listprice)


    # Find value
    i = string.find(source, "class=\"priceLarge\"")

    if i != -1:
        value = searchForPlus(source,  "class=\"priceLarge\"")
        value = searchForPlus(value,  "EUR ")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        rw.setItemValue(value)
    else:
        rw.setItemValue(rw.getListPrice())

    rw.setPurchasePrice(rw.getItemValue())
    rw.setPurchaseDate(Date())
    rw.setPurchasePlace(rw.getSource())


    # Find Comments
    tag = ">Descriptions du produit<"
    i = string.find(source, tag)

    if i == -1:
        tag = ">reviews<"
        i = string.find(source, tag)

    if i == -1:
        tag = ">Reviews<"
        i = string.find(source, tag)

    if i != -1:
        comments = searchForPlus(source, tag)
        comments = searchForPlus(comments, "<div")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "<a name=\"productDetails\"")
        comments = stripText(comments[0:i])

        i = string.find(comments, "Voir l'ensemble des Descriptions du produit")

        if i != -1:
            comments = comments[0:i]

        i = string.find(comments, "</form>")

        if i != -1:
            comments = comments[0:i]

        i = string.find(comments, "<hr noshade")

        if i != -1:
            comments = comments[0:i]

        i = string.find(comments, "<script")

        if i != -1:
            comments = comments[0:i]

        comments =  string.replace(comments, "&#x9C;", "")
        comments =  string.replace(comments, "&#xC9;", "")
        comments =  string.replace(comments, "&#xEB;", "")
        comments =  string.replace(comments, "&#xEF;", "")
        comments =  string.replace(comments, "&#xF4;", "")
        rw.setProductInfo(comments)
    else:
        tag = "id=\"ps-content\""
        i = string.find(source, tag)

        if i != -1:
            comments = searchForPlus(source, tag)
            comments = searchForPlus(comments, "class=\"content\"")
            comments = searchForPlus(comments, "<div>")
            i = string.find(comments, "</div>")
            comments = stripText(comments[0:i])
            comments =  string.replace(comments, "&#x9C;", "")
            comments =  string.replace(comments, "&#xC9;", "")
            comments =  string.replace(comments, "&#xEB;", "")
            comments =  string.replace(comments, "&#xEF;", "")
            comments =  string.replace(comments, "&#xF4;", "")
            rw.setProductInfo(comments)


    i = searchForPlus(source, "tails sur le produit")

    if i != -1:
        attributes = searchForPlus(source, "tails sur le produit")
        # first item of the description data; should be the format
        attributes = searchForPlus(attributes, "<li><b>")
        i = string.find(attributes, "</ul>")
        attributes = attributes[0:i]
        i = string.find(attributes, "</li>")
        formatline = attributes[0:i]
        format = "Unknown Binding"

        i = searchForPlus(formatline, "Poche")
        if (i != None):
            format = "Mass Market Paperback"
       
        j = searchForPlus(formatline, "Broch")
        if (j != None):
            format = "Paperback"
       
        k = searchForPlus(formatline, "Cartonn")
        if (k != None):
            format = "Hardback"
       
        l = searchForPlus(formatline, "Album")
        if (l != None):
            format = "Hardback"
       
        l = searchForPlus(formatline, "Kindle")
        if (l != None):
            format = "Kindle"

        rw.setFormat(format)
    
        if format != "Unknown Binding":
            # Find Pages
            attributes = searchForPlus(attributes, "</b>")
            i = string.find(attributes, "pages")

            if i != -1:
                pages = stripText(attributes[0:i-1])
                rw.setPages(pages)


        # Find Publisher
        tag = "<b>Editeur"

        attributes = searchForPlus(attributes, tag)
        attributes = searchForPlus(attributes, ">")
        i = string.find(attributes, "<")
        publisher = stripText(attributes[0:i])

        i = string.rfind(publisher, "(")

        if i != -1:
            date = stripText(publisher[i+1:])
            publisher = stripText(publisher[0:i])
            i = string.find(date, ")")
            date = stripText(date[0:i])
            rw.setReleaseDate(date)

        i = string.find(publisher, ";")

        if i != -1:
            publisher = stripText(publisher[0:i])

        i = string.find(publisher, "&nbsp")

        if (i != -1):
            publisher = stripText(publisher[0:i])
                
        rw.setPublisher(publisher)


        # Find Publication date, (may have got it with publisher, but might not)
        tag = "dition&#160;"
        i = string.find(attributes, tag)

        if i != -1:
            attributes = searchForPlus(attributes, tag)
            attributes = searchForPlus(attributes, ">")
            i = string.find(attributes, "<")
            publisher = stripText(attributes[0:i])

            i = string.rfind(publisher, "(")

            if i != -1:
                date = stripText(publisher[i+1:])
                i = string.find(date, ")")
                date = stripText(date[0:i])
                rw.setReleaseDate(date)


    # Find series if any
    i = string.find(attributes, ">Collection&")

    if i != -1:
        attributes = searchForPlus(attributes, ">Collection&")
        attributes = searchForPlus(attributes, ">")
        i = string.find(attributes, "<")
        series = stripText(attributes[0:i])
        rw.setSeries(series)

    
    # Find ISBN
    i = string.find(attributes, "ISBN-13:")

    if i != -1:
        attributes = searchForPlus(attributes, "ISBN-13:")
        attributes = searchForPlus(attributes, ">")
        i = string.find(attributes, "<")
        isbn = stripText(attributes[0:i])
        rw.setISBN(isbn)

    # Find Dimensions
    i = string.find(source, "Dimensions (en&nbsp;cm)&nbsp;:")

    if i != -1:
       source = searchForPlus(source, "Dimensions (en&nbsp;cm)&nbsp;:")
       source = searchForPlus(source, ">")
       i = string.find(source, "<")
       # sometimes this is left blank. Only include for non-null
       if i>1:
           dimensions = stripText(source[0:i]) + " cm"

       rw.setDimensions(dimensions)


    # Find category
    i = string.find(source, "<b>Parcourir les")

    if (i != -1):
        source = searchForPlus(source, "<b>Parcourir les")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        category = stripText(source[0:i])
        rw.setCategory1(category)


try:
    rw.setBookObject(Book)

    i = string.find(source, "\"btAsinTitle\"")

    if i == -1:
        # New format
        print "NEW FORMAT"
        extract(source)
    else:
        print "OLD FORMAT"
        extractOld(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
