# This Python file uses the following encoding: iso-8859-1
# amazon.jp scraper
#
# Copyright  1999-2014 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    rw.setDefaultPublicationPlace("Japan")


    i = string.find(source, "id=\"s-result-count\"")

    if i != -1:
        source = searchForPlus(source, "id=\"s-result-count\"")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        url = string.replace(url, "&#x2F;", "/")
        http = HTTPConnection()
        
        try:
            http.setGenericUserAgent()
        except:
            print "Unable to set UA"

        http.blockForLoad();
        source = http.getContents(url, "UTF-8")
        t2 = open(rw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    # Find Image (first try)
    image = ""
    i = string.find(source, "registerImage(\"original_image\"")

    if i != -1:
        tempdata = searchForPlus(source, "registerImage(\"original_image\"")
        tempdata = searchForPlus(tempdata, "\"")
        i = string.find(tempdata, "\"")
        image = stripText(tempdata[0:i])

        i = string.find(image, "no-image")

        if i != -1:
            image = ""

        i = string.find(image, ",")

        if i != -1:
            j = string.rfind(image[i:], ",")
            image = stripText(image[0:i] + image[i+j+1:])

        i = string.find(image, "_AA")

        if i != -1:
            image = stripText(image[0:i] + "_SL" + image[i+3:])

        rw.setImage1(image)


    # Find Image
    tag = "id=\"main-image-container\""

    i = string.find(source, tag)

    if i == -1:
        tag = "id=\"main-image-nonjs\""
        i = string.find(source, tag)

    if i != -1:
        images = searchForPlus(source, tag)
        images = searchForPlus(images, "src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "no-image")

        if i == -1:
            i = string.find(image, "/loadIndicators/")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                k = string.find(image[i+j:], "_")

                if k != -1:
                    j = j + (k - 1)

                imagex = stripText(image[0:i] + image[i+j+1:])

                if string.find(imagex, "_SY") == -1 & string.find(imagex, "_AA") == -1:
                    imagex = stripText(image[0:i] + "_SY300" + image[i+j+1:])

                image = imagex
                

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                rw.setImage1(image)

            tag = "_SY300_"
            i = string.find(image, tag)

            if i == -1:
                tag = "_SX225_"
                i = string.find(image, tag)

            if i != -1:
                large = string.replace(image, tag, "_SY500_")
                rw.setLargeImage1(large)
                rw.setImage1(image)
            else:
                rw.setImage1(image)

    if rw.getLargeImage1() == None:
        i = string.find(source, "class=\"quorus-product-photo\"")

        if i != -1:
            images = stripText(source[i-200:])
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])

            i = string.find(image, "_SL")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                rw.setLargeImage1(large)


    # Find new price/count
    i = string.find(source, "dp_olp_new")

    if i != -1:
        new = searchForPlus(source, "dp_olp_new")
        new = searchForPlus(new, "&condition=new")
        new = searchForPlus(new, ">")
        new = stripText(new)
        i = string.find(new, "&nbsp;")
        rw.setNewCount(new[0:i])

        if rw.getNewCount() != "0":
            new = searchForPlus(new, "EUR")
            i = string.find(new, "<")
            rw.setNewPrice(new[0:i])


    # Find used price/count
    i = string.find(source, "ref=dp_olp_used")

    if i != -1:
        used = searchForPlus(source, "ref=dp_olp_used")
        used = searchForPlus(used, "&condition=used")
        used = searchForPlus(used, ">")
        used = stripText(used)
        i = string.find(used, "&nbsp;")
        rw.setUsedCount(used[0:i])

        if rw.getUsedCount() != "0":
            used = searchForPlus(used, "EUR")
            i = string.find(used, "<")
            rw.setUsedPrice(used[0:i])


    # Find collectible price/count
    i = string.find(source, "olp-collectible olp-link")

    if i != -1:
        col = searchForPlus(source, "olp-collectible olp-link")
        col = searchForPlus(col, "&amp;condition=collectible")
        col = searchForPlus(col, ">")
        col = stripText(col)
        i = string.find(col, "&nbsp;")
        rw.setCollectibleCount(col[0:i])

        if rw.getCollectibleCount() != "0":
            col = searchForPlus(col, "EUR")
            i = string.find(col, "<")
            rw.setCollectiblePrice(col[0:i])


    # Find Title
    tag = "id='title'"

    if string.find(source, tag) == -1:
        tag = "<h1 id=\"title\""

    source = searchForPlus(source, tag)
    source = searchForPlus(source, "id=\"productTitle\"")
    source = searchForPlus(source, ">")
    source = stripText(source)

    if source.startswith("<span") == 1:
        source = searchForPlus(source, ">")

    i = string.find(source, "<")
    title = stripText(source[0:i])

    i = string.rfind(title, "(")

    if i != -1:
        title = stripText(title[0:i])

    rw.setTitle(title)


    # Find Author
    authorList = []
    tag = "href=\""

    i = string.find(source, tag)

    if i != -1 and i <= 2500:
        source = searchFor(source, tag)

        i = string.find(source, "\n")
        authors = stripText(source[0:i])
        authorList = []

        while (searchFor(authors, tag) != None):
            authors = searchForPlus(authors, tag)
            authors = searchForPlus(authors, "\">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            i = string.find(authors, "class=\"byLinePipe\">")

            if i != -1:
                authors = searchForPlus(authors, "class=\"byLinePipe\">")
                authors = stripText(authors)

                if authors.startswith("(") == 1:
                    i = string.find(authors, ")")
                    role = stripText(authors[0:i+1])

                    if role == "(Illustrator)":
                        rw.setIllustrator(author)
                        author = ""
                    elif role == "(Traduction)":
                        rw.setTranslator(author)
                        author = ""
                    elif role == "(Editor)":
                        rw.setEditor(author)
                        author = ""
                
            if author != "":
                authorList.append(author)

        rw.setAuthors(authorList)


    # Find List price
    i = string.find(source, "class=\"listprice\"")

    if i != -1:
        listprice = searchForPlus(source,  "class=\"listprice\"")
        listprice = searchForPlus(listprice,  " ")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])
        rw.setListPrice(listprice)


    # Find value
    i = string.find(source, "class=\"priceLarge\"")

    if i != -1:
        value = searchForPlus(source,  "class=\"priceLarge\"")

        sym = searchForPlus(value,  ">")
        i = string.find(sym, " ")
        sym = stripText(sym[0:i])
        rw.setCurrencySymbol(sym)

        value = searchForPlus(value,  " ")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        rw.setItemValue(value)
    else:
        rw.setItemValue(rw.getListPrice())

    rw.setPurchasePrice(rw.getItemValue())
    rw.setPurchaseDate(Date())
    rw.setPurchasePlace(rw.getSource())


    # Find Comments
    comments = ""
    tag = "id=\"productDescription\""

    if string.find(source, tag) != -1:
        reviews = searchForPlus(source, tag)
        reviews = searchForPlus(reviews, ">")
        i = string.find(reviews, "</div>  </div>")
        reviews = stripText(reviews[0:i])

        i = string.find(reviews, "<div class=\"seeAll\">")

        if i != -1:
            reviews = stripText(reviews[0:i])

        while (searchFor(reviews, "class=\"productDescriptionSource\"") != None):
            reviews = searchForPlus(reviews, "class=\"productDescriptionSource\"")
            reviews = searchForPlus(reviews, ">")
            i = string.find(reviews, "</h")
            comment = stripText(reviews[0:i])

            reviews = searchForPlus(reviews, "class=\"productDescriptionWrapper\"")
            reviews = searchForPlus(reviews, ">")
            i = string.find(reviews, "<div class=\"emptyClear\">")
            comment = comment + "<br>" + stripText(reviews[0:i])
            comments = appendComment(comments, comment)

    rw.setProductInfo(comments)


    i = string.find(source, "id=\"detail_bullets_id\"")

    if i != -1:
        attributes = searchForPlus(source, "id=\"detail_bullets_id\"")
        # first item of the description data; should be the format
        attributes = searchForPlus(attributes, "<li><b>")
        i = string.find(attributes, "</ul>")
        attributes = attributes[0:i]
        i = string.find(attributes, ":</b>")
        format = attributes[0:i]
        rw.setFormat(format)
    
        # Find Pages
        attributes = searchForPlus(attributes, "</b>")
        i = string.find(attributes, "\x3c\x2f\x6c\x69")

        if i != -1:
            pages = stripText(attributes[0:i-3])
            rw.setPages(pages)


        # Find Publisher
        tag = u"\u51fa\u7248\u793e"

        attributes = searchForPlus(attributes, tag)
        attributes = searchForPlus(attributes, ">")
        i = string.find(attributes, "<")
        publisher = stripText(attributes[0:i])

        i = string.rfind(publisher, "(")

        if i != -1:
            date = stripText(publisher[i+1:])
            publisher = stripText(publisher[0:i])
            i = string.find(date, ")")
            date = stripText(date[0:i])
            rw.setReleaseDate(date)

        i = string.find(publisher, ";")

        if i != -1:
            publisher = stripText(publisher[0:i])

        i = string.find(publisher, "&nbsp")

        if (i != -1):
            publisher = stripText(publisher[0:i])
                
        rw.setPublisher(publisher)


        # Find Publication date, (may have got it with publisher, but might not)
        tag = "dition&#160;"
        i = string.find(attributes, tag)

        if i != -1:
            attributes = searchForPlus(attributes, tag)
            attributes = searchForPlus(attributes, ">")
            i = string.find(attributes, "<")
            publisher = stripText(attributes[0:i])

            i = string.rfind(publisher, "(")

            if i != -1:
                date = stripText(publisher[i+1:])
                i = string.find(date, ")")
                date = stripText(date[0:i])
                rw.setReleaseDate(date)


        # Find language
        tag = u"\u8a00\u8a9e"
        i = string.find(attributes, tag)

        if i != -1:
            language = searchForPlus(attributes, tag)
            language = searchForPlus(language, ">")
            i = string.find(language, "<")
            language = stripText(language[0:i])
            rw.setLanguage(language)
            

    
    # Find ISBN
    i = string.find(source, "ISBN-13:")

    if i != -1:
        isbn = searchForPlus(source, "ISBN-13:")
        isbn = searchForPlus(isbn, ">")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])
        rw.setISBN(isbn)

    # Find Dimensions
    i = string.find(source, "Dimensions (en&nbsp;cm)&nbsp;:")

    if i != -1:
       source = searchForPlus(source, "Dimensions (en&nbsp;cm)&nbsp;:")
       source = searchForPlus(source, ">")
       i = string.find(source, "<")
       # sometimes this is left blank. Only include for non-null
       if i>1:
           dimensions = stripText(source[0:i]) + " cm"

       rw.setDimensions(dimensions)


    # Find category
    i = string.find(source, "<b>Parcourir les")

    if (i != -1):
        source = searchForPlus(source, "<b>Parcourir les")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        category = stripText(source[0:i])
        rw.setCategory1(category)


#convert string to hex
def toHex(s):
    lst = []
    for ch in s:
        hv = hex(ord(ch)).replace('0x', '')
        if len(hv) == 1:
            hv = '0'+hv
        lst.append(hv)
    
    return reduce(lambda x,y:x+y, lst)


try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
