# This Python file uses the following encoding: iso-8859-1
# Amazon API scraper
#
# Copyright  1999-2019 Readerware Corporation.  All Rights Reserved.
#
# This will be called once the media object has been built using the Amazon API.
#
# This is a chance to adjust the extracted data.

import  os
import  string

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    java.lang import String
from    java.util import Date

import  rw


def apiextract(source):
    print "Amazon API book extraction script..."

    if source == "None":
        print "No source object received."
        return


    # Find Comments
    comments = ""

    tag = "data-feature-name=\"bookDescription\""

    if string.find(source, tag) != -1:
        reviews = searchForPlus(source, tag)
        i = string.find(reviews, "<noscript>")

        if i != -1:
            reviews = searchForPlus(reviews, "<noscript>")
            i = string.find(reviews, "</noscript>")
            comment = stripText(reviews[0:i])
            comment = string.replace(comment, "</p>", "<br /><br />")
            comments = appendComment(comments, comment)

    tag = "Editorial Reviews"
    header = ""

    if string.find(source, tag) == -1:
        # Amazon UK comments
        tag = "Product description"
        header = ""

    if string.find(source, tag) != -1:
        header = "Editorial Reviews<BR>"
        comments = appendComment(comments, header)
        reviews = searchForPlus(source, tag)
        reviews = searchForPlus(reviews, ">")

        i = string.find(reviews, "<script")

        if i != -1:
            reviews = stripText(reviews[0:i])

        i = string.find(reviews, "</div>")

        if i != -1:
            reviews = stripText(reviews[0:i])

        while (searchFor(reviews, "<DIV>") != None):
            reviews = searchForPlus(reviews, "<DIV>")
            reviews = searchForPlus(reviews, ";")
            i = string.find(reviews, "</DIV>")

            if i != -1:
                comment = stripText(reviews[0:i])
            else:
                comment = stripText(reviews)

            i = string.find(comment, "<object")

            if i != -1:
                comment = stripText(comment[0:i])

            comments = appendComment(comments, comment)

    comments =  string.replace(comments, "</DIV>", "<BR>")
    comments =  string.replace(comments, "<I >", "")
    comments =  string.replace(comments, "<b >", "<b>")
    comments =  string.replace(comments, "<i >", "<i>")
    comments =  string.replace(comments, "<o:p>", "")
    comments =  string.replace(comments, "</o:p>", "")
    comments =  string.replace(comments, "</h5>", "")
    comments =  string.replace(comments, "&#147;", "\"")
    comments =  string.replace(comments, "&#8216;", "'")
    comments =  string.replace(comments, "&#x2022;", "*")
    comments =  string.replace(comments, "&#x2015;", "-")
    comments =  string.replace(comments, "&#xE5;", "")

    comments =  string.replace(comments, "\303\245", "\345")

    rw.setProductInfo(comments)

try:
    rw.setBookObject(Book)
    apiextract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
