# This Python file uses the following encoding: iso-8859-1
# ar scraper
#
# Copyright  1999-2007 Readerware Corporation.  All Rights Reserved.
import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setDefaultPublicationPlace("Australia")
    rw.setDefaultLanguage("English")
    rw.setCurrencySymbol("$")

    i = string.find(source, ">Sorry, your search returned no matches.")

    if i != -1:
        source = searchFor(source, "force exception")
        source = searchFor(source, "force exception")
        return


    #Get detail page, if necessary
    i = string.find(source, "class=\"row_title\">Search results for")

    if i != -1:
        source = searchForPlus(source, "class=\"row_title\">Search results for")
        source = searchForPlus(source, "<a href=\"")
        i = string.find(source, "\"")
        url = "http://www.angusrobertson.com.au" + stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(rw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()



    # Main extraction
    # Find Image (before title in new format)
    i = string.find(source, "id=\"primaryImage\"")

    if i != -1:
        image = searchForPlus(source, "id=\"primaryImage\"")
        image = searchForPlus(image, "itemprop=\"image\"")
        image = searchForPlus(image, "src=\"")
        i = string.find(image, "\"")
        image = "http:" + stripText(image[0:i])
        rw.setImage1(image)


    # Find Title
    title = searchForPlus(source, "class=\"product-title\"")
    title = searchForPlus(title, "\">")
    i = string.find(title, "<")
    title = stripText(title[0:i])
    rw.setTitle(title)


    # Find Author
    i = string.find(source, "class=\"author pull-left\"")

    if i != -1:
        authors = searchForPlus(source, "class=\"author pull-left\"")
        authors = searchForPlus(authors, "\">")
        i = string.find(authors, "<")
        author = stripText(authors[0:i])
        rw.setAuthor(author)


    # Find Price
    i = string.find(source, "itemprop=\"price\"")

    if i != -1:
        value = searchForPlus(source, "itemprop=\"price\"")
        value = searchFor(value, ">")
        i = string.find(value, "<")
        rw.setItemValue(value[0:i])

        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find comments
    i = string.find(source, "id=\"synopsisDescription\"")

    if i != -1:
        info = ""
        comments = searchForPlus(source, "id=\"synopsisDescription\"")
        comments = searchForPlus(comments, "itemprop=\"description\"")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</div>")
        comments = stripText(comments[0:i])
        rw.setProductInfo(comments)


    # Find ISBN
    i = string.find(source, ">ISBN:<")

    if i != -1:
        isbn = searchForPlus(source, ">ISBN:<")
        isbn = searchForPlus(isbn, "<dd")
        isbn = searchForPlus(isbn, ">")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])
        rw.setISBN(isbn)


    # Find Category
    i = string.find(source, "Category:<")

    if i != -1:
        category = searchForPlus(source, "Category:<")
        category = searchForPlus(category, "<dd")
        category = searchForPlus(category, ">")
        i = string.find(category, "<")
        category = stripText(category[0:i])
        rw.setCategory1(category)


    # Find Format
    i = string.find(source, ">Format:<")

    if i != -1:
        format = searchForPlus(source, ">Format:<")
        format = searchForPlus(format, "<dd>")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        rw.setFormat(format)


    # Find Publication Date
    i = string.find(source, ">Publication Date:<")

    if i != -1:
        date = searchForPlus(source, ">Publication Date:<")
        date = searchForPlus(date, "<dd")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        rw.setReleaseDate(date)


    # Find Publisher
    i = string.find(source, ">Publisher:<")

    if i != -1:
        publisher = searchForPlus(source, ">Publisher:<")
        publisher = searchForPlus(publisher, "<dd>")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])
        rw.setPublisher(publisher)


    # Find Pages
    i = string.find(source, ">Pages:<")

    if i != -1:
        pages = searchForPlus(source, ">Pages:<")
        pages = searchForPlus(pages, "<dd>")
        i = string.find(pages, "<")
        pages = stripText(pages[0:i])
        rw.setPages(pages)


    # Find Dimensions
    i = string.find(source, ">Dimensions (mm):<")

    if i != -1:
        dimensions = searchForPlus(source, ">Dimensions (mm):<")
        dimensions = searchForPlus(dimensions, "<dd>")
        i = string.find(dimensions, "<")
        dimensions = stripText(dimensions[0:i])
        rw.setDimensions(dimensions)


    # Find Publication Place
    i = string.find(source, ">Country of origin:<")

    if i != -1:
        place = searchForPlus(source, ">Country of origin:<")
        place = searchForPlus(place, "<dd>")
        i = string.find(place, "<")
        place = stripText(place[0:i])
        rw.setPublicationPlace(place)



try:
    rw.setBookObject(Book)

    i = string.find(source, ">Textbook Details<")

    if i == -1:
        extract(source)
    else:
        extractTextbook(source)

finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
