# This Python file uses the following encoding: iso-8859-1
# British Library (Online Public Access Catalogue, OPAC) scraper
#
# Copyright  1999-2014 Readerware Corporation.  All Rights Reserved.
#
# Note: We are not extracting format, not reliably available as of Dec 2014.
#

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setDefaultPublicationPlace("UK")
    rw.setDefaultLanguage("English")
    rw.setCurrencySymbol("")


    # Follow redirect page
    i = string.find(source, "<div id=\"connect\">")

    if i != -1:
        source = searchForPlus(source, "<div id=\"connect\">")
        source = searchForPlus(source, "href=\"/goto/")
        i = string.find(source, "\">")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)

        try:
            t2 = open(rw.getLogsDir() + "trace2.html", "w")
            t2.write(source)
            t2.close()
        except:
            print "Unable to create trace2.html"


    # Get detail page from results page
    i = string.find(source, "<em>Everything in this catalogue</em>")

    if i != -1:
        source = searchForPlus(source, "id=\"exlidResult0-DetailsTab\"")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = "http://explore.bl.uk/primo_library/libweb/action/" + stripText(source[0:i])
        url = string.replace(url, "&amp;", "&")
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)

        try:
            t3 = open(rw.getLogsDir() + "trace3.html", "w")
            t3.write(source)
            t3.close()
        except:
            print "Unable to create trace3.html"


    # Get detail tab
    i = string.find(source, "id=\"exlidResult0-DetailsTab\"")

    if i != -1:
        source = searchForPlus(source, "id=\"exlidResult0-DetailsTab\"")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = "http://explore.bl.uk/primo_library/libweb/action/" + stripText(source[0:i])
        url = string.replace(url, "&amp;", "&")
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)

        try:
            t3 = open(rw.getLogsDir() + "trace4.html", "w")
            t3.write(source)
            t3.close()
        except:
            print "Unable to create trace4.html"


    # Find Title
    source = searchForPlus(source, ">Title:<")
    source = searchForPlus(source, ">")
    i = string.find(source, "</li>")
    title = stripText(source[0:i])
    title = removeHighlight(title)

    if title.endswith("/"):
        i = string.rfind(title, "/")
        title = stripText(title[0:i])

    i = string.find(title, " / ")

    if i != -1:
        title = stripText(title[0:i])

    rw.setTitle(title)


    # Find Author
    i = string.find(source, ">Author:<")

    if i != -1:
        source = searchForPlus(source, ">Author:<")
        i = string.find(source, "<li")
        authors = stripText(source[0:i])

        while (searchFor(authors, "href=\"") != None):
            authors = searchForPlus(authors, "href=\"")
            authors = searchForPlus(authors, ">")
            i = string.find(authors, "</a>")
            author = stripText(authors[0:i])
            author = removeHighlight(author)

            i = string.find(author, "-")

            if i != -1:
                i = string.rfind(author, " ")
                # Removing author dates
                author = stripText(author[0:i])

            i = string.find(author, "<")

            if i != -1:
                author = stripText(author[0:i])

            if author.endswith("."):
                author = stripText(author[0:len(author)-1])

            rw.setAuthor(rw.convertName(author))


    # Find Publisher and date
    i = string.find(source, "Publication Details:")

    if i != -1:
        publisher = ""
        place = ""
        date = ""
        copyDate = ""
        publisher = searchForPlus(source, "Publication Details:")
        publisher = searchForPlus(publisher, "\">")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])
        publisher = removeHighlight(publisher)

        if publisher.endswith("."):
            i = string.rfind(publisher, ".")
            publisher = stripText(publisher[0:i])

        i = string.find(publisher, " : ")

        if i != -1:
            place = stripText(publisher[0:i])
            publisher = stripText(publisher[i+3:])
            i = string.find(publisher, ", ")

            if i != -1:
                date = stripText(publisher[i+1:])
                publisher = stripText(publisher[0:i])
        else:
            place = publisher
            publisher = ""

            i = string.find(place, ", ")

            if i != -1:
                date = stripText(place[i+1:])
                place = stripText(place[0:i])

        i = string.find(date, ", ")

        if i != -1:
            copyDate = stripText(date[i+1:])
            date = stripText(date[0:i])

            if copyDate.startswith("c"):
                copyDate = stripText(copyDate[1:])

        i = string.find(date, "(")

        if i != -1:
            date = stripText(date[0:i])

        if date.startswith("c") == 1 and copyDate == "":
            date = stripText(date[1:])
            copyDate = date

        rw.setPublisher(publisher)
        rw.setPublicationPlace(place)
        rw.setReleaseDate(date)
        rw.setCopyrightDate(copyDate)


    # Find Pages, Dimensions
    i = string.find(source, "Physical Description:")

    if i != -1:
        dimensions = ""
        pages = ""
        pages = searchForPlus(source, "Physical Description:")
        pages = searchForPlus(pages, "\">")
        i = string.find(pages, "<")
        pages = stripText(pages[0:i])

        i = string.find(pages, "cm")

        if i != -1:
            i = string.find(pages, "p")

            if i != -1:
                dimensions = stripText(pages[i+1:])
            else:
                dimensions = pages

            i = string.find(dimensions, "cm")
            dimensions = stripText(dimensions[0:i+2])

            i = string.rfind(dimensions, " ; ")

            if i != -1:
                dimensions = stripText(dimensions[i+1:])

            i = string.rfind(dimensions, ";&nbsp;")

            if i != -1:
                dimensions = stripText(dimensions[i+7:])

            if dimensions.startswith("."):
                dimensions = stripText(dimensions[1:])

            if dimensions.startswith(";"):
                dimensions = stripText(dimensions[1:])

        i = string.find(pages, "p")

        if i != -1:
            pages = stripText(pages[0:i])
        else:
            pages = ""

        i = string.rfind(pages, ",")

        if i != -1:
            pages = stripText(pages[i+1:])

        rw.setDimensions(dimensions)
        rw.setPages(pages)


    # Find Comments
    comments = ""
    i = string.find(source, "Notes:")

    if i != -1:
        comment = searchForPlus(source, "Notes:")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "</li>")
        comment = stripText(comment[0:i])
        comment = removeHighlight(comment)
        comments = comment

    i = string.find(source, "Contents:")

    if i != -1:
        comment = searchForPlus(source, "Contents:")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "</li>")
        comment = stripText(comment[0:i])
        comment = removeHighlight(comment)
        comments = appendComment(comments, comment)

    rw.setProductInfo(comments)


    # Find Series
    i = string.find(source, "Series:")

    if i != -1:
        series = searchForPlus(source, "Series:")
        series = searchForPlus(series, ">")
        i = string.find(series, "<")
        series = stripText(series[0:i])
        series = removeHighlight(series)
        rw.setSeries(series)


    # Find Category
    i = string.find(source, ">Subjects:<")

    if i != -1:
        category = searchForPlus(source, ">Subjects:<")
        category = searchForPlus(category, "href=\"")
        category = searchForPlus(category, ">")
        i = string.find(category, "<")
        category = stripText(category[0:i])
        category = removeHighlight(category)
        rw.setCategory1(category)


    # Find Keywords
    i = string.find(source, ">Subjects:<")

    if i != -1:
        subjects = searchForPlus(source, ">Subjects:<")
        i = string.find(subjects, "<li")
        subjects = stripText(subjects[0:i])
        keywords = ""

        while (searchFor(subjects, "href=\"") != None):
            subjects = searchForPlus(subjects, "href=\"")
            subjects = searchForPlus(subjects, ">")
            i = string.find(subjects, "<")
            keyword = stripText(subjects[0:i])
            keyword = removeHighlight(keyword)

            if keywords != "":
                keywords = keywords + ", " + keyword
            else:
                keywords = keyword

        rw.setKeywords(keywords)


    # Find Category
    i = string.find(source, "Genre/form")

    if i != -1:
        category = searchForPlus(source, "Genre/form")
        category = searchForPlus(category, ">")
        i = string.find(category, "<")
        category = stripText(category[0:i])
        category = removeHighlight(category)
        rw.setCategory1(category)


    # Find Dewey
    i = string.find(source, " >Dewey:")

    if i != -1:
        dewey = searchForPlus(source, " >Dewey:")
        i = string.find(dewey, "<")
        dewey = stripText(dewey[0:i])
        dewey = removeHighlight(dewey)
        rw.setDewey(dewey)


    # Find Language
    i = string.find(source, " Language:")

    if i != -1:
        language = searchForPlus(source, "Language:")
        language = searchForPlus(language, ">")
        i = string.find(language, "<")
        language = stripText(language[0:i])
        language = removeHighlight(language)
        rw.setLanguage(language)


    # Find ISBN
    i = string.find(source, "ISBN&nbsp;")

    if i != -1:
        source = searchForPlus(source, "ISBN&nbsp;")
        i = string.find(source, "<br/>")
        isbn = stripText(source[0:i])
        isbn = removeHighlight(isbn)

        # Find format (only look for paperback)
        if string.find(isbn, "pbk") != -1:
            rw.setFormat("Paperback")
        elif string.find(isbn, "paper") != -1:
            rw.setFormat("Paperback")
        else:
            rw.setFormat("Hardcover")

        i = string.find(isbn, "Dewey class. no. &nbsp;")

        if i != -1:
            isbn = stripText(isbn[0:i])

        i = string.find(isbn, "<span class=\"searchword\">")

        if i != -1:
            # BL can list multiple ISBNs. If one is highlighted, then
            # that is the one we searched for, take it.
            isbn = searchForPlus(isbn, "<span class=\"searchword\">")
            i = string.find(isbn, "<>")
            isbn = stripText(isbn[0:i])
        else:
            # No highlighted ISBN, take first.
            i = string.find(isbn, ";")

            if i != -1:
                i = string.find(isbn, ";")
                isbn = stripText(isbn[0:i])

        i = string.find(isbn, " ")

        if i != -1:
            isbn = stripText(isbn[0:i])

        i = string.find(isbn, "<")

        if i != -1:
            isbn = stripText(isbn[0:i])

        rw.setISBN(isbn)
            




def removeHighlight(str):
    # British library is highlighting search terms within the field.
    # Call this after getting data to remove highlighting.
    while (searchFor(str, "<span") != None):
        i = string.find(str, "<span")
        j = string.find(str[i:], ">")
        str = str[0:i] + str[i+j+1:]

    str = string.replace(str, "&nbsp;", " ")
    str = string.replace(str, "</span>", "")
    str = string.replace(str, "&#230;", "")
    str = string.replace(str, "\xC3\xA6", "")
    str = string.replace(str, "\xC3\xB8", "")
    return str




try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
