# This Python file uses the following encoding: iso-8859-1
# Book Depository  book scraper
#
# Copyright  1999-2019 Readerware Corporation.  All Rights Reserved.

import  os
import  string
import  time

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setDefaultPublicationPlace("US")
    rw.setDefaultLanguage("English")
    rw.setCurrencySymbol("$")


    # Find Image
    image = ""
    tag = "class=\"item-img\""
    i = string.find(source, tag)

    if i != -1:
        images = searchForPlus(source, tag)
        images = searchForPlus(images, "src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "no-image")

        if i == -1:
            i = string.find(image, "/lrg/")

            if i != -1:
                rw.setLargeImage1(image)
                image =  string.replace(image, "/lrg/", "/mid/")
                rw.setImage1(image)
            else:
                rw.setImage1(image)


    # Find Keywords
    i = string.find(source, ">Categories:<")

    if i != -1:
        extracted = ""
        keywords = searchFor(source, ">Categories:<")
        keywords = searchFor(keywords, ">")
        i = string.find(keywords, "</ol>")
        keywords = stripText(keywords[0:i])

        while (searchFor(keywords, "href=\"") != None):
            keywords = searchForPlus(keywords, "href=\"")
            keywords = searchForPlus(keywords, ">")
            i = string.find(keywords, "<")
            keyword = stripText(keywords[0:i])

            if extracted == "":
                extracted = keyword
            else:
                extracted = extracted + ", " + keyword

        rw.setKeywords(extracted)


    # Find Category
    i = string.find(source, ">Categories:<")

    if i != -1:
        category = searchFor(source, ">Categories:<")
        category = searchFor(category, ">")
        i = string.find(category, "</ol>")
        category = stripText(category[0:i])
        category = searchForPlus(category, "href=\"")
        category = searchForPlus(category, ">")
        i = string.find(category, "<")
        category = stripText(category[0:i])
        rw.setCategory1(category)


    # Find Title
    source = searchForPlus(source, "class=\"main-content")
    title = searchForPlus(source, "class=\"item-info\"")
    title = searchForPlus(title, "itemprop=\"name\"")
    title = searchForPlus(title, ">")
    i = string.find(title, "<")
    title = stripText(title[0:i])
    rw.setTitle(title)


    # Find rating
    i = string.find(source, "itemprop=\"ratingValue\"")

    if i != -1 and i <= 5000:
        rating = searchForPlus(source, "itemprop=\"ratingValue\"")
        rating = searchForPlus(rating, ">")
        i = string.find(rating, "<")
        rating = stripText(rating[0:i])
        rw.setMyRating(rating)


    # Find format
    i = string.find(source, "class=\"meta-info hidden-md\"")

    if i != -1:
        format = searchForPlus(source, "class=\"meta-info hidden-md\"")
        format = searchForPlus(format, "<li>")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        rw.setFormat(format)


    # Find language
    i = string.find(source, "itemprop=\"inLanguage\"")

    if i != -1:
        lang = searchForPlus(source, "itemprop=\"inLanguage\"")
        lang = searchForPlus(lang, "href=\"")
        lang = searchForPlus(lang, "\">")
        i = string.find(lang, "<")
        lang = stripText(lang[0:i])
        rw.setLanguage(lang)


    # Find Authors
    authorList = []
    tag = "class=\"author-info hidden-md\""

    i = string.find(source, tag)

    if i != -1:
        authors = searchFor(source, tag)
        i = string.find(authors, "</div>")
        authors = stripText(authors[0:i])
        tag = "itemprop=\"name\""

        while (searchFor(authors, tag) != None):
            authors = searchForPlus(authors, tag)
            authors = searchForPlus(authors, ">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            authorList.append(author)

    rw.setAuthors(authorList)


    # Find List price
    i = string.find(source, "class=\"checkout-tools\"")

    if i != -1:
        value = searchForPlus(source, "class=\"checkout-tools\"")

        i = string.find(value, "class=\"list-price\"")

        if i != -1:
            value = searchForPlus(value, "class=\"list-price\"")
            value = searchForPlus(value, ">")
            i = string.find(value, "<")
            rw.setListPrice(value[0:i])


    # Find value
    i = string.find(source, "class=\"checkout-tools\"")

    if i != -1:
        value = searchForPlus(source, "class=\"checkout-tools\"")

        i = string.find(value, "class=\"sale-price\"")

        if i != -1:
            value = searchForPlus(value, "class=\"sale-price\"")
            value = searchForPlus(value, ">")
            i = string.find(value, "<")
            rw.setItemValue(value[0:i])
            rw.setPurchasePrice(rw.getItemValue())
            rw.setPurchaseDate(Date())
            rw.setPurchasePlace(rw.getSource())


    # Find Comments
    comments = ""
    tag = "class=\"item-description\""

    if string.find(source, tag) != -1:
        reviews = searchForPlus(source, tag)
        reviews = searchForPlus(reviews, "<h2>")
        i = string.find(reviews, "<")
        comments = stripText(reviews[0:i]) + "<br />"

        reviews = stripText(reviews[i:])
        reviews = searchForPlus(reviews, "\">")
        i = string.find(reviews, "<a")
        reviews = stripText(reviews[0:i])
        comments = appendComment(comments, reviews)

    rw.setProductInfo(comments)


    # Find product details
    i = string.find(source, "class=\"biblio-wrap\"")

    if i != -1:
        details = searchForPlus(source, "class=\"biblio-wrap\"")
        details = searchForPlus(details, "<ul")
        i = string.find(details, "</ul>")
        details = stripText(details[0:i])


        # Find Format
        i = string.find(details, ">Format<")

        if i != -1:
            format = searchForPlus(details, ">Format<")
            format = searchForPlus(format, "<span>")
            i = string.find(format, "<")
            format = stripText(format[0:i])

            i = string.find(format, "|")

            if i != -1:
                format = stripText(format[0:i])

            rw.setFormat(format)


        # Find Pages
        i = string.find(details, "itemprop=\"numberOfPages\"")

        if i != -1:
            pages = searchForPlus(details, "itemprop=\"numberOfPages\"")
            pages = searchForPlus(pages, ">")
            i = string.find(pages, "<")
            pages = stripText(pages[0:i])

            i = string.find(pages, " ")

            if i != -1:
                pages = stripText(pages[0:i])

            rw.setPages(pages)


        # Find Dimensions
        i = string.find(details, ">Dimensions<")

        if i != -1:
            dimensions = searchForPlus(details, ">Dimensions<")
            dimensions = searchForPlus(dimensions, "<span>")
            i = string.find(dimensions, "<")
            dimensions = stripText(dimensions[0:i])

            i = string.find(dimensions, "|")

            if i != -1:
                dimensions = stripText(dimensions[0:i])

            rw.setDimensions(dimensions)


        # Find Publication date
        i = string.find(details, ">Publication date<")

        if i != -1:
            date = searchForPlus(details, ">Publication date<")
            date = searchForPlus(date, "itemprop=\"datePublished\"")
            date = searchForPlus(date, ">")
            i = string.find(date, "<")
            date = stripText(date[0:i])
            rw.setReleaseDate(date)


        # Find Publisher
        i = string.find(details, ">Publisher<")

        if i != -1:
            publisher = searchForPlus(details, ">Publisher<")
            publisher = searchForPlus(publisher, "itemprop=\"name\"")
            publisher = searchForPlus(publisher, ">")
            i = string.find(publisher, "<")
            publisher = stripText(publisher[0:i])
            rw.setPublisher(publisher)


        # Find Publication Place
        i = string.find(details, ">Publication City/Country<")

        if i != -1:
            place = searchForPlus(details, ">Publication City/Country<")
            place = searchForPlus(place, "<span>")
            i = string.find(place, "<")
            place = stripText(place[0:i])
            rw.setPublicationPlace(place)


        # Find Language
        i = string.find(details, ">Language<")

        if i != -1:
            language = searchForPlus(details, ">Language<")
            language = searchForPlus(language, "<span>")
            i = string.find(language, "<")
            language = stripText(language[0:i])
            rw.setLanguage(language)


        # Find ISBN
        i = string.find(details, ">ISBN13<")

        if i != -1:
            isbn = searchForPlus(details, ">ISBN13<")
            isbn = searchForPlus(isbn, "<span")
            isbn = searchForPlus(isbn, ">")
            i = string.find(isbn, "<")
            isbn = stripText(isbn[0:i])
            rw.setISBN(isbn)


        # Find Weight
        i = string.find(details, ">Dimensions<")

        if i != -1:
            weight = searchForPlus(details, ">Dimensions<")
            weight = searchForPlus(weight, "<span>")
            i = string.find(weight, "<")
            weight = stripText(weight[0:i])

            i = string.find(weight, "|")

            if i != -1:
                weight = stripText(weight[i+1:])
                rw.setWeight(weight)


        # Find Sales Rank
        i = string.find(details, ">Bestsellers rank<")

        if i != -1:
            rank = searchForPlus(details, ">Bestsellers rank<")
            rank = searchForPlus(rank, "<span>")
            i = string.find(rank, "<")
            rank = stripText(rank[0:i])
            rw.setLanguage(language)
            rw.setSalesRank(rank)


try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
