# This Python file uses the following encoding: iso-8859-1
# Blackwell [UK] scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setDefaultPublicationPlace("UK")
    rw.setDefaultLanguage("English")
    rw.setCurrencySymbol("&pound;")


    # Find Category
    tag = "class=\"bookLinkBold\""

    if string.find(source, tag) != -1:
        cats = searchFor(source, tag)
        i = string.find(cats, "<br />")
        cats = stripText(cats[0:i])

        ccount = 1

        while (searchFor(cats, "class=\"bookLinkBold\"") != None):
            cats = searchForPlus(cats, "class=\"bookLinkBold\"")
            cats = searchForPlus(cats, "\">")
            i = string.find(cats, "<")
            cat = stripText(cats[0:i])

            if cat == "Home":
                continue

            if cat == "Books":
                continue

            if ccount == 1:
                rw.setCategory1(cat)
            elif ccount == 2:
                rw.setCategory2(cat)
            else:
                rw.setCategory3(cat)
                break

            ccount = ccount + 1


    source = searchForPlus(source, "class=\"container container--50")

    # Find Image
    i = string.find(source, "thumbnail__wrapper")

    if i != -1:
        source = searchForPlus(source, "thumbnail__wrapper")
        source = searchForPlus(source, "src=\"")
        i = string.find(source, "\"")
        image = "https://blackwells.co.uk" + stripText(source[0:i])
        rw.setImage1(image)


    # Find Title
    source = searchForPlus(source, "<h1")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    rw.setTitle(stripText(source[0:i]))


    # Find Author
    tag = "class=\"product__author\""
    i = string.find(source, tag)

    if i != -1:
        authorList = []
        source = searchFor(source, tag)
        i = string.find(source, "</p>")
        authors = stripText(source[0:i])

        while (searchFor(authors, "href=") != None):
            authors = searchForPlus(authors, "href=")
            authors = searchForPlus(authors, ">")
            i = string.find(authors, "<")
            rw.setAuthor(stripText(authors[0:i]))


    # Find Format
    i = string.find(source, "itemprop=\"bookFormat\"")

    if i != -1:
        format = searchForPlus(source, "itemprop=\"bookFormat\"")
        format = searchForPlus(format, ">")
        i = string.find(format, "<")
        rw.setFormat(stripText(format[0:i]))


    # Find List Price
    i = string.find(source, "class=\"product-price--old\"")

    if i != -1:
        value = searchForPlus(source, "class=\"product-price--old\"")
        value = searchForPlus(value, "<strike>")
        i = string.find(value, "<")
        value = stripText(value[0:i])

        i = string.find(value, "&pound;")

        if i != -1:
            value = searchForPlus(value, "&pound;")

        i = string.find(value, "$")

        if i != -1:
            value = searchForPlus(value, "$")

        value = checkValue(value)
        rw.setListPrice(value)


    # Find Price
    i = string.find(source, "class=\"product-price--current\"")

    if i != -1:
        value = searchForPlus(source, "class=\"product-price--current\"")
        value = searchForPlus(value, ">")
        i = string.find(value, "<")
        value = stripText(value[0:i])

        i = string.find(value, "&pound;")

        if i != -1:
            value = searchForPlus(value, "&pound;")

        i = string.find(value, "$")

        if i != -1:
            value = searchForPlus(value, "$")

        value = checkValue(value)
        rw.setItemValue(value)

        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find Comments
    i = string.find(source, ">Synopsis<")

    if i != -1:
        comments = searchForPlus(source, ">Synopsis<")
        comments = searchForPlus(comments, "<section>")
        i = string.find(comments, "</section>")
        comments = stripText(comments[0:i])

        i = string.find(comments, "<p class=\"read-more\">")

        if i != -1:
            comments = stripText(comments[0:i])

        rw.setProductInfo(comments)


    # Find ISBN
    i = string.find(source, ">ISBN:")

    if i != -1:
        isbn = searchForPlus(source, ">ISBN:")
        isbn = searchForPlus(isbn, "itemprop")
        isbn = searchForPlus(isbn, ">")
        i = string.find(isbn, "<")
        rw.setISBN(stripText(isbn[0:i]))


    # Find Publisher
    i = string.find(source, ">Publisher:<")

    if i != -1:
        publisher = searchForPlus(source, ">Publisher:<")
        publisher = searchForPlus(publisher, "itemprop")
        publisher = searchForPlus(publisher, "href")
        publisher = searchForPlus(publisher, "\">")
        i = string.find(publisher, "<")
        rw.setPublisher(stripText(publisher[0:i]))


    # Find Publication date
    i = string.find(source, ">Pub date:<")

    if i != -1:
        date = searchForPlus(source, ">Pub date:<")
        date = searchForPlus(date, "itemprop")
        date = searchForPlus(date, "\">")
        i = string.find(date, "<")
        rw.setReleaseDate(stripText(date[0:i]))


    # Find Dewey Decimal Number
    i = string.find(source, ">DEWEY:<")

    if i != -1:
        dewey = searchForPlus(source, ">DEWEY:<")
        dewey = searchForPlus(dewey, "<td>")
        i = string.find(dewey, "<")
        rw.setDewey(stripText(dewey[0:i]))


    # Find Sales Rank
    i = string.find(source, ">Sales rank:<")

    if i != -1:
        rank = searchForPlus(source, ">Sales rank:<")
        rank = searchForPlus(rank, "<td>")
        i = string.find(rank, "<")
        rw.setSalesRank(stripText(rank[0:i]))


    # Find Pages
    i = string.find(source, ">Number of pages:<")

    if i != -1:
        pages = searchForPlus(source, ">Number of pages:<")
        pages = searchForPlus(pages, "itemprop")
        pages = searchForPlus(pages, ">")
        i = string.find(pages, "<")
        rw.setPages(stripText(pages[0:i]))


    # Find Dimensions
    i = string.find(source, ">Height:<")

    if i != -1:
        height = searchForPlus(source, ">Height:<")
        height = searchForPlus(height, "<td>")
        i = string.find(height, "<")
        height = stripText(height[0:i])

        i = string.find(source, ">Width:<")

        if i != -1:
            width = searchForPlus(source, ">Width:<")
            width = searchForPlus(width, "<td>")
            i = string.find(width, "<")
            width = stripText(width[0:i])

            rw.setDimensions(height + " / " + width)


    # Find Weight
    i = string.find(source, ">Weight:<")

    if i != -1:
        weight = searchForPlus(source, ">Weight:<")
        weight = searchForPlus(weight, "itemprop")
        weight = searchForPlus(weight, ">")
        i = string.find(weight, "<")
        weight = stripText(weight[0:i])
        rw.setWeight(weight)



#
# Blackwells always uses a local price so we have no idea what
# the currency symbol is but we must remove it. Remove 
# non-numeric characters
#
def checkValue(value):
    l = len(value)
    newValue = ""

    for c in value:
        if c == "." or c == ",":
            # Decimal separator, accept
            newValue = newValue + c
            continue
        
        if c < "0" or c > "9":
            # Non numeric, skip
            continue

        # Valid numeric character
        newValue = newValue + c

    return string.strip(newValue)




try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
