# This Python file uses the following encoding: iso-8859-1
# dnb.de scraper
#
# Copyright  1999-2017 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    rw.setCurrencySymbol("[[EUR]]")
    rw.setDefaultPublicationPlace("Germany")
    rw.setDefaultLanguage("German")


    # Find Title
    tag = ">Titel<"
    title = searchForPlus(source, tag)
    title = searchForPlus(title, "<td")
    title = searchForPlus(title, ">")
    i = string.find(title, "<")
    title = stripText(title[0:i])

    i = string.find(title, " : ")

    if i != -1:
        title = stripText(title[0:i])

    rw.setTitle(title)


    # Find Author
    authorList = []
    tag = ">Person(en)<"

    i = string.find(source, tag)

    if i != -1:
        authors = searchFor(source, tag)
        authors = searchFor(authors, "<td")
        authors = searchForPlus(authors, ">")
        i = string.find(authors, "</td>")
        authors = stripText(authors[0:i])
        authorList = []

        i = string.find(authors, "href=\"")
        
        if i != -1:
            while (searchFor(authors, "href=\"") != None):
                authors = searchForPlus(authors, "href=\"")
                authors = searchForPlus(authors, ">")
                i = string.find(authors, "<")
                author = stripText(authors[0:i])

                i = string.find(author, "(Verfasser)")

                if i != -1:
                    # Found author
                    author = stripText(author[0:i])

                i = string.find(author, "(bersetzer)")

                if i != -1:
                    # Found translator
                    rw.setTranslator(stripText(author[0:i]))
                    author = ""

                i = string.find(author, "(Herausgeber)")

                if i != -1:
                    # Found editor
                    rw.setEditor(stripText(author[0:i]))
                    author = ""
            
                if author != "":
                    authorList.append(author)
        else:
            authors = authors + "<br/>"

            while (searchFor(authors, "<br/>") != None):
                i = string.find(authors, "<br/>")
                author = stripText(authors[0:i])
                authors = searchForPlus(authors, "<br/>")

                i = string.find(author, "(Verfasser)")

                if i != -1:
                    # Found author
                    author = stripText(author[0:i])

                i = string.find(author, "(bersetzer)")

                if i != -1:
                    # Found translator
                    rw.setTranslator(stripText(author[0:i]))
                    author = ""

                    i = string.find(author, "(Herausgeber)")

                if i != -1:
                    # Found editor
                    rw.setEditor(stripText(author[0:i]))
                    author = ""
            
                if author != "":
                    authorList.append(author)

        rw.setAuthors(authorList)


    # Find Alternate Title
    tag = ">Werk(e)<"

    i = string.find(source, tag)

    if i != -1:
        title = searchForPlus(source, tag)
        title = searchForPlus(title, "<td")
        title = searchForPlus(title, ">")
        i = string.find(title, "<")
        title = stripText(title[0:i])

    i = string.find(title, "(")

    if i != -1:
        title = stripText(title[0:i])

        rw.setAltTitle(title)


    # Find Format
    tag = ">Ausgabe<"

    i = string.find(source, tag)

    if i != -1:
        format = searchForPlus(source, tag)
        format = searchForPlus(format, "<td")
        format = searchForPlus(format, ">")
        i = string.find(format, "<")
        format = stripText(format[0:i])

        i = string.find(format, "Taschenbuchausgabe")

        if i != -1:
            format = "Taschenbuchausgabe"
        else:
            format = ""

        rw.setFormat(format)


    # Find Publisher
    tag = ">Verlag<"

    i = string.find(source, tag)

    if i != -1:
        publisher = searchForPlus(source, tag)
        publisher = searchForPlus(publisher, "<td")
        publisher = searchForPlus(publisher, ">")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])

        i = string.find(publisher, ":")

        if i != -1:
            place = stripText(publisher[0:i])
            rw.setPublicationPlace(place)
            publisher = stripText(publisher[i+1:])

        rw.setPublisher(publisher)


    # Find Publication date
    tag = ">Zeitliche Einordnung<"

    i = string.find(source, tag)

    if i != -1:
        date = searchForPlus(source, tag)
        date = searchForPlus(date, "<td")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])

        i = string.find(date, ":")

        if i != -1:
            date = stripText(date[i+1:])

        rw.setReleaseDate(date)


    # Find Pages
    tag = ">Umfang/Format<"

    i = string.find(source, tag)

    if i != -1:
        pages = searchForPlus(source, tag)
        pages = searchForPlus(pages, "<td")
        pages = searchForPlus(pages, ">")
        i = string.find(pages, "<")
        pages = stripText(pages[0:i])

        i = string.find(pages, "Seiten")

        if i == -1:
            # No pages, assume dimensions
            rw.setDimensions(pages)
        else:
            i = string.find(pages, ";")

            if i != -1:
                dimensions = stripText(pages[i+1:])
                rw.setDimensions(dimensions)
                pages = stripText(pages[0:i])

            i = string.find(pages, "Seiten")

            if i != -1:
                pages = stripText(pages[0:i])

            rw.setPages(pages)


    # Find ISBN
    isbn = ""
    tag = ">EAN<"

    i = string.find(source, tag)

    if i != -1:
        isbn = searchForPlus(source, tag)
        isbn = searchForPlus(isbn, "<td")
        isbn = searchForPlus(isbn, ">")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])
        rw.setISBN(isbn)


    # Find Language
    tag = ">Sprache(n)<"

    i = string.find(source, tag)

    if i != -1:
        lang = searchForPlus(source, tag)
        lang = searchForPlus(lang, "<td")
        lang = searchForPlus(lang, ">")
        i = string.find(lang, "<")
        lang = stripText(lang[0:i])

        i = string.find(lang, "(")

        if i != -1:
            lang = stripText(lang[0:i])

        rw.setLanguage(lang)


    # Find Category
    tag = ">Sachgruppe(n)<"

    if string.find(source, tag) != -1:
        cats = searchForPlus(source, tag)
        cats = searchForPlus(cats, "<td")
        cats = searchForPlus(cats, ">")
        i = string.find(cats, "<")
        cats = stripText(cats[0:i])
        cats = cats + ";"

        ccount = 1

        while (searchFor(cats, ";") != None):
            i = string.find(cats, ";")
            cat = stripText(cats[0:i])
            cats = searchForPlus(cats, ";")

            if cat == "Books":
                continue

            if ccount == 1:
                rw.setCategory1(cat)
            elif ccount == 2:
                rw.setCategory2(cat)
            else:
                rw.setCategory3(cat)
                break

            ccount = ccount + 1


    #Find images    		
    if isbn != "":
        rw.setImage1("https://portal.dnb.de/opac/mvb/cover.htm?isbn=" + isbn + "&size=m")
        rw.setLargeImage1("https://portal.dnb.de/opac/mvb/cover.htm?isbn=" + isbn)





try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
