# This Python file uses the following encoding: iso-8859-1
# fishpond.com./au scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setDefaultPublicationPlace("Australia")
    rw.setDefaultLanguage("English")
    rw.setCurrencySymbol("$")


    i = string.find(source, ">Search Results for ")

    if i != -1:
        source = searchForPlus(source, ">Search Results for ")
        source = searchForPlus(source, "class=\"productListing-data\"")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)

        t2 = open(rw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()



    # Find List price
    i = string.find(source, "\"maxPrice\":")

    if i != -1:
        listprice = searchForPlus(source, "\"maxPrice\":")
        i = string.find(listprice, "}")
        listprice = stripText(listprice[0:i])
        rw.setListPrice(listprice)


    # Main extraction
    # Find Category
    ccount = 1
    categories = source

    while (searchFor(categories, "class=\"breadcrumbLarge\"") != None):
        categories = searchForPlus(categories, "class=\"breadcrumbLarge\"")
        categories = searchForPlus(categories, "itemprop=\"name\"")
        categories = searchForPlus(categories, ">")
        i = string.find(categories, "<")
        category = stripText(categories[0:i])

        if category == "" or category == "Books" or category == "Home":
            continue

        if ccount == 1:
            rw.setCategory1(category)
        elif ccount == 2:
            rw.setCategory2(category)
        else:
            rw.setCategory3(category)
            break

        ccount = ccount + 1


    # Find Title
    source = searchForPlus(source, "\"@type\":\"Product\"")
    title = searchForPlus(source, "\"name\":\"")
    i = string.find(title, "\"")
    title = stripText(title[0:i])
    rw.setTitle(title)

    if title == None:
        i = string.find(source, "class=\"b-product-info__title\"")
    
        if i != -1:
            title = searchForPlus(source, "class=\"b-product-info__title\"")
            title = searchForPlus(title, ">")
            i = string.find(title, "<")
            title = stripText(title[0:i])
            rw.setTitle(title)


    # Find ISBN
    i = string.find(source, "\"gtin13\":")

    if i != -1:
        isbn = searchForPlus(source, "\"gtin13\":")
        isbn = searchForPlus(isbn, "\"")
        i = string.find(isbn, "\"")
        isbn = stripText(isbn[0:i])
        rw.setISBN(isbn)


    # Find Price
    tag = "\"price\":"
    i = string.find(source, tag)

    if i != -1:
        val = searchForPlus(source, tag)
        i = string.find(val, ",")
        val = stripText(val[0:i])

        if val != "$0.00":
            value = val

        rw.setItemValue(value)
        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find Image
    tag = "\"image\":"
    i = string.find(source, tag)

    if i != -1:
        image = searchForPlus(source, tag)
        image = searchForPlus(image, "\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "no-image")

        if i == -1:
            rw.setImage1(image)


    # Find Rating
    i = string.find(source, ">Average Customer Rating<")

    if i != -1:
        rating = searchForPlus(source, ">Average Customer Rating<")
        rating = searchForPlus(rating, "stars_")
        i = string.find(rating, ".")
        rating = stripText(rating[0:i]) + " Stars"
        rw.setMyRating(rating)


    # Find Edition
    i = string.find(source, "\"bookEdition\":")

    if i != -1:
        edition = searchForPlus(source, "\"bookEdition\":")
        edition = searchForPlus(edition, "\"")
        i = string.find(edition, "\"")
        edition = stripText(edition[0:i])
        rw.setEdition(edition)


    # Find Format
    i = string.find(source, "\"bookFormat\":")

    if i != -1:
        format = searchForPlus(source, "\"bookFormat\":")
        format = searchForPlus(format, "\"")
        i = string.find(format, "\"")
        format = stripText(format[0:i])
        rw.setFormat(format)


    # Find Pages
    i = string.find(source, "\"numberOfPages\":")

    if i != -1:
        pages = searchForPlus(source, "\"numberOfPages\":")
        i = string.find(pages, ",")
        pages = stripText(pages[0:i])
        rw.setPages(pages)


    # Find Language
    i = string.find(source, "\"inLanguage\":")

    if i != -1:
        language = searchForPlus(source, "\"inLanguage\":")
        language = searchForPlus(language, "\"")
        i = string.find(language, "\"")
        language = stripText(language[0:i])
        rw.setLanguage(language)


    # Find Release date
    i = string.find(source, "\"datePublished\":")

    if i != -1:
        date = searchForPlus(source, "\"datePublished\":")
        date = searchForPlus(date, "\"")
        i = string.find(date, "\"")
        date = stripText(date[0:i])
        rw.setReleaseDate(date)


    # Find Author
    tag = "\"author\":"
    i = string.find(source, tag)
    authorList = []

    if i != -1:
        authors = searchForPlus(source, tag)
        authors = searchForPlus(authors, "[")

        i = string.find(authors, "]")
        authors = stripText(authors[0:i])

        while (searchFor(authors, "\"name\":") != None):
            authors = searchForPlus(authors, "\"name\":")
            authors = searchForPlus(authors, "\"")
            i = string.find(authors, "\"")
            author = stripText(authors[0:i])
            authorList.append(author)

        rw.setAuthors(authorList)


    # Find Publisher
    i = string.find(source, "\"publisher\":")

    if i != -1:
        publisher = searchForPlus(source, "\"publisher\":")
        publisher = searchForPlus(publisher, "\"name\":")
        publisher = searchForPlus(publisher, "\"")
        i = string.find(publisher, "\"")
        publisher = stripText(publisher[0:i])
        rw.setPublisher(publisher)


    # Find Dimensions
    i = string.find(source, "\"name\":\"Dimensions\"")

    if i != -1:
        dimensions = searchForPlus(source, "\"name\":\"Dimensions\"")
        dimensions = searchForPlus(dimensions, "\"value\":")
        dimensions = searchForPlus(dimensions, "\"")
        i = string.find(dimensions, "\"")
        dimensions = stripText(dimensions[0:i])
        rw.setDimensions(dimensions)


    # Find Place
    i = string.find(source, "\"location\":")

    if i != -1:
        place = searchForPlus(source, "\"location\":")
        place = searchForPlus(place, "\"")
        i = string.find(place, "\"")
        place = stripText(place[0:i])
        rw.setPublicationPlace(place)


    # Find Reading level
    i = string.find(source, "\"name\":\"Age Range\"")

    if i != -1:
        level = searchForPlus(source, "\"name\":\"Age Range\"")
        level = searchForPlus(level, "\"value\":")
        level = searchForPlus(level, "\"")
        i = string.find(level, "\"")
        level = stripText(level[0:i])

        rw.setReadingLevel(level)


    # Find Comments
    comments = ""
    tag = "\"description\":{"
    i = string.find(source, tag)

    if i != -1:
        comment = searchForPlus(source, tag)
        comment = searchForPlus(comment, "\"value\":\"")
        i = string.find(comment, "\"}")
        comment = stripText(comment[0:i])
        comments = appendComment(comments, comment)

    tag = ">Reviews<"
    i = string.find(source, tag)

    if i != -1:
        review = searchForPlus(source, tag)
        review = searchForPlus(review, ">")
        i = string.find(review, "</div>")
        review = stripText(review[0:i])
        review = "Reviews<br />" + review
        comments = appendComment(comments, review)

    rw.setProductInfo(comments)




try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
