# This Python file uses the following encoding: iso-8859-1
# Flipkart.com book scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setDefaultPublicationPlace("India")
    rw.setDefaultLanguage("English")
    rw.setCurrencySymbol("Rs.")


    # Main extraction
    # Find Image
    i = string.find(source, "id=\"mprodimg-id\"")

    if i != -1:
        images = searchForPlus(source, "id=\"mprodimg-id\"")
        image = searchForPlus(images, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "ImageNA")

        if i != -1:
            image = ""

        if image != "":
            try:
                http = HTTPConnection()
                http.resetReferer();
                http.blockForLoad();
                imgdata = http.getContents(image)
                i = string.find(imgdata, "Adobe")

                if i != -1:
                    image = ""
            except:
                print "Unable to access image"

        rw.setImage1(image)
    else:
        i = string.find(source, "id=\"main-image-id\"")

        if i != -1:
            images = searchForPlus(source, "id=\"main-image-id\"")
            image = searchForPlus(images, "src=\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])

            i = string.find(image, "ImageNA")

            if i == -1:
                rw.setImage1(image)

        i = string.find(source, "img id=\"visible-image-large\"")

        if i != -1:
            images = searchForPlus(source, "img id=\"visible-image-large\"")
            image = searchForPlus(images, "src=\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])

            i = string.find(image, "ImageNA")

            if i == -1:
                i = string.find(image, "ajax-loader")

                if i == -1:
                    rw.setLargeImage1(image)


    # Find Title
    source = searchForPlus(source, "<h1 ")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])

    i = string.rfind(title, "(")

    if i != -1:
        title = stripText(title[0:i])

    rw.setTitle(title)


    # Find Author
    authorList = []
    i = string.find(source, "class=\"secondary-info\"")

    if i != -1:
        authors = searchFor(source, "class=\"secondary-info\"")
        i = string.find(authors, "</div>")
        authors = stripText(authors[0:i])

        while (searchFor(authors, "/author/") != None):
            authors = searchForPlus(authors, "/author/")
            authors = searchForPlus(authors, ">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            authorList.append(author)

    rw.setAuthors(authorList)


    # Find List price
    i = string.find(source, "id=\"fk-mprod-list-id\"")

    if i != -1:
        listprice = searchFor(source, "id=\"fk-mprod-list-id\"")
        listprice = searchForPlus(listprice, "Rs.")
        i = string.find(listprice, "<")
        rw.setListPrice(stripText(listprice[0:i]) + ".00")


    # Find Retail Price (value)
    tag = "\"fk-font-26 pprice"
    i = string.find(source, tag)

    if i == -1:
        tag = "fk-mprod-our-id"
        i = string.find(source, tag)

    if i != -1:
        value = searchFor(source, tag)
        value = searchForPlus(value, "Rs.")
        i = string.find(value, "<")
        rw.setItemValue(value[0:i] + ".00")

        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find ISBN
    i = string.find(source, ">ISBN-13")

    if i != -1:
        isbn = searchForPlus(source, ">ISBN-13")
        isbn = searchForPlus(isbn, "\">")
        i = string.find(isbn, "<")
        rw.setISBN(stripText(isbn[0:i]))


    # Find Format
    i = string.find(source, ">Binding")

    if i != -1:
        format = searchForPlus(source, ">Binding")
        format = searchForPlus(format, "\">")
        i = string.find(format, "<")
        rw.setFormat(stripText(format[0:i]))


    # Find Release date
    i = string.find(source, ">Publication Year")

    if i != -1:
        date = searchForPlus(source, ">Publication Year")
        date = searchForPlus(date, "\">")
        i = string.find(date, "<")
        rw.setReleaseDate(stripText(date[0:i]))


    # Find Publisher
    i = string.rfind(source, ">Publisher")

    if i != -1:
        publisher = stripText(source[i:])
        publisher = searchForPlus(publisher, "\">")
        i = string.find(publisher, "<")
        rw.setPublisher(stripText(publisher[0:i]))


    # Find Pages
    i = string.find(source, ">Number of Pages")

    if i != -1:
        pages = searchForPlus(source, ">Number of Pages")
        pages = searchForPlus(pages, "\">")
        i = string.find(pages, "<")
        pages = stripText(pages[0:i])

        i = string.find(pages, " ")

        if i != -1:
            pages = stripText(pages[0:i])


        rw.setPages(stripText(pages[0:i]))


    # Find Language
    i = string.find(source, ">Language")

    if i != -1:
        language = searchForPlus(source, ">Language")
        language = searchForPlus(language, "\">")
        i = string.find(language, "<")
        rw.setLanguage(stripText(language[0:i]))


    # Find Dimensions
    i = string.find(source, ">Dimensions:")

    if i != -1:
        dimensions = searchForPlus(source, ">Dimensions:")
        dimensions = searchForPlus(dimensions, "<b>")
        i = string.find(dimensions, "<")
        rw.setDimensions(stripText(dimensions[0:i]))


    # Find Weight
    i = string.find(source, ">Weight:")

    if i != -1:
        weight = searchForPlus(source, ">Weight:")
        weight = searchForPlus(weight, "<b>")
        i = string.find(weight, "<")
        rw.setWeight(stripText(weight[0:i]))


    # Find Category
    tag = ">Categories"
    i = string.find(source, tag)

    if i == -1:
        tag = "<b>Category"

    

    if string.find(source, tag) != -1:
        cats = searchForPlus(source, tag)
        i = string.find(cats, "</div>")
        cats = stripText(cats[0:i])

        ccount = 1

        while (searchFor(cats, "href='") != None):
            cats = searchForPlus(cats, "href='")
            cats = searchForPlus(cats, "\">")
            i = string.find(cats, "<")
            cat = stripText(cats[0:i])

            if cat == "Books":
                continue

            if ccount == 1:
                rw.setCategory1(cat)
            elif ccount == 2:
                rw.setCategory2(cat)
            else:
                rw.setCategory3(cat)
                break

            ccount = ccount + 1


    # Find Comments
    comments = ""

    i = string.find(source, "id=\"description\"")

    if i != -1:
        comment = searchForPlus(source, "id=\"description\"")
        comment = searchForPlus(comment, "style=\"float:right\"")
        comment = searchForPlus(comment, "</div>")
        i = string.find(comment, "</div>")
        comment = stripText(comment[0:i])
        comments = appendComment(comments, comment)

    rw.setProductInfo(comments)



try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
