# This Python file uses the following encoding: iso-8859-1
# Google books book scraper
#
# Copyright  1999-2019 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setDefaultPublicationPlace("US")
    rw.setDefaultLanguage("English")
    rw.setCurrencySymbol("$")

    i = string.find(source, "- did not match any documents.")

    if i != -1:
        return

    tag = "<div id=\"res\">"
    i = string.find(source, tag)

    if i != -1:
        # Follow about link
        source = searchForPlus(source, tag)
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.blockForLoad();
        source = http.getContents(url)

        try:
            t = open(rw.getLogsDir() + "trace.html", "w")
            t.write(source)
            t.close()
        except:
            print "Unable to create trace.html"


    tag = "id=\"sidebar-atb-link\""
    i = string.find(source, tag)

    if i != -1:
        # Follow about link
        source = searchForPlus(source, tag)
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.blockForLoad();
        source = http.getContents(url)

        try:
            t = open(rw.getLogsDir() + "trace2.html", "w")
            t.write(source)
            t.close()
        except:
            print "Unable to create trace2.html"


    tag = "id=\"st-card\""
    i = string.find(source, tag)

    if i != -1:
        # Follow about link
        source = searchForPlus(source, tag)
        source = searchFor(source, "href=\"https")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.blockForLoad();
        source = http.getContents(url)

        try:
            t = open(rw.getLogsDir() + "trace2.html", "w")
            t.write(source)
            t.close()
        except:
            print "Unable to create trace2.html"


    # Main extraction
    # Find Image
    i = string.find(source, "<div class=\"bookcover\">")

    if i != -1:
        images = searchForPlus(source, "<div class=\"bookcover\">")
        image = searchForPlus(images, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "&edge=curl")

        if i != -1:
            image = string.replace(image, "&edge=curl", "")
            image = string.replace(image, "&zoom=1", "&zoom=2")
            rw.setImage1(image)
            image = string.replace(image, "&zoom=2", "&zoom=3")
            rw.setLargeImage1(image)
        else:
            rw.setImage1(image)



    # Find Title
    source = searchForPlus(source, "class=\"booktitle\"")
    source = searchForPlus(source, "<span dir=ltr>")
    i = string.find(source, "<")
    title = stripText(source[0:i])

    i = string.rfind(title, "(")

    if i != -1:
        title = stripText(title[0:i])

    rw.setTitle(title)


    # Find Author
    authorList = []
    i = string.find(source, "class=\"bookinfo_sectionwrap\"")

    if i != -1:
        source = searchForPlus(source, "class=\"bookinfo_sectionwrap\"")
        i = string.find(source, "</div>")
        authors = stripText(source[0:i+6])

        while (searchFor(authors, "href=\"") != None):
            authors = searchForPlus(authors, "href=\"")
            authors = searchForPlus(authors, "<span dir=ltr>")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            i = string.rfind(author, "(")

            if i != -1:
                role = stripText(author[i:])
                author = stripText(author[0:i])
                i = string.find(role, ")")
                role = stripText(role[0:i+1])

                if role == "(Illustrator)":
                    rw.setIllustrator(author)
                    author = ""
                elif role == "(Translator)":
                    rw.setTranslator(author)
                    author = ""
                elif role == "(Editor)":
                    rw.setEditor(author)
                    author = ""
                else:
                    author = author + " " + role
                
            if author != "":
                authorList.append(author)

    rw.setAuthors(authorList)


    # Find Format
    i = string.find(source, "itemprop=\"bookFormat\"")

    if i != -1:
        format = searchForPlus(source, "itemprop=\"bookFormat\"")
        format = searchForPlus(format, ">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        rw.setFormat(format)


    # ISBN
    i = string.find(source, ">ISBN")

    if i != -1:
        isbn = searchForPlus(source, ">ISBN")
        isbn = searchForPlus(isbn, "<span dir=ltr>")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])
        i = string.find(isbn, ", ")

        if i != -1:
            isbn = stripText(isbn[i+1:])

        rw.setISBN(isbn)


    # Find Publisher
    i = string.find(source, ">Publisher")

    if i != -1:
        publisher = searchForPlus(source, ">Publisher")
        publisher = searchForPlus(publisher, "<span dir=ltr>")
        i = string.find(publisher, "</span")
        publisher = stripText(publisher[0:i])
        i = string.find(publisher, ", ")

        if i != -1:
            date = stripText(publisher[i+1:])
            rw.setReleaseDate(date)
            publisher = stripText(publisher[0:i])

        rw.setPublisher(publisher)


    # Find Pages
    i = string.find(source, ">Length")

    if i != -1:
        pages = searchForPlus(source, ">Length")
        pages = searchForPlus(pages, "<span dir=ltr>")
        i = string.find(pages, "<")
        pages = stripText(pages[0:i])
        i = string.find(pages, " ")

        if i != -1:
            pages = stripText(pages[0:i])

        rw.setPages(stripText(pages))


    # Series
    i = string.find(source, ">Series:<")

    if i != -1:
        series = searchForPlus(source, ">Series:<")
        series = searchForPlus(series, "href=\"")
        series = searchForPlus(series, ">")
        i = string.find(series, "<")
        rw.setSeries(stripText(series[0:i]))

        number = searchForPlus(source, ">Series:<")
        number = searchForPlus(number, "\">")
        i = string.find(number, "</td>")
        number = stripText(number[0:i])
        i = string.find(number, "#")

        if i != -1:
            number = searchForPlus(number, "#")
            number = stripText(number)
            rw.setSeriesNumber(number)


    # Find Category
    i = string.rfind(source, ">Subjects")

    if i != -1:
        cats = stripText(source[i:])
        i = string.find(cats, "</tr>")
        cats = stripText(cats[0:i])

        ccount = 1

        while (searchFor(cats, "href=\"") != None):
            cats = searchForPlus(cats, "href=\"")
            cats = searchForPlus(cats, "\">")
            i = string.find(cats, "<")
            cat = stripText(cats[0:i])

            if cat.startswith("Fiction") == 1:
                continue

            if cat == "Kindle eBooks":
                continue

            if ccount == 1:
                rw.setCategory1(cat)
            elif ccount == 2:
                rw.setCategory2(cat)
            else:
                rw.setCategory3(cat)
                break

            ccount = ccount + 1



    # Find Comments
    comments = ""

    i = string.find(source, "id=synopsistext")

    if i != -1:
        comment = searchForPlus(source, "id=synopsistext")
        comment = searchForPlus(comment, "\">")
        i = string.find(comment, "</div>")
        comment = stripText(comment[0:i])

        comments = appendComment(comments, comment)

    rw.setProductInfo(comments)




try:
    rw.setBookObject(Book)
    extract(source)

finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
