# This Python file uses the following encoding: iso-8859-1
# bol.it scraper
#
# copied from various sources
#

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setDefaultPublicationPlace("Italia")
    rw.setDefaultLanguage("Italian")
    rw.setCurrencySymbol("[[EUR]]")

    
    i = string.find(source, "id=\"tab_libri\"")

    if i == -1:
        return

    source = searchForPlus(source, "id=\"tab_libri\"")

    # Find Cover Image
    i = string.find(source, "class=\"immagine\"")

    if i != -1:
        image = searchForPlus(source, "class=\"immagine\"")
        image = searchForPlus(image, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        if image[0] == "/":
            image = "http://www.gullivertown.com" + image

        rw.setImage1(image)


    # Find Title
    source = searchForPlus(source, ">Titolo:")
    source = searchForPlus(source, "\">")
    i = string.find(source, "<");
    title = stripText(source[0:i])
    rw.setTitle(title)

    # Find Author
    # author is in an href tag, comma separated authors
    authorList = []

    tag = ">Autore:"

    i = string.find(source, tag)

    if i == -1:
        tag = ">Autori:"
        i = string.find(source, tag)

    if i != -1:
        authors = searchForPlus(source, tag)
        i = string.find(authors, "</tr>")
        authors = stripText(authors[0:i])

        while (searchFor(authors, "class=\"linked_search\"") != None):
           authors = searchForPlus(authors, "class=\"linked_search\"")
           authors = searchForPlus(authors, ">")
           i = string.find(authors, "<")
           author = stripText(authors[0:i])

           # Weird author format last first (no comma, add one)
           i = string.rfind(author, " ")

           if i != -1:
               author = stripText(author[0:i]) + ", " + stripText(author[i:])

           authorList.append(author)

        rw.setAuthors(authorList)


    # Find Pages
    i = string.find(source, "Pagine:")

    if i != -1:
        pages = searchForPlus(source, "Pagine:")
        pages = searchForPlus(pages, "<td>")
        i = string.find(pages, "<")
        pages = stripText(pages[0:i])
        rw.setPages(pages)


    # Find Date
    i = string.find(source, "Anno Edizione:")

    if i != -1:
        date = searchForPlus(source, "Anno Edizione:")
        date = searchForPlus(date, "<td>")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        rw.setReleaseDate(date)


    # Find Publisher
    i = string.find(source, "Editore:")

    if i != -1:
        publisher = searchForPlus(source, "Editore:")
        publisher = searchForPlus(publisher, "<td>")
        publisher = searchForPlus(publisher, "\">")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])
        rw.setPublisher(publisher)


    # Find Series
    i = string.find(source, "Collana:")

    if i != -1:
        series = searchForPlus(source, "Collana:")
        series = searchForPlus(series, "<td>")
        series = searchForPlus(series, "\">")
        i = string.find(series, "<")
        series = stripText(series[0:i])
        rw.setSeries(series)


    # Find ISBN
    i = string.find(source, "Codice EAN 13:")

    if i != -1:
        isbn = searchForPlus(source, "Codice EAN 13:")
        isbn = searchForPlus(isbn, "<td>")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])
        rw.setISBN(isbn)


    # Find Value
    i = string.find(source, "Prezzo Gullivertown:")

    if i != -1:
        value = searchForPlus(source, "Prezzo Gullivertown:")
        value = searchForPlus(value, "<td>")
        value = searchForPlus(value, "class=\"pvp_")
        value = searchForPlus(value, ">")
        i = string.find(value, " ")
        value = stripText(value[0:i])
        rw.setItemValue(value)
        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find List price
    i = string.find(source, "Prezzo Intero:")

    if i != -1:
        value = searchForPlus(source, "Prezzo Intero:")
        value = searchForPlus(value, "<td>")
        value = searchForPlus(value, "\">")
        i = string.find(value, " ")
        value = stripText(value[0:i])
        rw.setListPrice(value)


    # Find Comments
    i = string.find(source, ">Recensione<")

    if i != -1:
        comments = searchForPlus(source, ">Recensione<")
        comments = searchForPlus(comments, "id=\"recensione\"")
        comments = searchForPlus(comments, "\">")
        i = string.find(comments, "</div>")
        comments = stripText(comments[0:i])
        # Unitil 3.02
        comments = string.replace(comments, "\xC3\xA0", "")
        comments = string.replace(comments, "\xC3\xA8", "")
        comments = string.replace(comments, "\xC3\xB9", "")
        rw.setProductInfo(comments)



try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
