# This Python file uses the following encoding: iso-8859-1
# Internet Book Store (IT) scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setDefaultPublicationPlace("Italia")
    rw.setDefaultLanguage("Italian")
    rw.setCurrencySymbol("[[EUR]]")


    # Sometimes ISBN only hidden at top. Try that now,
    # Regular ISBN is at end, I'll try that too, see
    # further down.
    # Find ISBN, first try
    i = string.find(source, "name=\"isbn\"")

    if i != -1:
        isbn = searchForPlus(source, "name=\"isbn\"")
        isbn = searchForPlus(isbn, "value=\"")
        i = string.find(isbn, "\"")
        isbn = stripText(isbn[0:i])
        rw.setISBN(isbn)

    # Find Image
    i = string.find(source, "class=\"nuovo-cover\"")

    if i != -1:
        image = searchForPlus(source, "class=\"nuovo-cover\"")
        i = string.find(image, "</section>")
        image = stripText(image[0:i])

        i = string.find(image, "href=\"")

        if i != -1:
            image = searchForPlus(image, "href=\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])
            rw.setImage1(image)
            rw.setLargeImage1(image)
        else:            
            i = string.find(image, "src=\"")

            if i != -1:
                image = searchForPlus(image, "src=\"")
                i = string.find(image, "\"")
                image = stripText(image[0:i])
                rw.setImage1(image)

    # Find Title
    title = searchFor(source, "class=\"title__text\"")
    title = searchForPlus(title, ">")
    i = string.find(title, "<")
    title = stripText(title[0:i])

    if title == "Libro non presente nel catalogo":
        title = ""
        source = searchFor(source, "force exception")
        source = searchFor(source, "force exception")
        return

    rw.setTitle(title)


    # Find Author
    i = string.find(source, "class=\"nuovo-author\"")

    if i != -1:
        authors = searchForPlus(source, "class=\"nuovo-author\"")
        i = string.find(authors, "</section>")
        authors = stripText(authors[0:i]) + ":"
        authorList = []

        while (searchFor(authors, "class=\"subline__title author__title\"") != None):
            authors = searchForPlus(authors, "class=\"subline__title author__title\"")
            author = searchForPlus(authors, "\">")
            i = string.find(author, "<")
            author = stripText(author[0:i])
            authorList.append(author)

        rw.setAuthors(authorList)


    # Find Price
    i = string.find(source, "'price'")

    if i != -1:
        value = searchForPlus(source, "'price'")
        value = searchForPlus(value, ":")
        value = searchForPlus(value, "'")
        i = string.find(value, "'")
        value = stripText(value[0:i])
        rw.setItemValue(value)
        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find Publisher
    i = string.find(source, "'brand'")

    if i != -1:
        publisher = searchFor(source, "'brand'")
        publisher = searchForPlus(publisher, ":")
        publisher = searchForPlus(publisher, "'")
        i = string.find(publisher, "'")
        publisher = stripText(publisher[0:i])
        rw.setPublisher(publisher)


    # Find Series
    i = string.find(source, "EXACTSERIES")

    if i != -1:
        series = searchFor(source, "EXACTSERIES")
        series = searchForPlus(series, "><b>")
        i = string.find(series, "</b>")
        series = stripText(series[0:i])
        rw.setSeries(series)


    # Find Comments
    comments = ""
    i = string.find(source, "'description':")

    if i != -1:
        comments = searchForPlus(source, "'description':")
        comments = searchForPlus(comments, "'")
        i = string.find(comments, "',")  
        comments = stripText(comments[0:i])
        comments = "Descrizione<br>" + comments

    rw.setProductInfo(comments)


    # Find ISBN
    i = string.find(source, "<strong>EAN:</strong>")

    if i != -1:
        isbn = searchForPlus(source, "<strong>EAN:</strong>")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])
        rw.setISBN(isbn)


    # Find Format
    i = string.find(source, "<b>Pagine:</b>")

    if i != -1:
        format = searchForPlus(source, "<b>Pagine:</b>")
        format = searchForPlus(format, "<span>")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        i = string.find(format, ", ")

        if i != -1:
            format = stripText(format[i+2:])

        rw.setFormat(format)


    # Find Page count
    i = string.find(source, "<b>Pagine:</b>")

    if i != -1:
        pages = searchForPlus(source, "<b>Pagine:</b>")
        pages = searchForPlus(pages, "<span>")
        i = string.find(pages, "<")
        pages = stripText(pages[0:i])
        i = string.find(pages, " p.,")

        if i != -1:
            pages = stripText(pages[0:i])

        rw.setPages(pages)


try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
