# This Python file uses the following encoding: iso-8859-1
# Internet Speculative Fiction Database scraper
#
#

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setDefaultPublicationPlace("US")
    rw.setDefaultLanguage("English")

    i = source.find("class=\"publications\"")

    if i != -1:
        try:
            # We're at a multiple item list.  Select the first item.
            source = searchForPlus(source, "class=\"publications\"")
            source = searchForPlus(source, "href=\"")
            i = source.index("\"")
            source = source[:i]
            http = HTTPConnection()
            http.resetReferer()
            http.blockForLoad()
            source = http.getContents(source)

            t = open(rw.getLogsDir() + "trace2.html", "w")
            t.write(source)
            t.close()
        except ValueError:
            return

    i = source.find("id=\"content\"")

    if i == -1:
        return

    # Find Image
    i = string.find(source, "alt=\"picture\"")

    if i != -1:
        image = stripText(source[i-200:])
        image = searchForPlus(image, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])
        rw.setImage1(image)
        rw.setLargeImage1(image)


    # Find Title
    title = searchForPlus(source, ">Publication:<")
    title = searchForPlus(title, ">")
    i = string.find(title, "<")
    title = stripText(title[0:i])
    print "TITLE=",title

    if title == "":
        title = searchForPlus(source, ">Publication:<")
        title = searchForPlus(title, ">")
        title = searchForPlus(title, ">")
        i = string.find(title, "<")
        title = stripText(title[0:i])
        print "TITLE=",title

    rw.setTitle(title)


    # Find Author
    authorList = []
    tag = ">Author:<"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Authors:<"
        i = string.find(source, tag)

    if i != -1:
        authors = searchForPlus(source, tag)
        i = string.find(authors, "<li>")
        authors = stripText(authors[0:i])
        i = string.find(authors, "<br>")

        if i != -1:
            authors = stripText(authors[0:i])

        while (searchFor(authors, "href=\"") != None):
            authors = searchForPlus(authors, "href=\"")
            authors = searchForPlus(authors, "\">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            authorList.append(author)

    rw.setAuthors(authorList)


    # Find Release date
    i = string.find(source, ">Year:<")

    if i != -1:
        date = searchForPlus(source, ">Year:<")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        rw.setReleaseDate(date)


    # Find Release date
    i = string.find(source, ">Date:<")

    if i != -1:
        date = searchForPlus(source, ">Date:<")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        rw.setReleaseDate(date)


    # Find ISBN
    tag = ">ISBN-13:<"
    i = string.find(source, tag)

    if i == -1:
        tag = ">ISBN:<"
        i = string.find(source, tag)

    if i != -1:
        isbn = searchForPlus(source, tag)
        isbn = searchForPlus(isbn, ">")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])
        i = string.find(isbn, "[")

        if i != -1:
            isbn = stripText(isbn[0:i])

        rw.setISBN(isbn)


    # Find Publisher
    i = string.find(source, ">Publisher:<")

    if i != -1:
        publisher = searchForPlus(source, ">Publisher:<")
        publisher = searchForPlus(publisher, "\">")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])
        rw.setPublisher(publisher)


    # Find Value
    i = string.find(source, ">Price:<")

    if i != -1:
        value = searchForPlus(source, ">Price:<")
        value = searchForPlus(value, ">")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        rw.setListPrice(value)
        rw.setItemValue(value)


    # Find Pages
    i = string.find(source, ">Pages:<")

    if i != -1:
        pages = searchForPlus(source, ">Pages:<")
        pages = searchForPlus(pages, ">")
        i = string.find(pages, "<")
        pages = stripText(pages[0:i])
        rw.setPages(pages)


    # Find Format
    i = string.find(source, ">Format:<")

    if i != -1:
        format = searchForPlus(source, ">Format:<")
        format = searchForPlus(format, "\">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        format = format_convert.get(format, format)
        rw.setFormat(format)


    # Get title information
    i = string.find(source, ">Title Reference:<")

    if i != -1:
        reference = searchForPlus(source, ">Title Reference:<")
        reference = searchForPlus(reference, "href=\"")
        i = string.find(reference, "\"")
        reference = reference[0:i]
        http = HTTPConnection()
        http.resetReferer()
        http.blockForLoad()
        source = http.getContents(reference)

        t = open(rw.getLogsDir() + "trace2.html", "w")
        t.write(source)
        t.close()
        
        # Find Series
        i = string.find(source, ">Series:<")
        if i == -1:
            return
        series = searchForPlus(source, ">Series:<")
        series = searchForPlus(series, "\">")
        i = string.find(series, "<")
        series = stripText(series[0:i])
        rw.setSeries(series)

        # Find Series Number
        i = string.find(source, ">Series Number:<")
        if i == -1:
            return
        seriesnum = searchForPlus(source, ">Series Number:<")
        seriesnum = searchForPlus(seriesnum, ">")
        i = string.find(seriesnum, "<")
        seriesnum = stripText(seriesnum[0:i])
        rw.setSeriesNumber(seriesnum)

format_convert = {
    "hc": "Hardcover",
    "tp": "Paperback",
    "pb": "Paperback"
    }

try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
