# This Python file uses the following encoding: iso-8859-1
# kalahari.com scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setDefaultPublicationPlace("South Africa")
    rw.setDefaultLanguage("English")
    rw.setCurrencySymbol("R")

    i = string.find(source, "There are no results for your search.")

    if i != -1:
        source = searchFor(source, "force exception")
        source = searchFor(source, "force exception")
        return


    #Get detail page, if necessary
    # NO LONGER WORKS WITH AUTO-CATALOG. Site displays Busy processing, then refreshes.
    # We just get the busy page. Drag & Drop only.
    i = string.find(source, "START LOOP THROUGH EACH RESULT")

    if i != -1:
        source = searchForPlus(source, "START LOOP THROUGH EACH RESULT")
        source = searchForPlus(source, "class=\"textmb\"")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\">")
        url = "http://www.kalahari.net/BK/" + stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)


    # Main extraction
    # Find Image
    i = string.find(source, "class=\"product_image\"")

    if i != -1:
        image = searchForPlus(source, "class=\"product_image\"")
        image = searchForPlus(image, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "free-shipping")

        if i == -1:
            rw.setImage1(image)


    # Find Title
    source = searchForPlus(source, "class=\"page_heading\"")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])
    title = string.replace(title, "&quot;", "\"")
    rw.setTitle(title)


    # Find Author
    authorList = []
    i = string.find(source, ">Author:<")

    if i != -1:
        source = searchForPlus(source, ">Author:<")
        i = string.find(source, "\n")
        authors = stripText(source[0:i])

        while (searchFor(authors, "href='") != None):
            authors = searchForPlus(authors, "href='")
            authors = searchForPlus(authors, "'>")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            authorList.append(author)


            if len(authorList) > 0:
                author = authorList[0]

            if len(authorList) > 1:
                author2 = authorList[1]

            if len(authorList) > 2:
                author3 = authorList[2]

            if len(authorList) > 3:
                author4 = authorList[3]

            if len(authorList) > 4:
                author5 = authorList[4]

            if len(authorList) > 5:
                author6 = authorList[5]

        rw.setAuthors(authorList)


    # Find Publisher
    i = string.find(source, ">Publisher:<")

    if i != -1:
        publisher = searchForPlus(source, ">Publisher:<")
        publisher = searchForPlus(publisher, "<dd>")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])
        rw.setPublisher(publisher)


    # Find ISBN
    i = string.find(source, ">ISBN:<")

    if i != -1:
        isbn = searchForPlus(source, ">ISBN:<")
        isbn = searchForPlus(isbn, "<dd>")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])
        rw.setISBN(isbn)


    # Find Pages
    i = string.find(source, ">Pages:<")

    if i != -1:
        pages = searchForPlus(source, ">Pages:<")
        pages = searchForPlus(pages, "<dd>")
        i = string.find(pages, "<")
        pages = stripText(pages[0:i])
        rw.setPages(pages)


    # Find Format
    i = string.find(source, ">Format:<")

    if i != -1:
        format = searchForPlus(source, ">Format:<")
        format = searchForPlus(format, "<dd>")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        rw.setFormat(format)


    # Find List price
    i = string.find(source, "class='list_price'")

    if i != -1:
        listprice = searchForPlus(source, "class='list_price'")
        listprice = searchForPlus(listprice, "'>")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])
        rw.setListPrice(listprice)


    # Find Price
    i = string.find(source, "class='product_pricing'")

    if i != -1:
        value = searchForPlus(source, "class='our_price'")
        value = searchForPlus(value, "'>")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        rw.setItemValue(value)

        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find Comments
    target = ">Long description<"
    i = string.find(source, target)

    if i == -1:
        target = ">Short description<"
        i = string.find(source, target)

    if i != -1:
        source = searchForPlus(source, target)
        source = searchForPlus(source, "\">")
        i = string.find(source, "</div>")
        comments = source[0:i]
        rw.setProductInfo(comments)




try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
