# This Python file uses the following encoding: iso-8859-1
# Libro, Archivos y Bibliotecas scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setDefaultPublicationPlace("Spain")
    rw.setDefaultLanguage("Spanish")
    rw.setCurrencySymbol("[[EUR]]")

    # Old URL?
    i = string.find(source, ">ERROR - URL:")

    if i != -1:
        source = searchForPlus(source, "&WISB-C=")
        i = string.find(source, "&")
        isbn = stripText(source[0:i])

        url = "http://www.mcu.es/webISBN/tituloSimpleDispatch.do?params.forzaQuery=N&params.cdispo=A&params.cisbnExt=" + isbn + "&params.liConceptosExt[0].texto=&params.orderByFormId=1&action=Buscar&language=es&prev_layout=busquedaisbn&layout=busquedaisbn"

        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents("http://www.mcu.es/webISBN/tituloSimpleFilter.do?cache=init&prev_layout=busquedaisbn&layout=busquedaisbn&language=es")

        http = HTTPConnection()
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(rw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()



    # Get detail page is necessary
    i = string.find(source, ">Resultados <strong>")

    if i != -1:
        # Want last ISBN, (volume specific ISBN)  when multiple volumes.
        i = string.rfind(source, "class=\"isbnResultado\"")
        source = stripText(source[i:])
        source = searchForPlus(source, "ISBN ")
        source = searchForPlus(source, " href=\"")
        i = string.find(source, "\"")
        url = "http://www.mcu.es" + stripText(source[0:i])
        url = string.replace(url, " ", "%20")
        url = string.replace(url, "&amp;", "&")
        http = HTTPConnection()
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(rw.getLogsDir() + "trace3.html", "w")
        t2.write(source)
        t2.close()


    source = searchForPlus(source, "class=\"cabInfAd\"")


    # Find ISBN
    i = string.find(source, "ISBN 10:")

    if i != -1:
        source = searchForPlus(source, "ISBN 10:")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        isbn = stripText(source[0:i])
        isbn = string.replace(isbn, "-", "")
        i = string.find(isbn, "&nbsp;")

        if i != -1:
            isbn = stripText(isbn[0:i])

        rw.setISBN(isbn)


    # Find Title
    source = searchForPlus(source, "tulo:")
    source = searchForPlus(source, "<strong>")
    i = string.find(source, "<")
    title = stripText(source[0:i])
    i = string.find(title, "\n: ")

    if i != -1:
        title = stripText(title[0:i]) + " " + stripText(title[i+3:])

    title = string.replace(title, "\n", " ")
    title = string.replace(title, "\t", " ")

    while (searchFor(title, "  ") != None):
        i = string.find(title, "  ")
        title = title[0:i] + title[i+1:]

    rw.setTitle(title)


    # Find Author
    author = ""
    i = string.find(source, "Autor/es:")

    if i != -1:
        authorList = []
        source = searchFor(source, "Autor/es:")
        source = searchFor(source, "<td>")
        i = string.find(source, "</td>")
        authors = stripText(source[0:i])

        while (searchFor(authors, "<span>") != None):
            authors = searchForPlus(authors, "<span>")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])

            i = string.find(author, "(")

            if i != -1:
                author = stripText(author[0:i]) 

            i = string.find(author, ";")

            if i != -1:
                role = stripText(author[i+1:]) 
                author = stripText(author[0:i]) + " (" + role + ")" 

            authorList.append(author)


        rw.setAuthors(authorList)


    # Find Publisher / Place / Date
    i = string.find(source, ">Publicaci")

    if i != -1:
        publisher = ""
        place = ""
        date = ""
        source = searchForPlus(source, ">Publicaci")
        source = searchForPlus(source, "<span>")
        i = string.find(source, "</span>")
        publisher = stripText(source[0:i])
        i = string.find(publisher, "<a ")

        if i != -1:
            j = string.find(publisher[i:], ">")
            publisher = publisher[0:i] + publisher[i+j+1:]
            publisher = string.replace(publisher, "</a>", "")

        i = string.find(publisher, ",&nbsp;")

        if i != -1:
            date = stripText(publisher[i+7:])
            publisher = stripHTML(publisher[0:i])

            i = string.find(date, "<")

            if i != -1: 
                date = stripText(date[0:i])

        i = string.find(publisher, ".\n")

        if i != -1:
            place = stripText(publisher[0:i])
            publisher = stripText(publisher[i+2:])

        i = string.find(publisher, "&nbsp;:")

        if i != -1:
            place = stripText(publisher[0:i])
            publisher = stripText(publisher[i+7:])

        i = string.find(publisher, "<")

        if i != -1: 
            publisher = stripText(publisher[0:i])

        i = string.find(place, "<")

        if i != -1: 
            place = stripText(place[0:i])

        rw.setPublisher(publisher)
        rw.setPublicationPlace(place)
        rw.setReleaseDate(date)


    # Find Page / Dimensions
    pages = ""
    dimensions = ""
    i = string.find(source, ">Descripc")

    if i != -1:
        source = searchForPlus(source, ">Descripc")
        source = searchForPlus(source, "<td>")
        i = string.find(source, "</td>")
        pages = stripText(source[0:i])

        i = string.find(pages, " p. ")

        if i != -1:
            dimensions = stripText(pages[i+3:])
            pages = stripText(pages[0:i])

        if pages.endswith("v.") == 1:
            pages = ""

        i = string.find(pages, " ")

        if i != -1:
            pages = stripText(pages[0:i])

        rw.setPages(pages)
        rw.setDimensions(dimensions)


    # Find Format
    i = string.find(source, ">Encuadernac")

    if i != -1:
        source = searchForPlus(source, ">Encuadernac")
        source = searchForPlus(source, "<td>")
        i = string.find(source, "</td>")
        format = stripText(source[0:i])
        rw.setFormat(format)


    # Find Value
    i = string.find(source, "Precio:")

    if i != -1:
        value = searchForPlus(source, "Precio:")
        value = searchForPlus(value, "<td>")
        i = string.find(value, "</td>")
        value = stripText(value[0:i])
        value = string.replace(value, "&euro;", "")
        value = string.replace(value, "Euros", "")
        rw.setItemValue(value[0:i])

        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find Category
    i = string.find(source, "Materia/s:")

    if i != -1:
        category = ""
        dewey = ""

        source = searchForPlus(source, "Materia/s:")
        source = searchForPlus(source, "<span>")
        i = string.find(source, "</span>")
        category = stripText(source[0:i])

        if category.startswith("<a ") == 1:
            category = searchForPlus(category, ">")    
            i = string.find(category, "<")
            category = stripText(category[0:i])

        i = string.find(category, " - ")

        if i != -1:
            dewey = stripText(category[0:i])
            category = stripText(category[i+2:])

        rw.setCategory1(category)
        rw.setDewey(dewey)



try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
