# This Python file uses the following encoding: iso-8859-1
# nolau.com scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment
from    rwsupport import calcISBN10CheckDigit

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setDefaultPublicationPlace("Australia")
    rw.setDefaultLanguage("English")
    rw.setCurrencySymbol("$")

    # Site does not list format, as library assume hardcover
    rw.setFormat("Hardcover")


    i = string.find(source, "did not match any resources in the Catalogue.<")

    if i != -1:
        isbn = searchForPlus(source, "isn:")
        i = string.find(source, "\"")
        isbn = stripText(isbn[0:i])

        if isbn.startswith("978"):
            isbn = stripText(isbn[3:])
            isbn = stripText(isbn[0:9])
            isbn = calcISBN10CheckDigit(isbn)
        
            http = HTTPConnection()
            http.resetReferer();
            http.blockForLoad();
            source = http.getContents("http://catalogue.nla.gov.au/Search/Home?lookfor=" + isbn + "&type=isn&limits=format%3ABook&submit=Find")

            t2 = open(rw.getLogsDir() + "trace2.html", "w")
            t2.write(source)
            t2.close()


    i = string.find(source, "<div class=\"resultitem\">")

    if i != -1:
        source = searchForPlus(source, "<div class=\"resultitem\">")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = "http://catalogue.nla.gov.au" + stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)

        t2 = open(rw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()



    i = string.find(source, ">Librarian's View")

    if i != -1:
        librarian = stripText(source[i-150:])
        librarian = searchForPlus(librarian, "href=\"")
        i = string.find(librarian, "\"")
        url = "http://catalogue.nla.gov.au" + stripText(librarian[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        librarian = http.getContents(url)

        t2 = open(rw.getLogsDir() + "trace3.html", "w")
        t2.write(librarian)
        t2.close()

        i = string.find(librarian, ">082<")

        if i != -1:
            librarian = searchForPlus(librarian, ">082<")
            librarian = searchForPlus(librarian, "class=\"subfield\"")
            librarian = searchForPlus(librarian, "</strong>")
            i = string.find(librarian, "<")
            rw.setDewey(stripText(librarian[0:i]))



    # Find Title
    source = searchForPlus(source, "class=\"header_title\"")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])

    i = string.find(title, "  ")

    if i != -1:
        title = stripText(title[0:i])

    i = string.rfind(title, " / ")

    if i != -1:
        title = stripText(title[0:i])

    rw.setTitle(title)


    # Find Author
    author = ""
    i = string.find(source, "<th>Author</th>")

    if i != -1:
        source = searchForPlus(source, "<th>Author</th>")
        source = searchForPlus(source, "<td")
        source = searchForPlus(source, ">")
        source = stripText(source)
        i = string.find(source, "</td>")
        author = stripText(source[0:i])
        i = string.find(author, "<a ")

        if i != -1:
            author = searchForPlus(author, "<a ")
            author = searchForPlus(author, "\">")
            i = string.find(author, "<")
            author = stripText(author[0:i])

            if string.find(author, ", ") != string.rfind(author, ", "):
                i = string.rfind(author, ", ")

                if (i != -1):
                    author = stripText(author[0:i])


        if author == "<br />":
            author = ""


    if author == "":
        i = string.find(source, ">Other Authors")

        if i != -1:
            tempdata = searchForPlus(source, ">Other Authors")
            tempdata = searchForPlus(tempdata, "<td")
            tempdata = searchForPlus(tempdata, ">")
            tempdata = stripText(tempdata)

            if tempdata.startswith("<a "):
                tempdata = searchForPlus(tempdata, "\">")

            i = string.find(tempdata, "<")
            author = stripText(tempdata[0:i])

            if string.find(author, ", ") != string.rfind(author, ", "):
                i = string.rfind(author, ", ")

                if (i != -1):
                    author = stripText(author[0:i])

        else:
            author = "No Author"

    rw.setAuthor(author)


    # Find Publication Data
    source = searchForPlus(source, ">Description<")
    source = searchForPlus(source, "<td")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    pubdata = stripText(source[0:i])

    i = string.find(pubdata, ":")

    if (i != -1):
        place = stripText(pubdata[0:i])
        rw.setPublicationPlace(place)
        pubdata = pubdata[i+1:]

    i = string.find(pubdata, ",")

    if (i == -1):
        publisher = pubdata
        rw.setPublisher(publisher)
    else:
        publisher = stripText(pubdata[0:i])
        rw.setPublisher(publisher)
        date = stripText(pubdata[i+1:])
        rw.setReleaseDate(date)

    i = string.find(place, "[")

    if (i != -1):
        place = stripText(place[i+1:])

    i = string.find(place, "]")

    if (i != -1):
        place = stripText(place[0:i])
        rw.setPublicationPlace(place)

    i = string.find(date, "[")

    if (i != -1):
        date = stripText(date[i+1:])
        rw.setReleaseDate(date)

    i = string.find(date, "]")

    if (i != -1):
        date = stripText(date[0:i])
        rw.setReleaseDate(date)

    i = string.find(date, ".")

    if (i != -1):
        date = stripText(date[0:i])
        rw.setReleaseDate(date)

    i = string.find(date, ",")

    copyDate = ""

    if (i != -1):
        copyDate = stripText(date[i+1:])
        date = stripText(date[0:i])
        rw.setReleaseDate(date)
        rw.setCopyrightDate(copyDate)

    i = string.find(copyDate, "c")

    if (i != -1):
        copyDate = stripText(copyDate[i+1:])
        rw.setCopyrightDate(copyDate)

    i = string.find(date, "c")

    if (i != -1):
        date = stripText(date[i+1:])
        rw.setReleaseDate(date)


    # Find Pages/Dimensions
    source = searchForPlus(source, "<br />")
    i = string.find(source, "<")
    descdata = stripText(source[0:i])

    i = string.find(descdata, ";")

    if (i == -1):
        pages = descdata
    else:
        pages = stripText(descdata[0:i])
        dimensions = stripText(descdata[i+1:])
        rw.setDimensions(dimensions)

    i = string.find(pages, " ")

    if i != -1:
        pages = stripText(pages[0:i])

    i = string.find(pages, ",")

    if i != -1:
        pages = stripText(pages[i+1:])

    pages = string.replace(pages, "p.", "")
    rw.setPages(pages)


    # Find ISBN
    i = string.find(source, ">ISBN<")

    if i != -1:
        source = searchForPlus(source, ">ISBN<")
        source = searchForPlus(source, "<td")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        isbn = stripText(source[0:i])

        i = string.find(isbn, " ")

        if (i != -1):
            isbn = stripText(isbn[0:i])

        i = string.find(isbn, "&nbsp;")

        if (i != -1):
            isbn = stripText(isbn[0:i])

        rw.setISBN(isbn)


    # Find Comments
    i = string.find(source, ">Summary<")
    comments = ""

    if i != -1:
        comment = searchForPlus(source, ">Summary<")
        comment = searchForPlus(comment, "<td")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "</td>")
        comments = stripText(comment[0:i])


    i = string.find(source, ">Notes<")

    if (i != -1):
        comment = searchForPlus(source, ">Notes<")
        comment = searchForPlus(comment, "<td")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "</td>")
        comment = stripText(comment[0:i])
        comments = appendComment(comments, comment)

    rw.setProductInfo(comments)


    # Find Category
    i = string.find(source, ">Genre<")

    if i != -1:
        source = searchForPlus(source, ">Genre<")
        source = searchForPlus(source, "<td")
        source = searchForPlus(source, ">")
        i = string.find(source, "</td>")
        category = stripText(source[0:i])

        if category.startswith("<a "):
            category = searchForPlus(category, "\">")
            i = string.find(category, "<")
            category = stripText(category[0:i])

        rw.setCategory1(category)
    else:
        i = string.find(source, ">Subjects<")

        if i != -1:
            source = searchForPlus(source, ">Subjects<")
            source = searchForPlus(source, "<td")
            source = searchForPlus(source, ">")
            i = string.find(source, "</tr>")
            cats = stripText(source[0:i])

            ccount = 1
        
            while (searchFor(cats, "href=") != None):
                cats = searchForPlus(cats, "href=")
                cats = searchForPlus(cats, ">")
                i = string.find(cats, "<")
                cat = stripText(cats[0:i])

                if ccount == 1:
                    rw.setCategory1(cat)
                elif ccount == 2:
                    rw.setCategory2(cat)
                else:
                    rw.setCategory3(cat)
                    break

                ccount = ccount + 1



    # Find call number
    i = string.find(source, ">Call Number:<")

    if i != -1:
        source = searchForPlus(source, ">Call Number:<")
        source = searchForPlus(source, "<TD")
        source = searchForPlus(source, ">")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        callnumber = stripText(source[0:i])





try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
