# This Python file uses the following encoding: iso-8859-1
# proxis.be.scraper
# this one is funny. proxis operates in English, French and Dutch
# we will try to make it work in any langage.....
#

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


# remove any <a> tags, keeping everything else
# assume PRE<a href="xxx">yyy</a>POST
# This returns PREyyyPOST
def removeAtags(str):

    cat = ""
    while (str != None):
        # save anything before
        tag = "<a"
        i = string.find(str, tag)
        if i == -1:
            tag = "<A"
            i = string.find(str, tag)
        if i == -1:
            cat = cat + str
            return cat
        else:
            if i > 0:
                cat = cat + str[:i]
                str = searchForPlus(str, tag)

        # move marker to "inside"
        tag = ">"
        i = string.find(str, tag)
        if i == -1:
            return cat
        else:
            str = searchForPlus(str, tag)

        tag = "</a>"
        i = string.find(str, tag)
        if i == -1:
            tag = "</A>"
            i = string.find(str, tag)
        if i == -1:
            return cat
        else:
            cat = cat + str[:i]
            str = searchForPlus(str, tag)


def translate_nl(str):
    str = string.replace (str, "Literatuur", "Literature")
    str = string.replace (str, "Literaire romans", "Literature")
    str = string.replace (str, "Vertaalde", "Translated")
    str = string.replace (str, "Romans", "Novels")
    str = string.replace (str, "Verhalen", "Stories")
    str = string.replace (str, "Recht", "Law")
    str = string.replace (str, "Computers & informatica", "IT")
    str = string.replace (str, "Geschiedeniswetenschappen", "History of Science")
    str = string.replace (str, "Geschiedenis", "History")
    str = string.replace (str, "Pocket", "Mass Market Paperback")
    str = string.replace (str, "Populaire pockets", "Popular Reading")
    return string.strip(str);


def extract(source):
    # Defaults
    rw.setDefaultPublicationPlace("Netherlands")
    rw.setDefaultLanguage("Dutch")
    rw.setCurrencySymbol("[[EUR]]")


    # Find Cover Image
    tag = "<!-- product img-->"
    i = string.find(source, tag)

    if i != -1:
        image = searchForPlus(source, tag)
        image = searchForPlus(image, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])
        rw.setImage1(image)


    # Find Title
    tag = "id=\"pb-left-column\""
    i = string.find(source, tag);

    if i == -1:
        print "can't find TITLE"
        return

    title = searchForPlus(source, tag)
    title = searchForPlus(title, "<h1>")
    i = string.find(title, "</h1>");
    title = stripText(title[0:i])
    rw.setTitle(title)


    # Find Author
    i = string.find(source, "/boeken/auteur-val_");
    
    if i != -1:
        # Find Author
        author = searchForPlus(source, "/boeken/auteur-val_")
        author = searchForPlus(author, ">")
        i = string.find(author, "<");
        author = stripText(author[0:i])
        rw.setAuthor(author)


    # Find Value
    tag = "class=\"our_price_display price\""
    i = string.find(source, tag)

    if i != -1:
        value = searchForPlus(source, tag)
        value = searchForPlus(value, ">")
        i = string.find(value, "<")
        value = stripText(value[0:i])

        i = string.find(value, " ")

        if i != -1:
            value = stripText(value[0:i])

        rw.setItemValue(value)
        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find list price
    tag = "id=\"old_price_display price\""
    i = string.find(source, tag)

    if i != -1:
        value = searchForPlus(source, tag)
        value = searchForPlus(value, ">")
        i = string.find(value, "<")
        value = stripText(value[0:i])

        i = string.find(value, " ")

        if i != -1:
            value = stripText(value[0:i])

        rw.setListPrice(value)


    # Find comments
    tag = "class=\"short_description_content2\""
    i = string.find(source, tag)

    if i != -1:
        comments = searchForPlus(source, tag)
        comments = searchForPlus(comments, "\">")
        i = string.find(comments, "</div>")
        comments = stripText(comments[0:i])
        rw.setProductInfo(comments)


    # Find ISBN
    tag = "productReference ="
    i = string.find(source, tag)

    if i != -1:
        isbn = searchForPlus(source, tag)
        isbn = searchForPlus(isbn, "'")
        i = string.find(isbn, "'")
        isbn = stripText(isbn[0:i])

        i = string.find(isbn, "978")

        if i != -1:
            isbn = stripText(isbn[i:])


        rw.setISBN(isbn)


    # Find Comments
    tag = "<!-- full description -->"
    i = string.find(source, tag)

    if i != -1:
        comment = searchForPlus(source, tag)
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "</div>")
        comment = stripText(comment[0:i])
        rw.setProductInfo(comment)


    # Find Author
    tag = ">Auteur / illustrator<"
    i = string.find(source, tag)

    if i != -1:
        author = searchForPlus(source, tag)
        author = searchForPlus(author, "\">")
        i = string.find(author, "<")
        author = stripText(author[0:i])
        rw.setAuthor(author)


    # Find Series
    tag = ">Reeks<"
    i = string.find(source, tag)

    if i != -1:
        series = searchForPlus(source, tag)
        series = searchForPlus(series, "\">")
        i = string.find(series, "<")
        series = stripText(series[0:i])
        rw.setSeries(series)


    # Find Format
    tag = ">Uitvoering<"
    i = string.find(source, tag)

    if i != -1:
        format = searchForPlus(source, tag)
        format = searchForPlus(format, "\">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        rw.setFormat(format)


    # Find Publisher
    tag = ">Uitgever<"
    i = string.find(source, tag)

    if i != -1:
        publisher = searchForPlus(source, tag)
        publisher = searchForPlus(publisher, ">")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])
        rw.setPublisher(publisher)


    # Find Release date
    tag = ">Herpulicatie datum<"
    i = string.find(source, tag)

    if i != -1:
        date = searchForPlus(source, tag)
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        rw.setReleaseDate(date)


    # Find Alternate title
    tag = ">Originele titel<"
    i = string.find(source, tag)

    if i != -1:
        title = searchForPlus(source, tag)
        title = searchForPlus(title, ">")
        i = string.find(title, "<")
        title = stripText(title[0:i])
        rw.setAltTitle(title)


    # Find Pages
    tag = ">Pagina"
    i = string.find(source, tag)

    if i != -1:
        pages = searchForPlus(source, tag)
        pages = searchForPlus(pages, ">")
        i = string.find(pages, "<")
        pages = stripText(pages[0:i])
        rw.setPages(pages)


    # Find Dimensions
    tag = ">Width<"
    i = string.find(source, tag)

    if i != -1:
        dimensions = searchForPlus(source, tag)
        dimensions = searchForPlus(dimensions, ">")
        i = string.find(dimensions, "<")
        dimensions = stripText(dimensions[0:i])
        rw.setDimensions(dimensions)


    # Find Category
    tag = ">Genre<"
    i = string.find(source, tag)

    if i != -1:
        category = searchForPlus(source, tag)
        category = searchForPlus(category, "\">")
        i = string.find(category, "<")
        category = stripText(category[0:i])
        rw.setCategory1(category)





try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
