# This Python file uses the following encoding: iso-8859-1
# williamdam.dk scraper
#
# Copyright  1999-2014 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment
from    rwsupport import calcISBN10CheckDigit

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setDefaultublicationPlace("Denmark")
    rw.setDefaultLanguage("Danish")
    rw.setCurrencySymbol("DKK")

    i = string.find(source, ">Viser <")

    if i != -1:
        # Search results page, follow link
        source = searchForPlus(source, ">Viser <")
        source = searchForPlus(source, "class=\"main\"")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.blockForLoad();
        source = http.getContents(url)
        
        try:
            t = open(rw.getLogsDir() + "trace2.html", "w")
            t.write(source)
            t.close()
        except:
            print "Unable to create trace.html"


    # Main extraction
    source = searchFor(source, "class=\"midbox_contents\"")


    # Find Image
    i = string.find(source, "<img border=\"0\"")
    print "I=",i

    if i != -1 and i < 2500:
        image = searchForPlus(source, "<img border=\"0\"")
        image = searchForPlus(image, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])
        image =  string.replace(image, " ", "%20")

        rw.setImage1(image)


    # Find Large Image
    i = string.find(source, "class=\"fancybox\"")

    if i != -1:
        image = searchForPlus(source, "class=\"fancybox\"")
        image = searchForPlus(image, "href=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])
        image =  string.replace(image, " ", "%20")

        rw.setLargeImage1(image)


    # Find Title
    source = searchForPlus(source, "<h1>")
    title = searchForPlus(source, "\">")
    i = string.find(title, "<")
    title = stripText(title[0:i])

    rw.setTitle(title)


    # Find Author
    i = string.find(source, ">Forfatter:")

    if i != -1:
        author = searchForPlus(source, ">Forfatter:")
        author = searchForPlus(author, "href=")
        author = searchForPlus(author, "\">")
        i = string.find(author, "<")
        author = stripText(author[0:i])

        rw.setAuthor(author)


    # Find Illustrator
    i = string.find(source, ">Tegninger:")

    if i != -1:
        author = searchForPlus(source, ">Tegninger:")
        author = searchForPlus(author, ">")
        i = string.find(author, "<")
        author = stripText(author[0:i])

        rw.setIllustrator(author)


    # Find ISBN
    i = string.find(source, ">ISBN")

    if i != -1:
        isbn = searchForPlus(source, ">ISBN")
        isbn = searchForPlus(isbn, ">")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])
        rw.setISBN(isbn)


    # Find Publisher
    i = string.find(source, ">Forlag:")

    if i != -1:
        publisher = searchForPlus(source, ">Forlag:")
        publisher = searchForPlus(publisher, ">")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])
        rw.setPublisher(publisher)


    # Find Format
    i = string.find(source, ">Indbinding:")

    if i != -1:
        format = searchForPlus(source, ">Indbinding:")
        format = searchForPlus(format, ">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        rw.setFormat(format)


    # Find Release date
    i = string.find(source, ">Udgivelsesdato:")

    if i != -1:
        date = searchForPlus(source, ">Udgivelsesdato:")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        rw.setReleaseDate(date)
    else:
        i = string.find(source, ">Trykt i:")

        if i != -1:
            date = searchForPlus(source, ">Trykt i:")
            date = searchForPlus(date, ">")
            i = string.find(date, "<")
            date = stripText(date[0:i])
            rw.setReleaseDate(date)


    # Find Series
    i = string.find(source, ">Serie:")

    if i != -1:
        series = searchForPlus(source, ">Serie:")
        series = searchForPlus(series, ">")
        i = string.find(series, "<")
        series = stripText(series[0:i])
        rw.setSeries(series)


    # Find Series number
    i = string.find(source, ">Nr i serie:")

    if i != -1:
        series = searchForPlus(source, ">Nr i serie:")
        series = searchForPlus(series, ">")
        i = string.find(series, "<")
        series = stripText(series[0:i])
        rw.setSeriesNumber(series)


    # Find Pages
    i = string.find(source, ">Sider:")

    if i != -1:
        pages = searchForPlus(source, ">Sider:")
        pages = searchForPlus(pages, ">")
        i = string.find(pages, "<")
        pages = stripText(pages[0:i])
        rw.setPages(pages)


    # Find Language
    i = string.find(source, ">Sprog:")

    if i != -1:
        lang = searchForPlus(source, ">Sprog:")
        lang = searchForPlus(lang, ">")
        i = string.find(lang, "<")
        lang = stripText(lang[0:i])

        rw.setLanguage(lang)


    # Find Dimensions
    i = string.find(source, ">Ml:")

    if i != -1:
        dim = searchForPlus(source, ">Ml:")
        dim = searchForPlus(dim, ">")
        i = string.find(dim, "<")
        dim = stripText(dim[0:i])

        rw.setDimensions(dim)


    # Find Value
    i = string.find(source, "name=\"cart_quantity\"")

    if i != -1:
        value = searchForPlus(source, "name=\"cart_quantity\"")
        value = searchForPlus(value, "class=\"overskrift5\"")
        value = searchForPlus(value, ">")
        i = string.find(value, "<")
        value = stripText(value[0:i])

        rw.setItemValue(value)
        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find Book Info
    i = string.find(source, "class=\"products_description\"")

    if i != -1:
        info = searchForPlus(source, "class=\"products_description\"")
        info = searchForPlus(info, "\">")
        i = string.find(info, "</div><br>")
        info = stripText(info[0:i])

        rw.setProductInfo(info)


    # Find Keywords
    info = ""
    i = string.find(source, ">Emne: <")

    if i != -1:
        keywords = ""
        temp = searchForPlus(source, ">Emne: <")
        i = string.find(temp, "<br/>")
        info = stripText(temp[i+5:])
        temp = stripText(temp[0:i])

        while (searchFor(temp, "class='lnk'") != None):
            temp = searchForPlus(temp, "class='lnk'")
            temp = searchForPlus(temp, "\">")
            i = string.find(temp, "<")
            keyword = stripText(temp[0:i])

            if keywords == "":
                keywords = keyword
            else:
                keywords = keywords + ", " + keyword

        rw.setKeywords(keywords)

        i = string.find(info, "</div>")
        info = stripText(info[0:i])
        info = string.replace(info, "[...]", "")
        info = string.replace(info, "  ", " ")
        rw.setProductInfo(info)




def cleanupData(str):
    str = string.replace(str, "\xC3\x84", "\xC4")
    str = string.replace(str, "\xC3\x85", "\xC5")
    str = string.replace(str, "\xC3\x96", "\xD6")
    str = string.replace(str, "\xC3\xA4", "\xE4")
    str = string.replace(str, "\xC3\xA5", "\xE5")
    str = string.replace(str, "\xC3\xB6", "\xF6")
    str = string.replace(str, "\xC5\x8D", "\xF6")
    return str    




try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
