# This Python file uses the following encoding: iso-8859-1
# waterstones.co.uk scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setDefaultPublicationPlace("UK")
    rw.setDefaultLanguage("English")
    rw.setCurrencySymbol("")

    i = string.find(source, "<!-- Start Of Search Results -->")

    if i != -1:
        # Search results, get detail
        source = searchForPlus(source, "<!-- Start Of Search Results -->")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        source = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(source)

        try:
            t2 = open(rw.getLogsDir() + "trace2.html", "w")
            t.write(source)
            t.close()
        except:
            print "Unable to create trace2.html"




    # Find Category
    i = string.find(source, ">This book can be found in:<")

    if i != -1:
        source = searchForPlus(source, ">This book can be found in:<")
        i = string.find(source, "</div>")
        categories = stripText(source[0:i])
        index = 1

        while (searchFor(categories, "href=") != None):
            categories = searchForPlus(categories, "href=")
            categories = searchForPlus(categories, ">")
            i = string.find(categories, "<")
            temp = stripText(categories[0:i])

            if index == 1:
                rw.setCategory1(temp)
            elif index == 2:
                rw.setCategory2(temp)
            elif index == 3:
                rw.setCategory3(temp)

            index = index + 1


    source = searchForPlus(source, "itemtype=\"http://schema.org/Book\"")


    # Find Image
    i = string.find(source, "itemprop=\"image\"")

    if i != -1:
        source = searchForPlus(source, "itemprop=\"image\"")
        source = searchForPlus(source, " src=\"")
        i = string.find(source, "\"")
        image = stripText(source[0:i])

        i = string.find(image, "noimage.gif")

        if i == -1:
            rw.setImage1(image)


    # Find Title
    source = searchForPlus(source, "class=\"book-title\"")
    source = searchForPlus(source, "\">")
    i = string.find(source, "<")
    rw.setTitle(stripText(source[0:i]))


    # Find Author
    i = string.find(source, "itemprop=\"author\"")

    if i != -1:
        source = searchForPlus(source, "itemprop=\"author\"")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        rw.setAuthor(stripText(source[0:i]))



    # Find List price
    i = string.find(source, "class=\"price-rrp\"")

    if i != -1:
        listprice = searchForPlus(source, "class=\"price-rrp\"")
        listprice = searchForPlus(listprice, ">")
        i = string.find(listprice, "<")
        rw.setListPrice(stripText(listprice[0:i]))


    # Find Price
    i = string.find(source, "itemprop=\"price\"")

    if i != -1:
        value = searchForPlus(source, "itemprop=\"price\"")
        value = searchFor(value, ">")
        i = string.find(value, "<")
        rw.setItemValue(stripText(value[0:i]))

        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find Format
    i = string.find(source, "itemprop=\"bookFormat\"")

    if i != -1:
        format = searchForPlus(source, "itemprop=\"bookFormat\"")
        format = searchForPlus(format, ">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        rw.setFormat(format)


    # Find Publication date
    i = string.find(source, "itemprop=\"datePublished\"")

    if i != -1:
        date = searchForPlus(source, "itemprop=\"datePublished\"")
        date = searchForPlus(date, ">")

        if date.startswith("<strong") == 1:
            date = searchForPlus(date, ">")

        i = string.find(date, "<")
        rw.setReleaseDate(stripText(date[0:i]))


    # Find Comments
    i = string.find(source, "data-tab=\"synopsis\"")

    if i != -1:
        comments = searchForPlus(source, "data-tab=\"synopsis\"")
        comments = searchForPlus(comments, "itemprop=\"description\"")
        comments = searchForPlus(comments, "<p")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</div>")
        comments = stripText(comments[0:i])
        rw.setProductInfo(comments)


    # Find Publisher
    i = string.find(source, ">Publisher:")

    if i != -1:
        publisher = searchForPlus(source, ">Publisher:")
        publisher = searchForPlus(publisher, "\">")
        i = string.find(publisher, "<")
        rw.setPublisher(stripText(publisher[0:i]))


    # Find ISBN
    i = string.find(source, "ISBN:")

    if i != -1:
        isbn = searchForPlus(source, "ISBN:")
        isbn = searchForPlus(isbn, "\">")
        i = string.find(isbn, "<")
        rw.setISBN(stripText(isbn[0:i]))


try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
