# This Python file uses the following encoding: iso-8859-1
# Amazon US, UK, CA video scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    vw.setDefaultPlace("Australia")
    vw.setDefaultRegion("Region 4")
    vw.setDefaultLanguage("English")
    vw.setCurrencySymbol("$")
    siteurl = "https://www.amazon.com.au"

    cSymbol = "$"


    tag = "<div class=\"fastTrack\">This item is currently not available.</div>"

    i = string.find(source, tag)

    if i != -1:
        # Amazon returning not found, try again
        source = searchForPlus(source, "\"searchKeywords\":")
        source = searchForPlus(source, "\"")
        i = string.find(source, "\"")
        isbn = stripText(source[0:i])
        url = "http://www.amazon.com/s/ref=nb_ss?url=search-alias%3Daps&field-keywords=" + isbn
        print "New url=",url
        http = HTTPConnection()
        
        #try:
        #    http.setGenericUserAgent()
        #except:
        #    print "Unable to set UA"

        http.blockForLoad();
        source = http.getContents(url)
        c = 0

        while (string.find(source, "HTTP response code: 503") != -1):
            print "Sleeping",c,"..."
            time.sleep(5)
            source = http.getContents(url)

            c = c + 1

            if c > 3:
                break
        
        try:
            t = open(rw.getLogsDir() + "trace1a.html", "w")
            t.write(source)
            t.close()
        except:
            print "Unable to create trace.html"


    i = string.find(source, ">Please verify that this is the")

    if i != -1:
        source = searchForPlus(source, ">Please verify that this is the")
        source = searchForPlus(source, "class=\"headerblocktitle\"")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace.html", "w")
        t2.write(source)
        t2.close()



    tag = "class=\"a-size-mini a-spacing-none a-color-base s-line-clamp-2\""

    if string.find(source, tag) == -1:
        tag = "class=\"listView\""

    if string.find(source, tag) == -1:
        tag = "class=\"resultCount\""

    if string.find(source, tag) == -1:
        tag = "class=resultCount"

    if string.find(source, tag) == -1:
        tag = "id=\"result_0\""

    i = string.find(source, tag)

    if i != -1:
        # Amazon search results page, follow link
        source = searchForPlus(source, tag)
        source = searchForPlus(source, " href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        url = string.replace(url, "&#x2F;", "/")

        if url.startswith("http") != 1:
            url = siteurl + url

        http = HTTPConnection()
        
        #
        # Here is the problem. If we pretend to be Mozilla, Amazon uses advanced HTML, i.e. product
        # description is an object and not included in the HTML. So to get description we must be 
        # Readerware so that Amazon generates a basic HTML page.
        #try:
        #    http.setGenericUserAgent()
        #except:
        #    print "Unable to set UA"

        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    # Find Image
    imageFound = 0
    i = string.find(source, "registerImage(\"original_image\"")

    if i != -1:
        images = searchForPlus(source, "registerImage(\"original_image\"")
        images = searchForPlus(images, "\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "no-image")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                image = stripText(image[0:i] + image[i+j+1:])

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                vw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                vw.setImage1(image)
            else:
                vw.setImage1(image)

            imageFound = 1
    else:
        i = string.find(source, "id=\"prodImageCell\"")

        if i != -1:
            images = searchForPlus(source, "id=\"prodImageCell\"")
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])

            i = string.find(image, "videogames/ratings")

            if i != -1:
                image = "no-image"

            i = string.find(image, "no-image")

            if i == -1:
                i = string.find(image, "_AA")

                if i != -1:
                    j = string.find(image, "_.")
                    large = stripText(image[0:i] + image[j:])
                    vw.setLargeImage1(large)
                    image = stripText(image[0:i] + "_SL280" + image[j:])
                    vw.setImage1(image)
                else:
                    vw.setImage1(image)

                imageFound = 1


    # Find Image
    tag = "id=\"main_image_0\""

    i = string.find(source, tag)

    if i == -1:
        tag = "id=\"main-image-nonjs\""
        i = string.find(source, tag)

    if i == -1:
        tag = "id=\"rwImages_hidden\""
        i = string.find(source, tag)

    if i != -1:
        images = searchForPlus(source, tag)
        images = searchForPlus(images, "src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "no-image")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                image = stripText(image[0:i] + image[i+j+1:])

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                vw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                vw.setImage1(image)

            i = string.find(image, "_SY300_")

            if i != -1:
                large = string.replace(image, "_SY300_", "_SY500_")
                vw.setLargeImage1(large)
                vw.setImage1(image)
            else:
                vw.setImage1(image)

            imageFound = 1

    if vw.getLargeImage1() == None:
        i = string.find(source, "class=\"quorus-product-photo\"")

        if i != -1:
            images = stripText(source[i-200:])
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])

            i = string.find(image, "_SL")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                vw.setLargeImage1(large)

                imageFound = 1


    if imageFound == 0:                    
        tag = "'colorImages'"

        i = string.find(source, tag)

        if i != -1:
            images = searchForPlus(source, tag)
            i = string.find(images, "\n")
            images = stripText(images[0:i])
            i = string.find(images, "\"main\"")

            if i != -1:
                images = searchForPlus(images, "\"main\"")
                i = string.find(images, "http")
                image = stripText(images[i:])
                i = string.find(image, "\"")
                image = stripText(image[0:i])
                vw.setImage1(image)

                i = string.rfind(images, "http")
                image = stripText(images[i:])
                i = string.find(image, "\"")
                image = stripText(image[0:i])
                vw.setLargeImage1(image)
                imageFound = 1


    # Find Keywords
    i = string.find(source, "name=\"field+keywords\"")

    if i != -1:
        extracted = ""
        keywords = searchFor(source, "name=\"field+keywords\"")

        while (searchFor(keywords, "name=\"field+keywords\"") != None):
            keywords = searchForPlus(keywords, "name=\"field+keywords\"")
            keywords = searchForPlus(keywords, "value=\"")
            i = string.find(keywords, "\"")
            keyword = stripText(keywords[0:i])

            if extracted == "":
                extracted = keyword
            else:
                extracted = extracted + ", " + keyword

        vw.setKeywords(extracted)


    # Find used price
    i = string.find(source, "id=\"usedItemExpandBuyingInfoDiv\"")

    if i != -1:
        used = searchForPlus(source, "id=\"usedItemExpandBuyingInfoDiv\"")
        used = searchForPlus(used, cSymbol)
        i = string.find(used, "<")
        vw.setUsedPrice(used[0:i])


    # Find Title
    tag = "id=\"btAsinTitle\""

    if string.find(source, tag) == -1:
        tag = "id=\"productTitle\""
    
    if string.find(source, tag) == -1:
        tag = "id=\"mediaProductTitle\""
    
    source = searchForPlus(source, tag)
    source = searchForPlus(source, ">")
    source = stripText(source)

    if source.startswith("<span") == 1:
        source = searchForPlus(source, ">")

    i = string.find(source, "<")
    title = stripText(source[0:i])

    i = string.rfind(title, "(")

    if i != -1:
        date = stripText(title[i+1:])

        i = string.find(date, ")")

        if i != -1:
            vw.setCopyrightDate(date[0:i])

    if string.find(title, "[HD DVD]") != -1:
        vw.setFormat("HD DVD")

    if string.find(title, "(Combo HD DVD") != -1:
        vw.setFormat("HD DVD Combo")

    if string.rfind(title, "Blu-ray") != -1:
        vw.setFormat("Blu-ray")

    if string.rfind(title, "Blu-ray/DVD") != -1:
        vw.setFormat("Blu-ray/DVD")

    if string.rfind(title, "(Blu-ray + DVD") != -1:
        vw.setFormat("Blu-ray/DVD")

    if string.rfind(title, "(Blu-ray 3D") != -1:
        vw.setFormat("Blu-ray 3D")

    if string.rfind(title, "[Blu-ray 3D") != -1:
        vw.setFormat("Blu-ray 3D")

    if string.rfind(title, "(4K Ultra HD") != -1:
        vw.setFormat("4K Ultra HD Blu-ray")

    if string.rfind(title, "(4K UHD") != -1:
        vw.setFormat("4K Ultra HD Blu-ray")

    if string.rfind(title, "[VHS]") != -1:
        vw.setFormat("VHS")

    i = string.find(title, "[")

    if i != -1 and i != 0:
        title = stripText(title[0:i])

    i = string.find(title, "(")

    if i != -1:
        title = stripText(title[0:i])

    vw.setTitle(title)


    # Find VHS format
    i = string.find(source, ">Format:</span>&nbsp;VHS Tape")

    if i != -1:
        vw.setFormat("VHS")


    # Find video game format
    i = string.find(source, ">Platform: <strong>")

    if i != -1:
        format = searchForPlus(source, ">Platform: <strong>")
        i = string.find(format, "<")
        vw.setFormat(format[0:i])


    # Find format Amazon [AU]
    i = string.find(source, ">Format: <")

    if i != -1:
        format = searchForPlus(source, ">Format: <")
        format = searchForPlus(source, "<span>")
        i = string.find(format, "<")
        vw.setFormat(format[0:i])


    # Find video game format (Amazon UK)
    i = string.find(source, ">Platform:</b>")

    if i != -1:
        format = searchForPlus(source, ">Platform:</b>")
        format = searchForPlus(format, "</span>")
        i = string.find(format, "<")
        vw.setFormat(format[0:i])


    # Find List price
    i = string.find(source, "class=\"listprice\">")

    if i != -1 and i < 50000:
        value = searchForPlus(source, "class=\"listprice\">")
        value = searchForPlus(value, cSymbol)
        i = string.find(value, "<")
        vw.setListPrice(value[0:i])


    # Find value
    tag = "class=\"priceLarge\">"

    if string.find(source, tag) == -1:
        tag = "class=\"a-size-medium a-color-price\""

    if string.find(source, tag) == -1:
        tag = "class=\"a-size-base a-color-price a-color-price\""

    i = string.find(source, tag)

    if i != -1:
        value = searchForPlus(source, tag)
        value = searchForPlus(value, cSymbol)
        i = string.find(source, "<")
        vw.setItemValue(value[0:i])
        vw.setPurchasePrice(vw.getItemValue())
        vw.setPurchaseDate(Date())
        vw.setPurchasePlace(vw.getSource())


    # Find new price/count
    i = string.find(source, "&amp;condition=new")

    if i != -1:
        new = searchForPlus(source, "&amp;condition=new")
        new = searchForPlus(new, ">")
        i = string.find(new, "&")
        vw.setNewCount(new[0:i])

        new = searchForPlus(new, cSymbol)
        i = string.find(new, "<")
        vw.setNewPrice(new[0:i])


    # Find used price/count
    i = string.find(source, "&amp;condition=used")

    if i != -1:
        used = searchForPlus(source, "&amp;condition=used")
        used = searchForPlus(used, ">")
        i = string.find(used, "&")
        vw.setUsedCount(used[0:i])

        used = searchForPlus(used, cSymbol)
        i = string.find(used, "<")
        vw.setUsedPrice(used[0:i])


    # Find collectible price/count
    i = string.find(source, "&amp;condition=collectible")

    if i != -1:
        col = searchForPlus(source, "&amp;condition=collectible")
        col = searchForPlus(col, ">")
        i = string.find(col, "&")
        vw.setCollectibleCount(col[0:i])

        col = searchForPlus(col, cSymbol)
        i = string.find(col, "<")
        vw.setCollectiblePrice(col[0:i])


    # Find Extras
    i = string.find(source, ">Special Features<")

    if i != -1:
        extras = ""
        features = searchForPlus(source, ">Special Features<")
        features = searchForPlus(features, ">")
        i = string.find(features, "<hr ")
        features = stripText(features[0:i])

        while (searchFor(features, "id=\"postBodySPF\"") != None):
            features = searchForPlus(features, "id=\"postBodySPF\"")
            features = searchForPlus(features, ">")
            i = string.find(features, "</div>")
            extras = appendComment(extras, stripText(features[0:i]))

        vw.setExtrasInfo(extras)


    # Find Comments
    tag = ">Editorial Reviews<"
    comments = "Editorial Reviews<BR>"

    if string.find(source, tag) == -1:
        tag = "Editorial Reviews"
        comments = "Product Description<BR>"

    if string.find(source, tag) == -1:
        # Amazon UK comments
        tag = "Product description"
        comments = ""

    if string.find(source, tag) == -1:
        # Amazon CA comments
        tag = ">Product Description<"
        comments = "Product Description<BR>"

    if string.find(source, tag) != -1:
        reviews = searchForPlus(source, tag)
        reviews = searchForPlus(reviews, ">")

        i = string.find(reviews, "<style")

        if i != -1:
            reviews = stripText(reviews[0:i])

        while (searchFor(reviews, "id=\"productDescription\"") != None):
            reviews = searchForPlus(reviews, "id=\"productDescription\"")
            reviews = searchForPlus(reviews, ">")
            i = string.find(reviews, "</div>")
            comment = stripText(reviews[0:i])

            comments = appendComment(comments, comment)

        i = string.find(comments, "Special Features:")

        if i != -1:
            if vw.getExtrasInfo() == "":
                vw.setExtrasInfo(comments[i:])

            comments = stripText(comments[0:i])

        while (searchFor(reviews, "class=\"productDescriptionWrapper\"") != None):
            reviews = searchForPlus(reviews, "class=\"productDescriptionWrapper\"")
            reviews = searchForPlus(reviews, ">")
            i = string.find(reviews, "</div>")
            comment = stripText(reviews[0:i])
            comment = string.replace(comment, "<![CDATA[", "")
            comment = string.replace(comment, "]]>", "")

            comments = appendComment(comments, comment)

        i = string.find(comments, "Special Features:")

        if i != -1:
            if vw.getExtrasInfo() == "":
                vw.setExtrasInfo(comments[i:])

            comments = stripText(comments[0:i])

        vw.setProductInfo(comments)


    # Find Comments (Video games)
    i = string.find(source, ">Product Features<")

    if i != -1:
        comments = "Product Features<BR>"
        features = searchForPlus(source, ">Product Features<")
        features = searchForPlus(features, "\">")
        i = string.find(features, "</td>")
        features = stripText(features[0:i])

        comments = appendComment(comments, features)

        vw.setProductInfo(comments)


    # Find Actors
    actorTag = ">Actors:"
    i = string.find(source, actorTag)

    if i == -1:
        actorTag = ">Starring"
        i = string.find(source, actorTag)

    if i != -1:
        actors = searchForPlus(source, actorTag)
        i = string.find(actors, "\n")
        actors = stripText(actors[0:i])

        while (searchFor(actors, "href") != None):
            actors = searchForPlus(actors, "href")
            actors = searchForPlus(actors, ">")
            i = string.find(actors, "<")
            actor = stripText(actors[0:i])

            if actor == "See more":
                continue

            if actor == ".":
                continue

            vw.setActor(actor)


    # Find Director
    i = string.find(source, ">Director")

    if i != -1:
        director = searchForPlus(source, ">Director")
        director = searchForPlus(director, "\">")
        i = string.find(director, "<")
        director = stripText(director[0:i])

        if director != ".":
            vw.setDirector(director[0:i])


    # Find Producer
    i = string.find(source, ">Producer")

    if i != -1:
        producer = searchForPlus(source, ">Producer")
        producer = searchForPlus(producer, "\">")
        i = string.find(producer, "<")
        vw.setProducer(producer[0:i])


    # Find Writer
    i = string.find(source, ">Writers:<")

    if i != -1:
        writer = searchForPlus(source, ">Writers:<")
        writer = searchForPlus(writer, "\">")
        i = string.find(writer, "<")
        vw.setWriter(writer[0:i])


    # Find Attributes
    i = string.rfind(source, ">Format:<")

    if i != -1:
        attrs = stripText(source[i:])
        attrs = searchForPlus(attrs, ">")
        i = string.find(attrs, "</li>")
        attrs = stripText(attrs[0:i])

        # Find Color
        i = string.find(attrs, "Black & White")

        if i != -1:
            vw.setColor("Black & White")
        else:
            vw.setColor("Color")

        # Find Sound
        i = string.find(attrs, "HiFi Sound")

        if i != -1:
            vw.setSound("HiFi Sound")

        # Find Sound
        i = string.find(attrs, "Dolby")

        if i != -1:
            vw.setSound("Dolby")

        # Find Sound
        i = string.find(attrs, "DTS Surround Sound")

        if i != -1:
            vw.setSound("DTS Surround Sound")

        # Find Sound
        i = string.find(attrs, "AC-3")

        if i != -1:
            vw.setSound("AC-3")

        # Find Widescreen
        i = string.find(attrs, "Wide")

        if i != -1:
            vw.setAspectRatio("Widescreen")

        # Find Anamorphic
        i = string.find(attrs, "Anamorphic")

        if i != -1:
            vw.setAnamorphic("True")

        # Find Subtitles
        i = string.find(attrs, "Subtitled")

        if i != -1:
            vw.setSubtitled("True")


    # Find Language
    i = string.find(source, ">Language")

    if i != -1:
        language = searchForPlus(source, ">Language")
        language = searchForPlus(language, ">")
        i = string.find(language, "<")
        language = stripText(language[0:i])

        if string.find(language, vw.getLanguage()) == -1:
            # Extract only if default language not found
            i = string.find(language, "(")

            if i != -1:
                language = stripText(language[0:i])

            vw.setLanguage(language)


    # Find Subtitles
    i = string.find(source, ">Subtitles:")

    if i != -1:
        vw.setSubtitled("True")


    # Find Region
    i = string.find(source, ">Region:<")

    if i != -1:
        region = searchForPlus(source, ">Region:<")
        region = stripText(searchForPlus(region, ">"))

        if region.startswith("<") == 1:
            region = searchForPlus(region, "\">")

        i = string.find(region, "<")
        region = stripText(region[0:i])

        i = string.find(region, "(")

        if i != -1:
            region = stripText(region[0:i])

        if region.endswith(" encoding") == 1:
            region = stripText(region[0:len(region)-9])

        if region == "Region B/1":
            region = "Blu-ray Region A"

        if region == "Region B/2":
            region = "Blu-ray Region B"

        if region == "Region B/3":
            region = "Blu-ray Region C"

        vw.setRegion(region)


    # Find Aspect Ratio
    i = string.find(source, ">Aspect Ratio:<")

    if i != -1:
        ar = searchForPlus(source, ">Aspect Ratio:<")
        ar = searchForPlus(ar, ">")
        i = string.find(ar, "<")
        vw.setAspectRatio("Widescreen " + stripText(ar[0:i]))


    # Find MPAA Rating
    tag = ">Rating:"

    if string.find(source, tag) == -1:
        tag = ">Rated: <"

    if string.find(source, tag) != -1:
        cert = searchForPlus(source, tag)
        cert = searchForPlus(cert, "<span class=\"a-size-small\">")
        i = string.find(cert, "<")
        cert = stripText(cert[0:i])
        i = string.find(cert, " ")

        if i != -1:
            cert = stripText(cert[0:i])

        if cert == "Unrated":
            cert = "NR"

        if cert == "NR":
            vw.setCertification(cert)
        else:
            vw.setCertification(cert + " (MPAA)")


    # Find BBFC Rating
    i = string.find(source, ">Classification:")

    if i != -1:
        cert = searchForPlus(source, ">Classification:")
        cert = searchForPlus(cert, ">")
        i = string.find(cert, "</li>")
        cert = stripText(cert[0:i])

        i = string.find(cert, "<span>")

        if i != -1:
            cert = stripText(cert[i+6:])

        i = string.find(cert, "<")

        if i != -1:
            cert = stripText(cert[0:i])

        #i = string.find(cert, " ")

        #if i != -1:
        #    cert = stripText(cert[0:i])

        if cert == "Unrated":
            vw.setCertification("NR")
        elif cert == "To be announced":
            vw.setCertification("TBA")
        else:
            vw.setCertification(cert + " (BBFC)")


    # Find ESRB video game Rating
    i = string.find(source, ">ESRB Rating:")

    if i != -1:
        cert = searchForPlus(source, ">ESRB Rating:")
        cert = searchForPlus(cert, "\">")
        i = string.find(cert, "<")
        cert = stripText(cert[0:i])
        i = string.find(cert, " ")

        if i != -1:
            cert = stripText(cert[0:i])

        if cert == "Unrated":
            vw.setCertification("NR")
        else:
            vw.setCertification(cert + " (ESRB)")

        # Take out inappropriate video game defaults
        vw.setRegion("")
        vw.setAspectRatio("")
        vw.setLanguage("")


    # Find PEGI video game Rating (Amazon UK)
    i = string.find(source, ">PEGI")

    if i != -1:
        cert = searchForPlus(source, ">PEGI")
        cert = searchForPlus(cert, "Rating:")
        cert = searchForPlus(cert, ">")
        i = string.find(cert, "<")
        cert = stripText(cert[0:i])
        vw.setCertification(cert + " (PEGI)")

        # Take out inappropriate video game defaults
        vw.setRegion("")
        vw.setAspectRatio("")
        vw.setLanguage("")


    # Find Studio
    tag = ">Studio:<"

    if string.find(source, tag) == -1:
        tag = "field-brandtextbin"

    if string.find(source, tag) == -1:
        # Amazon UK
        tag = "index=video-games-uk"

    if string.find(source, tag) != -1:
        studio = searchForPlus(source, tag)
        studio = searchForPlus(studio, ">")
        i = string.find(studio, "<")
        vw.setStudio(studio[0:i])


    # Find Release date
    i = string.find(source, "Release Date:")

    if i != -1:
        date = searchForPlus(source, "Release Date:")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        vw.setReleaseDate(date[0:i])


    # Find Running time
    i = string.find(source, ">Run Time:<")

    if i != -1:
        run = searchForPlus(source, ">Run Time:<")
        run = searchForPlus(run, ">")
        i = string.find(run, "<")
        vw.setRunningTime(run[0:i])


    # Find User Rating
    i = string.find(source, ">Average Customer Review:<")

    if i != -1:
        rating = searchForPlus(source, ">Average Customer Review:<")
        rating = searchForPlus(rating, "class=\"swSprite s_star_")

        if rating != None:
            rating = searchForPlus(rating, "<span>")
            i = string.find(rating, " ")
            vw.setMyRating(rating[0:i])


    # Find Sales Rank
    tag = "Sales Rank:<"

    if string.find(source, tag) == -1:
        tag = " Bestsellers Rank:<"

    if string.find(source, tag) == -1:
        tag = " Best Sellers Rank:"

    i = string.find(source, tag)

    if i != -1:
        rank = searchForPlus(source, tag)
        rank = searchForPlus(rank, ">")
        i = string.find(rank, "<")
        rank = stripText(rank[0:i])

        i = string.find(rank, " ")

        if i != -1:
            rank = stripText(rank[0:i])

        if rank.startswith("#") == 1:
            rank = stripText(rank[1:])

        vw.setSalesRank(rank)


    # Find ASIN
    i = string.find(source, ">ASIN:")

    if i != -1:
        asin = searchForPlus(source, ">ASIN:")
        asin = searchForPlus(asin, ">")
        i = string.find(asin, "<")
        vw.setASIN(asin[0:i])


    # Find weight
    i = string.find(source, "Item Weight:")

    if i != -1:
        weight = searchForPlus(source, "Item Weight:")
        weight = searchForPlus(weight, ">")
        i = string.find(weight, "<")
        vw.setWeight(weight[0:i])


    # Find Category
    tag = "Similar Items by Category<"

    if string.find(source, tag) == -1:
        # Amazon UK
        tag = ">Look for similar items by category<"

    if string.find(source, tag) != -1:
        cats = searchForPlus(source, tag)
        cats = searchForPlus(cats, "<li>")
        i = string.find(cats, "</ul>")
        cats = stripText(cats[0:i])
        i = string.find(cats, "</li>")
        catl = stripText(cats[0:i])
        ccount = 1

        while (searchFor(catl, "href=\"") != None):
            catl = searchForPlus(catl, "href=\"")
            catl = searchForPlus(catl, "\">")
            i = string.find(catl, "<")
            cat = stripText(catl[0:i])

            if cat == "Bonus Offers":
                cats = searchForPlus(cats, "<li>")
                i = string.find(cats, "</li>")
                catl = stripText(cats[0:i])
                ccount = 1
                continue

            if cat == "English Subtitles":
                cats = searchForPlus(cats, "<li>")
                i = string.find(cats, "</li>")
                catl = stripText(cats[0:i])
                ccount = 1
                continue

            if cat == "Featured Categories":
                cats = searchForPlus(cats, "<li>")
                i = string.find(cats, "</li>")
                catl = stripText(cats[0:i])
                ccount = 1
                continue

            if cat == "Blu-ray":
                cats = searchForPlus(cats, "<li>")
                i = string.find(cats, "</li>")
                catl = stripText(cats[0:i])
                ccount = 1
                continue

            if cat == "DVD & Blu-ray":
                continue

            if cat == "Movies & TV":
                continue

            if ccount == 1:
                vw.setCategory1(cat)
            elif ccount == 2:
                vw.setCategory2(cat)
            else:
                vw.setCategory3(cat)
                break

            ccount = ccount + 1



try:
    vw.setVideoObject(Video)
    extract(source)

finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
