# This Python file uses the following encoding: iso-8859-1
# Amazon API scraper
#
# Copyright  1999-2019 Readerware Corporation.  All Rights Reserved.
#
# This will be called once the media object has been built using the Amazon API.
#
# This is a chance to adjust the extracted data.

import  os
import  string

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    java.lang import String
from    java.util import Date

import  vw


def apiextract(source):
    print "Amazon API video extraction script..."

    if source == "None":
        print "No source object received."
        return

    # Find Comments
    tag = ">Editorial Reviews<"
    comments = "Editorial Reviews<BR>"

    if string.find(source, tag) == -1:
        tag = "Editorial Reviews"
        comments = "Product Description<BR>"

    if string.find(source, tag) == -1:
        # Amazon UK comments
        tag = "Product description"
        comments = ""

    if string.find(source, tag) == -1:
        # Amazon CA comments
        tag = ">Product Description<"
        comments = "Product Description<BR>"

    if string.find(source, tag) != -1:
        reviews = searchForPlus(source, tag)
        reviews = searchForPlus(reviews, ">")

        i = string.find(reviews, "<style")

        if i != -1:
            reviews = stripText(reviews[0:i])

        while (searchFor(reviews, "id=\"productDescription\"") != None):
            reviews = searchForPlus(reviews, "id=\"productDescription\"")
            reviews = searchForPlus(reviews, ">")
            i = string.find(reviews, "</div>")
            comment = stripText(reviews[0:i])

            comments = appendComment(comments, comment)

        i = string.find(comments, "Special Features:")

        if i != -1:
            if vw.getExtrasInfo() == "":
                vw.setExtrasInfo(comments[i:])

            comments = stripText(comments[0:i])

        while (searchFor(reviews, "class=\"productDescriptionWrapper\"") != None):
            reviews = searchForPlus(reviews, "class=\"productDescriptionWrapper\"")
            reviews = searchForPlus(reviews, ">")
            i = string.find(reviews, "</div>")
            comment = stripText(reviews[0:i])
            comment = string.replace(comment, "<![CDATA[", "")
            comment = string.replace(comment, "]]>", "")

            comments = appendComment(comments, comment)

        i = string.find(comments, "Special Features:")

        if i != -1:
            if vw.getExtrasInfo() == "":
                vw.setExtrasInfo(comments[i:])

            comments = stripText(comments[0:i])

        vw.setProductInfo(comments)


try:
    vw.setVideoObject(Video)
    apiextract(source)
finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()

