# This Python file uses the following encoding: iso-8859-1
# Barnes and Noble video scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    vw.setDefaultPlace("US")
    vw.setDefaultRegion("Region 1")
    vw.setDefaultLanguage("English")
    vw.setCurrencySymbol("$")


    i = string.find(source, "Error=Premature EOF")

    if i != -1:
        # Sometimes getting thyis error from B&N, try again
        source = searchForPlus(source, "URL:")
        i = string.find(source, " ")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace.html", "w")
        t2.write(source)
        t2.close()

    # Main extraction
    i = string.find(source, "id=\"prodImage\"")

    if i != -1:
        images = searchForPlus(source, "id=\"prodImage\"")
        image = searchForPlus(images, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "0000000000")

        if i == -1:
            vw.setImage1("https:" + image)
            image = string.replace(image, "550x406", "600x595")
            vw.setLargeImage1("https:" + image)


    # Find Category
    tag = "<h2>Related Subjects<"
    i = string.find(source, tag)

    if i != -1:
        category = searchForPlus(source, tag)
        category = searchForPlus(category, " href")
        category = searchForPlus(category, ">")
        i = string.find(category, "<")
        vw.setCategory1(stripText(category[0:i]))


    # Find Title
    source = searchForPlus(source, "id=\"prodSummary-header\"")
    source = searchForPlus(source, "<h")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])

    if title == "The page you are looking for is currently unavailable.":
        source = searchFor(source, "force exception")
        source = searchFor(source, "force exception")
        return

    vw.setTitle(title)


    # Find Director
    i = string.find(source, "Director:")

    if i != -1:
        director = searchForPlus(source, "Director:")
        director = searchForPlus(director, "\">")
        i = string.find(director, "<")
        vw.setDirector(director[0:i])


    # Find Actors
    i = string.find(source, "Cast:")

    if i != -1:
        actors = searchForPlus(source, "Cast:")
        i = string.find(actors, "</span>")
        actors = stripText(actors[0:i])

        while (searchFor(actors, "<a href=") != None):
            actors = searchForPlus(actors, "<a href=")
            actor = searchForPlus(actors, ">")
            i = string.find(actor, "<")
            actor = stripText(actor[0:i])
            vw.setActor(actor)


    # Find Rating
    i = string.find(source, "itemprop=\"ratingValue\"")

    if i != -1:
        rating = searchForPlus(source, "itemprop=\"ratingValue\"")
        rating = searchForPlus(rating, ">")
        i = string.find(rating, "<")
        rating = stripText(rating[0:i])
        vw.setMyRating(rating)


    # Find List price
    i = string.find(source, "class=\"old-price\"")

    if i != -1:
        listprice = searchFor(source, "class=\"old-price\"")
        listprice = searchFor(listprice, "$")
        i = string.find(listprice, "<")
        vw.setListPrice(stripText(listprice[0:i]))


    # Find Retail Price (value)
    i = string.find(source, "itemprop=\"price\"")

    if i != -1:
        value = searchFor(source, "itemprop=\"price\"")
        value = searchFor(value, ">")
        i = string.find(value, "<")
        value = stripText(value[0:i])

        i = string.find(value, "&")

        if i != -1:
            value = stripText(value[0:i])

        vw.setItemValue(value)

        vw.setPurchasePrice(vw.getItemValue())
        vw.setPurchaseDate(Date())
        vw.setPurchasePlace(vw.getSource())


    # Find Format
    i = string.find(source, "id=\"prodPromo\"")

    if i != -1:
        format = searchForPlus(source, "id=\"prodPromo\"")
        format = searchForPlus(format, "<h2")
        format = searchForPlus(format, ">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        i = string.find(format, " - ")

        if i != -1:
            format = stripText(format[0:i])

        vw.setFormat(format);


    # Find Release Date
    i = string.find(source, "class=\"ReleaseDate\"")

    if i != -1:
        date = searchForPlus(source, "class=\"ReleaseDate\"")
        date = searchForPlus(date, ":")
        i = string.find(date, "<")
        vw.setReleaseDate(date[0:i])


    # Find Copyright Date
    i = string.find(source, "class=\"originalReleaseDate\"")

    if i != -1:
        copyDate = searchForPlus(source, "class=\"originalReleaseDate\"")
        copyDate = searchForPlus(copyDate, ":")
        i = string.find(copyDate, "<")
        vw.setCopyrightDate(copyDate[0:i])


    # Find UPC
    i = string.find(source, ">UPC:")

    if i != -1:
        upc = searchForPlus(source, ">UPC:")
        upc = searchForPlus(upc, "<td>")
        i = string.find(upc, "<")
        upc = stripText(upc[0:i])

        while len(upc) < 12:
            upc = "0" + upc

        if len(upc) == 13 and upc[0:1] == "0":
            upc = upc[1:13] 

        vw.setUPC(upc)


    # Find Product information
    comments = ""

    i = string.rfind(source, ">Overview</h2>")

    if i != -1:
        comment = searchForPlus(source, ">Overview</h2>")
        comment = searchForPlus(comment, "itemprop=\"description\"")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "</div")
        comment = stripText(comment[0:i])

        i = string.find(comment, "<script")

        if i != -1:
            comment = stripText(comment[0:i])

        i = string.find(comment, "<section")

        if i != -1:
            comment = stripText(comment[0:i])

        comments = appendComment(comments, comment)

    i = string.rfind(source, "<h2>Editorial Reviews</h2>")

    if i != -1:
        comment = searchFor(source, "<h2>Editorial Reviews</h2>")
        i = string.find(comment, "</div>")
        comment = stripText(comment[0:i])

        i = string.find(comment, "<aside")

        if i != -1:
            comment = stripText(comment[0:i])

        i = string.find(comment, "<p class=\"read-more fade\">")

        if i != -1:
            comment = stripText(comment[0:i])

        comments = appendComment(comments, comment)

    comments = string.replace(comments, "<footer>", "")
    comments = string.replace(comments, "</footer>", "")
    comments = string.replace(comments, "</aside>", "")
    comments = string.replace(comments, "<article>", "")
    comments = string.replace(comments, "</article>", "<br><br>")

    if comments != "":
        vw.setProductInfo(comments)


    # Find Extras information
    i = string.rfind(source, ">Special Features</h2>")

    if i != -1:
        comment = searchForPlus(source, ">Special Features</h2>")
        i = string.find(comment, "</div")
        comment = stripText(comment[0:i])

        i = string.find(comment, "Full Product Details<")

        if i != -1:
            comment = stripText(comment[0:i])

        i = string.find(comment, "Scene Index<")

        if i != -1:
            comment = stripText(comment[0:i])

        comment = string.replace(comment, "<article>", "")
        comment = string.replace(comment, "</article>", "<br><br>")

        vw.setExtrasInfo(comment)


    # Find Attributes
    i = string.rfind(source, ">Product Details<")

    if i != -1:
        attrs = stripText(source[i:])
        i = string.find(attrs, "</div>")
        attrs = stripText(attrs[0:i])


        # Find release date
        i = string.find(attrs, ">Release Date:")

        if i != -1:
            date = searchForPlus(attrs, ">Release Date:")
            date = searchForPlus(date, "<td>")
            i = string.find(date, "<")
            vw.setReleaseDate(stripText(date[0:i]))


        # Find copyright date
        i = string.find(attrs, ">Original Release:")

        if i != -1:
            date = searchForPlus(attrs, ">Original Release:")
            date = searchForPlus(date, "<td>")
            i = string.find(date, "<")
            vw.setCopyrightDate(stripText(date[0:i]))


        # Find Studio
        i = string.find(attrs, ">Source:")

        if i != -1:
            studio = searchForPlus(attrs, ">Source:")
            studio = searchForPlus(studio, "<td>")
            i = string.find(studio, "<")
            vw.setStudio(stripText(studio[0:i]))


        # Region
        i = string.find(attrs, ">Region Code:")

        if i != -1:
            region = searchForPlus(attrs, ">Region Code:")
            region = searchForPlus(region, "<td>")
            i = string.find(region, "<")
            region = stripText(region[0:i])

            if region == "A" or region == "B" or region == "C":
                vw.setRegion("Blu-ray Region " + region)
            else:
                vw.setRegion("Region " + region)


        # Rating
        i = string.find(attrs, ">Rating:")

        if i != -1:
            mpaa = searchForPlus(attrs, ">Rating:")
            mpaa = searchForPlus(mpaa, "<td>")
            i = string.find(mpaa, "<")
            mpaa = stripText(mpaa[0:i] + " (MPAA)")

            vw.setCertification(mpaa)


        # Sales Rank
        i = string.find(source, ">Sales rank:")

        if i != -1:
            salesrank = searchForPlus(source, ">Sales rank:")
            salesrank = searchForPlus(salesrank, "<td>")
            i = string.find(salesrank, "<")
            vw.setSalesRank(salesrank[0:i])


        # Find widescreen, color
        i = string.find(attrs, ">Presentation:")

        if i != -1:
            wide = searchForPlus(attrs, ">Presentation:")
            wide = searchForPlus(wide, "<td>")
            i = string.find(wide, "<")
            wide = stripText(wide[0:i])

            if string.find(wide, "Wide") != -1:
                vw.setAspectRatio("Widescreen")

            if string.find(wide, "B&W") != -1:
                vw.setColor("B&W")


        # Find aspect ratio
        i = string.find(attrs, ">Aspect Ratio:")

        if i != -1:
            ar = searchForPlus(attrs, ">Aspect Ratio:")
            i = string.find(ar, "<")
            ar = stripText(ar[0:i])

            if string.find(ar, "Wide") != -1:
                vw.setAspectRatio("Widescreen")

            i = string.find(ar, "(")

            if i != -1:
                ar = searchForPlus(attrs, "(")
                i = string.find(ar, ")")
                ar = stripText(ar[0:i])
                i = string.rfind(ar, ".")
                ar = stripText(ar[0:i] + ":" + ar[i+1:])
                vw.setAspectRatio("Widescreen " + ar)


        # Find Sound
        i = string.find(attrs, ">Sound:")

        if i != -1:
            sound = searchForPlus(attrs, ">Sound:")
            sound = searchForPlus(sound, "<td>")
            i = string.find(sound, "<")
            sound = stripText(sound[0:i])

            i = string.find(sound, ",")

            if i != -1:
                sound = stripText(sound[0:i])

            sound = string.replace(sound, "[", "")
            sound = string.replace(sound, "]", "")
            vw.setSound(sound)


        # Find Language
        i = string.find(attrs, ">Language:")

        if i != -1:
            language = searchForPlus(attrs, ">Language:")
            i = string.find(language, "<td>")
            language = stripText(language[0:i])

            i = string.find(language, ",")

            if i != -1:
                language = stripText(language[0:i])

            vw.setLanguage(language)


        # Find subtitled
        i = string.find(attrs, ">Editions:")

        if i != -1:
            attr = searchForPlus(attrs, ">Editions:")
            i = string.find(attr, "<")
            attr = stripText(attr[0:i])

            if string.find(attr, "Subtitled") != -1:
                vw.setSubtitled("True")
        else:
            i = string.find(attrs, ">Subtitles:")

            if i != -1:
                vw.setSubtitled("True")


        # Find Running Time
        i = string.find(attrs, ">Time:")

        if i != -1:
            running = searchForPlus(attrs, ">Time:")
            running = searchForPlus(running, "<td>")
            i = string.find(running, "<")
            vw.setRunningTime(stripText(running[0:i]))


    #Find Tracks
    i = string.find(source, "<h3>Menu</h3>")

    if i != -1:
        disks = searchForPlus(source, "<h3>Menu</h3>")
        i = string.find(disks, "</section>")
        disks = stripText(disks[0:i])
        diskCount = 0

        while (searchFor(disks, "Disc #") != None):
            disks = searchForPlus(disks, "Disc #")
            diskCount = diskCount + 1

            i = string.find(disks, "Disc #")

            if i != -1:
                tracks = stripText(disks[0:i])
            else:
                tracks = disks

            i = string.find(tracks, ";Episode")

            if i == -1:
                continue

            tracks = searchForPlus(tracks, ";Episode")
            i = string.find(tracks, "&nbsp; &nbsp;Language")

            if i != -1:
                tracks = stripText(tracks[0:i])

            i = string.find(tracks, "&nbsp; &nbsp;Scene")

            if i != -1:
                tracks = stripText(tracks[0:i])

            i = string.find(tracks, "&nbsp; &nbsp;Subtitles")

            if i != -1:
                tracks = stripText(tracks[0:i])

            i = string.find(tracks, "&nbsp; &nbsp;Features")

            if i != -1:
                tracks = stripText(tracks[0:i])

            i = string.find(tracks, "&nbsp; &nbsp;Extras")

            if i != -1:
                tracks = stripText(tracks[0:i])

            i = string.find(tracks, "&nbsp; &nbsp;Bonus Feature")

            if i != -1:
                tracks = stripText(tracks[0:i])

            i = string.find(tracks, "&nbsp; &nbsp;Setup")

            if i != -1:
                tracks = stripText(tracks[0:i])

            trackCount = 0

            while (searchFor(tracks, "&nbsp; &nbsp;&nbsp; &nbsp;") != None):
                tracks = searchForPlus(tracks, "&nbsp; &nbsp;&nbsp; &nbsp;")

                if tracks.startswith("&nbsp; &nbsp;") == 1:
                    tracks = searchForPlus(tracks, "&nbsp; &nbsp;")
                    continue;

                if tracks.startswith("<a ") == 1:
                    tracks = searchForPlus(tracks, "\">")

                i = string.find(tracks, "<")

                if i == -1:
                    track = tracks
                else:
                    track = stripText(tracks[0:i])

                if track == "Play All":
                    continue

                if track.endswith(": Chapters") == 1:
                    continue

                trackCount = trackCount + 1
                vw.setEpisode(diskCount, trackCount, track)


    # Second attempt at credits
    i = string.find(source, "id=\"CastCrew\"")

    if i != -1:

        # Find Actors
        i = string.find(source, ">Performance Credits<")

        if i != -1:
            source = searchForPlus(source, ">Performance Credits<")
            i = string.find(source, "</table>")
            actors = stripText(source[0:i])

            while (searchFor(actors, " href=") != None):
                actors = searchForPlus(actors, " href=")
                actor = searchForPlus(actors, ">")
                i = string.find(actor, "<")
                vw.setActor(stripText(actor[0:i]))

        # Find Director
        i = string.find(source, ">Director")

        if i != -1:
            tag = searchForPlus(source, ">Director")
            j = string.find(tag, "<")
            tag = stripText(tag[0:j])
            director = stripText(source[i-150:])
            director = searchForPlus(director, "href=")
            director = searchForPlus(director, ">")
            i = string.find(director, "<")
            vw.setDirector(director[0:i])

            i = string.find(tag, "Screenwriter")

            if i != -1:
                vw.setScreenwriter(vw.getDirector())

        # Find Producer
        i = string.find(source, ">Producer")

        if i != -1:
            producer = stripText(source[i-150:])
            producer = searchForPlus(producer, "href=")
            producer = searchForPlus(producer, ">")
            i = string.find(producer, "<")
            vw.setProducer(producer[0:i])

        # Find Composer
        i = string.find(source, ">Score Composer<")

        if i != -1:
            composer = stripText(source[i-150:])
            composer = searchForPlus(composer, "href=")
            composer = searchForPlus(composer, ">")
            i = string.find(composer, "<")
            vw.setComposer(composer[0:i])

        # Find Photographer
        i = string.find(source, ">Cinematographer<")

        if i != -1:
            photographer = stripText(source[i-150:])
            photographer = searchForPlus(photographer, "href=")
            photographer = searchForPlus(photographer, ">")
            i = string.find(photographer, "<")
            vw.setPhotographer(photographer[0:i])

        # Find Screenwriter
        i = string.find(source, ">Screenwriter<")

        if i != -1:
            screenwriter = stripText(source[i-150:])
            screenwriter = searchForPlus(screenwriter, "href=")
            screenwriter = searchForPlus(screenwriter, ">")
            i = string.find(screenwriter, "<")
            vw.setScreenwriter(screenwriter[0:i])

        # Find Editor
        i = string.find(source, ">Editor<")

        if i != -1:
            editor = stripText(source[i-150:])
            editor = searchForPlus(editor, "href=")
            editor = searchForPlus(editor, ">")
            i = string.find(editor, "<")
            vw.setEditor(editor[0:i])

        # Find Author
        i = string.find(source, ">Source Author<")

        if i != -1:
            author = stripText(source[i-150:])
            author = searchForPlus(author, "href=")
            author = searchForPlus(author, ">")
            i = string.find(author, "<")
            vw.setAuthor(author[0:i])

        





try:
    vw.setVideoObject(Video)
    extract(source)
finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
