# This Python file uses the following encoding: iso-8859-1
# Best Buy video scraper
#
# Copyright  1999-2020 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    vw.setDefaultPlace("US")
    vw.setDefaultRegion("Region 1")
    vw.setDefaultLanguage("English")

    cSymbol = "$"
    vw.setCurrencySymbol(cSymbol)

    siteurl = "https://www.bestbuy.com"


    tag = "class=\"sku-title\"><h4 class=\"sku-header\">"

    i = string.find(source, tag)

    if i != -1:
        # Best buy search results page, follow link
        source = searchForPlus(source, tag)
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])

        if url.startswith("http") != 1:
            url = siteurl + url

        http = HTTPConnection()
        http.blockForLoad();
        print "Getting item from:",url
        source = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    # Find Image
    imageFound = 0
    i = string.find(source, "class=\"primary-media-wrapper\"")

    if i != -1:
        images = searchForPlus(source, "class=\"primary-media-wrapper\"")
        images = searchForPlus(images, "src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])
        vw.setImage1(image)
        vw.setLargeImage1(image)


    # Find Title
    tag = "id=\"shop-product-title-"
    source = searchForPlus(source, tag)
    source = searchForPlus(source, "class=\"heading-5 v-fw-regular\"")
    source = searchForPlus(source, ">")
    source = stripText(source)
    i = string.find(source, "<")
    title = stripText(source[0:i])

    if string.find(title, "[4K Ultra HD Blu-ray]") != -1:
        vw.setFormat("4K Ultra HD Blu-ray")
    elif string.find(title, "[4K Ultra HD Blu-ray/Blu-ray]") != -1:
        vw.setFormat("4K Ultra HD Blu-ray")
    elif string.find(title, "[Blu-ray/DVD]") != -1:
        vw.setFormat("Blu-ray/DVD")
    elif string.find(title, "[DVD]") != -1:
        vw.setFormat("DVD")

    vw.setTitle(title)


    # Find value
    tag = "class=\"priceView-hero-price priceView-customer-price\""
    i = string.find(source, tag)

    if i != -1:
        value = searchForPlus(source, tag)
        value = searchForPlus(value, cSymbol)
        i = string.find(value, "</")
        value = stripText(value[0:i])
        value = string.replace(value, "<!-- -->", "")
        vw.setItemValue(value)
        vw.setPurchasePrice(vw.getItemValue())
        vw.setPurchaseDate(Date())
        vw.setPurchasePlace(vw.getSource())


    # Find Release date
    i = string.find(source, "<strong>Release Date</strong>")

    if i != -1:
        date = searchForPlus(source, "<strong>Release Date</strong>")
        date = searchForPlus(date, "class=\"product-data-value body-copy\">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        vw.setReleaseDate(date)


    # Find Rating
    i = string.find(source, "<strong>Rating</strong>")

    if i != -1:
        rating = searchForPlus(source, "<strong>Rating</strong>")
        rating = searchForPlus(rating, "data-track=\"Title-Product-Ratings\">")
        i = string.find(rating, "<")
        rating = stripText(rating[0:i])
        vw.setCertification(rating + " (MPAA)")
    else:
        vw.setReleaseDate("NR")


    # Find Comments
    tag = "class=\"shop-product-movie-schema\""

    if string.find(source, tag) != -1:
        comment = searchForPlus(source, tag)
        tag = "\"description\":\""

        if string.find(comment, tag) != -1:
            comment = searchForPlus(comment, tag)
            i = string.find(comment, "\",\"")
            comment = stripText(comment[0:i])
            vw.setProductInfo(comment)


    # Find Actors
    actorTag = ">Cast<"
    i = string.find(source, actorTag)

    if i != -1:
        actors = searchForPlus(source, actorTag)
        actors = searchForPlus(actors, "<ul>")
        i = string.find(actors, "</ul>")
        actors = stripText(actors[0:i])

        while (searchFor(actors, "class=\"name col-xs-6\"") != None):
            actors = searchForPlus(actors, "class=\"name col-xs-6\"")
            actors = searchForPlus(actors, "<strong>")
            i = string.find(actors, "<")
            actor = stripText(actors[0:i])
            vw.setActor(actor)


    # Find Director
    i = string.find(source, ">Director<")

    if i != -1:
        director = searchForPlus(source, ">Director<")
        director = searchForPlus(director, "class=\"name col-xs-6\"")
        director = searchForPlus(director, "<strong>")
        i = string.find(director, "<")
        director = stripText(director[0:i])
        vw.setDirector(director[0:i])


    # Find Writer
    i = string.find(source, ">Writer<")

    if i != -1:
        writer = searchForPlus(source, ">Writer<")
        writer = searchForPlus(writer, "class=\"name col-xs-6\"")
        writer = searchForPlus(writer, "<strong>")
        i = string.find(writer, "<")
        writer = stripText(writer[0:i])
        vw.setWriter(writer)




try:
    vw.setVideoObject(Video)
    extract(source)

finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
