# This Python file uses the following encoding: iso-8859-1
# bol.com [NL] video scraper
#
# Copyright  1999-2013 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import convertArtist

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    vw.setDefaultPlace("Netherlands")
    vw.setDefaultRegion("Region 2")
    vw.setDefaultLanguage("Dutch")
    vw.setCurrencySymbol("[[EUR]]")

    i = string.find(source, "Geen zoekresultaat")

    if i != -1:
        return


    i = string.find(source, "<title>bol.com | Zoekresultaten voor")

    if i != -1:
        # Search results page, get listing page
        source = searchForPlus(source, "class=\"product-title px_list_page_product_click")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = "https://www.bol.com" + stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace.html", "w")
        t2.write(source)
        t2.close()


    # Find Title
    source = searchForPlus(source, "name=\"product_title\"")
    source = searchForPlus(source, "<h1 class=")
    source = searchForPlus(source, "\">")
    i = string.find(source, "<")
    title = stripText(source[0:i])

    i = string.find(title, "(")

    if i != -1:
        title = stripText(title[0:i])

    vw.setTitle(title)


    # Find Studio
    i = string.find(source, "Distributeur")

    if i != -1:
        studio = searchForPlus(source, "Distributeur")
        studio = searchForPlus(studio, "title=\"")
        i = string.find(studio, "\"")
        studio = stripText(studio[0:i])
        vw.setStudio(studio)

    i = string.find(source, "Label")

    if i != -1:
        studio = searchForPlus(source, "Label")
        studio = searchForPlus(studio, "title=\"")
        i = string.find(studio, "\"")
        studio = stripText(studio[0:i])
        vw.setStudio(studio)


    # Find Image
    imageTag = "class=\"product-images"
    i = string.find(source, imageTag)

    if i != -1:
        image = searchForPlus(source, "class=\"product-images")
        image = searchForPlus(image, " src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        if image[i:].startswith("xxx") == 1:
            image = ""
        else:
            vw.setImage1(image)

        image = searchForPlus(source, "class=\"product-images")
        image = searchForPlus(image, " data-zoom-src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        if image != "":
            if image[i:].startswith("xxx") == 1:
                image = ""
            else:
                vw.setLargeImage1(image)


    # Find List Price
    i = string.find(source, "class=\"fleft boxedtop_xs\"")

    if i != -1:
        listprice = searchForPlus(source, "class=\"fleft boxedtop_xs\"")
        listprice = searchForPlus(listprice, " ")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])
        vw.setListPrice(listprice)


    # Find Price
    i = string.find(source, "\"offers\":{\"price\":")

    if i != -1:
        value = searchForPlus(source, "\"offers\":{\"price\":")
        value = searchForPlus(value, "\"")
        i = string.find(value, "\"")
        value = stripText(value[0:i])
        vw.setItemValue(value)

        vw.setPurchasePrice(vw.getItemValue())
        vw.setPurchaseDate(Date())
        vw.setPurchasePlace(vw.getSource())


    # Find Comments
    i = string.find(source, ">Productbeschrijving<")

    if i != -1:
        comments = searchFor(source, ">Productbeschrijving<")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</div>")
        comments = stripText(comments[0:i])
        comments = fixChar(comments)

        i = string.find(comments, "Tracklist<")

        if i != -1:
            comments = stripText(comments[0:i])

        vw.setProductInfo(comments)


    i = string.find(source, "<ul class=\"product-small-specs product-small-specs--large\"")

    if i != -1:
        info = searchForPlus(source, "<ul class=\"product-small-specs product-small-specs--large\"")
        i = string.find(info, "</ul>")
        info = stripText(info[0:i])

        # Find Format
        format = "DVD"

        i = string.find(info, "Dvd")

        if i != -1:
            format = "DVD"

        i = string.find(info, "Blu-ray")

        if i != -1:
            format = "Blu-ray"

        vw.setFormat(format)

        # Find Running time
        i = string.find(info, "minuten")

        if i != -1:
            running = info[i-55:]
            running = searchForPlus(running, "<li>")
            i = string.find(running, "&")
            running = stripText(running[0:i])

            i = string.find(running, ":")

            if i != -1:
                running = stripText(running[0:i])

            vw.setRunningTime(running)

        # Find Region
        i = string.find(info, "Regio")

        if i != -1:
            region = searchForPlus(info, "Regio")
            i = string.find(region, "<")
            region = stripText(region[0:i])
            vw.setRegion(region)


    # Find UPC
    i = string.find(source, "EAN")

    if i != -1:
        upc = searchForPlus(source, "EAN")
        upc = searchForPlus(upc, "class=\"specs__value\"")
        upc = searchForPlus(upc, ">")
        i = string.find(upc, "<")
        upc = stripText(upc[0:i])
        vw.setUPC(upc)


    # Find Category
    i = string.find(source, "specs__categories")

    if i != -1:
        cats = searchForPlus(source, "specs__categories")
        i = string.find(cats, "</ul>")
        cats = stripText(cats[0:i])

        ccount = 1

        while (searchFor(cats, "href=\"") != None):
            cats = searchForPlus(cats, "href=\"")
            cats = searchForPlus(cats, "\">")
            i = string.find(cats, "<")
            cat = stripText(cats[0:i])

            if ccount == 1:
                vw.setCategory1(cat)
            elif ccount == 2:
                vw.setCategory2(cat)
            else:
                vw.setCategory3(cat)
                break

            ccount = ccount + 1


    # Find Actors
    actorTag = "Acteurs"
    i = string.rfind(source, actorTag)

    if i != -1:
        actors = stripText(source[i:])
        i = string.find(actors, "</div>")
        actors = stripText(actors[0:i])

        while (searchFor(actors, "href") != None):
            actors = searchForPlus(actors, "href")
            actors = searchForPlus(actors, "\">")
            i = string.find(actors, "<")
            actor = stripText(actors[0:i])
            actor = fixChar(actor)
            vw.setActor(actor)


    # Find Screenwriter
    i = string.find(source, "Schrijver")

    if i != -1:
        screenwriter = searchForPlus(source, "Schrijver")
        screenwriter = searchForPlus(screenwriter, "class=\"specs__value\"")
        screenwriter = searchForPlus(screenwriter, "href=")
        screenwriter = searchForPlus(screenwriter, "\">")
        i = string.find(screenwriter, "<")
        screenwriter = stripText(screenwriter[0:i])
        screenwriter = fixChar(screenwriter)
        vw.setScreenwriter(screenwriter)


    # Find Director
    i = string.find(source, ">Regisseur(s)<")

    if i != -1:
        director = searchForPlus(source, ">Regisseur(s)<")
        director = searchForPlus(director, "class=\"specs__value\"")
        director = searchForPlus(director, "\">")
        i = string.find(director, "<")
        director = stripText(director[0:i])
        vw.setDirector(director)


    # Find Aspect Ratio
    i = string.find(source, "Beeldformaat")

    if i != -1:
        aspect = searchForPlus(source, "Beeldformaat")
        aspect = searchForPlus(aspect, "class=\"specs__value\"")
        aspect = searchForPlus(aspect, ">")
        i = string.find(aspect, "<")
        aspect = stripText(aspect[0:i])
        vw.setAspectRatio(aspect)


    # Find Color
    i = string.find(source, "Kleur")

    if i != -1:
        color = searchForPlus(source, "Kleur")
        color = searchForPlus(color, "class=\"specs__value\"")
        color = searchForPlus(color, ">")
        i = string.find(color, "<")
        color = stripText(color[0:i])
        vw.setColor(color)


    # Find Release Date
    i = string.find(source, "Releasedatum")

    if i != -1:
        date = searchForPlus(source, "Releasedatum")
        date = searchForPlus(date, "class=\"specs__value\"")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        vw.setReleaseDate(date)


    # Find Language
    i = string.find(source, "Overige talen")

    if i != -1:
        language = searchForPlus(source, "Overige talen")
        language = searchForPlus(language, "class=\"specs__value\"")
        language = searchForPlus(language, ">")
        i = string.find(language, "<")
        language = stripText(language[0:i])
        vw.setLanguage(language)


    # Find Sound
    i = string.find(source, "Audio")

    if i != -1:
        sound = searchForPlus(source, "Audio")
        sound = searchForPlus(sound, "class=\"specs__value\"")
        sound = searchForPlus(sound, ">")
        i = string.find(sound, "<")
        sound = stripText(sound[0:i])
        vw.setSound(sound)




def fixChar(source):
    source =  string.replace(source, "\xC3\xA5", "")
    source =  string.replace(source, "\xC3\xAB", "")
    source =  string.replace(source, "\xC3\xB8", "")
    return source


try:
    vw.setVideoObject(Video)
    extract(source)
finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
