# This Python file uses the following encoding: iso-8859-1
# fishpond.com.au video scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    vw.setRegion("Region 4")
    vw.setAspectRatio("Standard")
    vw.setSubtitled("False")
    vw.setLanguage("English")
    vw.setCertification("NR")
    vw.setCurrencySymbol("$")

    i = string.find(source, "> - did not match any products.")

    if i != -1:
        return

    i = string.find(source, ">Products meeting the search criteria<")

    if i != -1:
        source = searchForPlus(source, ">Products meeting the search criteria<")
        source = searchForPlus(source, "class=\"productListing-data\"")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()

    # Main extraction
    # Find Category
    ccount = 1
    categories = source
    i = string.find(categories, "class=\"breadcrumbLarge\"")

    if i != -1:
        categories = searchForPlus(categories, "class=\"breadcrumbLarge\"")
        i = string.find(categories, "</div>")
        categories = stripText(categories[0:i])

        while (searchFor(categories, "class=\"breadcrumbLarge\"") != None):
            categories = searchForPlus(categories, "class=\"breadcrumbLarge\"")
            categories = searchForPlus(categories, "itemprop=\"name\"")
            categories = searchForPlus(categories, ">")
            i = string.find(categories, "<")
            category = stripText(categories[0:i])

            if category == "" or category == "DVD Movies" or category == "Home":
                continue

            if ccount == 1:
                vw.setCategory1(category)
            elif ccount == 2:
                vw.setCategory2(category)
            else:
                vw.setCategory3(category)
                break

            ccount = ccount + 1


    # Find Title
    source = searchForPlus(source, "\"@type\":\"Product\"")
    title = searchForPlus(source, "\"name\":\"")
    i = string.find(title, "\"")
    title = stripText(title[0:i])
    vw.setTitle(title)


    # Find UPC
    i = string.find(source, "\"gtin13\":")

    if i != -1:
        upc = searchForPlus(source, "\"gtin13\":")
        upc = searchForPlus(upc, "\"")
        i = string.find(upc, "\"")
        upc = stripText(upc[0:i])
        vw.setUPC(upc)


    # Find Price
    tag = "\"price\":"
    i = string.find(source, tag)

    if i != -1:
        val = searchForPlus(source, tag)
        i = string.find(val, ",")
        val = stripText(val[0:i])

        if val != "$0.00":
            value = val

        vw.setItemValue(value)
        vw.setPurchasePrice(vw.getItemValue())
        vw.setPurchaseDate(Date())
        vw.setPurchasePlace(vw.getSource())


    # Find Image
    tag = "\"image\":"
    i = string.find(source, tag)

    if i != -1:
        image = searchForPlus(source, tag)
        image = searchForPlus(image, "\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "no-image")

        if i == -1:
            vw.setImage1(image)


    # Find Rating
    i = string.find(source, "\"ratingValue\":")

    if i != -1:
        rating = searchForPlus(source, "\"ratingValue\":")
        i = string.find(rating, ",")
        rating = stripText(rating[0:i])

        i = string.find(rating, "}")

        if i != -1:
            rating = stripText(rating[0:i])

        rating = "" + rating + " Stars"
        vw.setMyRating(rating)


    # Find Format
    i = string.find(source, "\"fileFormat\":")

    if i != -1:
        format = searchForPlus(source, "\"fileFormat\":")
        format = searchForPlus(format, "\"")
        i = string.find(format, "\"")
        format = stripText(format[0:i])

        i = string.find(format, "(")

        if i != -1:
            format = stripText(format[0:i])

        vw.setFormat(format)


    # Find MPAA Rating
    i = string.find(source, "\"contentRating\":")

    if i != -1:
        mpaa = searchForPlus(source, "\"contentRating\":")
        mpaa = searchForPlus(mpaa, "\"")
        i = string.find(mpaa, "\"")
        mpaa = stripText(mpaa[0:i])

        i = string.find(mpaa, "(")

        if i != -1:
            mpaa = stripText(mpaa[i+1:])

        i = string.find(mpaa, ")")

        if i != -1:
            mpaa = stripText(mpaa[0:i])

        vw.setCertification(mpaa)


    # Find Release date
    i = string.find(source, "\"datePublished\":")

    if i != -1:
        date = searchForPlus(source, "\"datePublished\":")
        date = searchForPlus(date, "\"")
        i = string.find(date, "\"")
        date = stripText(date[0:i])
        vw.setReleaseDate(date)


    # Find Copyright date
    i = string.find(source, ">Released Year:")

    if i != -1:
        copyDate = searchForPlus(source, ">Released Year:")
        copyDate = searchForPlus(copyDate, ">")
        i = string.find(copyDate, "<")
        copyDate = stripText(copyDate[0:i])
        vw.setCopyrightDate(copyDate)


    # Find Runtime
    i = string.find(source, "\"duration\":")

    if i != -1:
        running = searchForPlus(source, "\"duration\":")
        running = searchForPlus(running, "\"")
        i = string.find(running, "\"")
        running = stripText(running[1:i])

        i = string.find(running, "M")

        if i != -1:
            running = stripText(running[0:i])

        vw.setRunningTime(running)


    # Find Studio
    i = string.find(source, "\"publisher\":")

    if i != -1:
        publisher = searchForPlus(source, "\"publisher\":")
        publisher = searchForPlus(publisher, "\"name\":")
        publisher = searchForPlus(publisher, "\"")
        i = string.find(publisher, "\"")
        publisher = stripText(publisher[0:i])
        vw.setStudio(publisher)


    # Find Comments
    comments = ""
    tag = "\"description\":{"
    i = string.find(source, tag)

    if i != -1:
        comment = searchForPlus(source, tag)
        comment = searchForPlus(comment, "\"value\":\"")
        i = string.find(comment, "\"}")
        comment = stripText(comment[0:i])

        i = string.find(comment, "<br>\\n<b")

        if i != -1:
            comment = stripText(comment[0:i])

        comments = appendComment(comments, comment)

    vw.setProductInfo(comments)


    # Find Actors
    i = string.find(source, "\"actor\":")

    if i != -1:
        actors = searchForPlus(source, "\"actor\":")
        i = string.find(actors, "]")
        actors = stripText(actors[0:i]) + ", "

        while (searchFor(actors, "\"name\":") != None):
            actors = searchForPlus(actors, "\"name\":")
            actors = searchForPlus(actors, "\"")
            i = string.find(actors, "\"")
            actor = stripText(actors[0:i])
            vw.setActor(actor)


    # Find Director
    i = string.find(source, "\"director\":")

    if i != -1:
        director = searchForPlus(source, "\"director\":")
        director = searchForPlus(director, "\"name\"")
        director = searchForPlus(director, "\"")
        i = string.find(director, "\"")
        director = stripText(director[0:i])
        vw.setDirector(director)


    # Find Producer
    i = string.find(source, "\"producer\":")

    if i != -1:
        producer = searchForPlus(source, "\"producer\":")
        producer = searchForPlus(producer, "\"name\"")
        producer = searchForPlus(producer, "\"")
        i = string.find(producer, "\"")
        producer = stripText(producer[0:i])
        vw.setProducer(producer)


    # Find Writer
    i = string.find(source, "\"author\":")

    if i != -1:
        writer = searchForPlus(source, "\"author\":")
        writer = searchForPlus(writer, "\"name\"")
        writer = searchForPlus(writer, "\"")
        i = string.find(writer, "\"")
        writer = stripText(writer[0:i])
        vw.setWriter(writer)


    # Find Composer
    i = string.find(source, ">Composer:<")

    if i != -1:
        composer = searchForPlus(source, ">Composer:<")
        composer = searchForPlus(composer, " href=")
        composer = searchForPlus(composer, "\">")
        i = string.find(composer, "<")
        composer = stripText(composer[0:i])
        vw.setComposet(composer)


    # Find Sound
    i = string.find(source, ">Audio:<")

    if i != -1:
        sound = searchForPlus(source, ">Audio:<")
        sound = searchForPlus(sound, "<td")
        sound = searchForPlus(sound, ">")
        i = string.find(sound, "<")
        sound = stripText(sound[0:i])
        vw.setSound(sound)


    # Find Widescreen
    i = string.find(source, ">Widescreen: <")

    if i != -1:
        wide = searchForPlus(source, ">Widescreen: <")
        wide = searchForPlus(wide, "<td")
        wide = searchForPlus(wide, ">")
        i = string.find(wide, "<")
        wide = stripText(wide[0:i])

        if wide == "Yes":
            wide = "Y"
        else:
            wide = "N"



try:
    vw.setVideoObject(Video)
    extract(source)
finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
