# This Python file uses the following encoding: iso-8859-1
# imdb scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    print "vwimdbdx.py.extract(source)" 

    try:
        t4 = open(vw.getLogsDir() + "trace4.html", "w")
        t4.write(source)
        t4.close()
    except:
        print "Unable to write log file"

    # Defaults
    vw.setRegion("Region 1")
    vw.setAspectRatio("Standard")
    vw.setSubtitled("False")
    vw.setLanguage("English")
    vw.setCertification("NR")


    # Find Image
    tag = "rel='image_src'"
    i = string.find(source, tag)

    if i != -1:
        image = searchForPlus(source, tag)
        image = searchForPlus(image, "href=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "/nopicture/")

        if i == -1:
            vw.setImage1(image)
            vw.setLargeImage1(image)


    if vw.getImage1() == None:
        tag = "content=\"image\""
        i = string.find(source, tag)

        if i != -1:
            image = searchForPlus(source, tag)
            image = searchForPlus(image, "content=\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])

            i = string.find(image, "/nopicture/")

            if i == -1:
                vw.setImage1(image)
                vw.setLargeImage1(image)


    if vw.getImage1() == None:
        tag = "\"image\":"
        i = string.find(source, tag)

        if i != -1:
            image = searchForPlus(source, tag)
            image = searchForPlus(image, "\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])

            i = string.find(image, "/nopicture/")

            if i == -1:
                vw.setImage1(image)
                vw.setLargeImage1(image)

    # Find user rating
    i = string.find(source, "\"AggregateRating\"")

    if i != -1:
        rating = searchForPlus(source, "\"AggregateRating\"")
        rating = searchForPlus(rating, "\"ratingValue\":")
        i = string.find(rating, "}")
        rating = stripText(rating[0:i]) + " (IMDB)"
        rating = string.replace(rating, "\"", "")
        vw.setMyRating(rating)


    # Find Title
    tag = "class=\"title_wrapper\""
    i = string.find(source, tag)

    if i == -1:
        tag = "class=\"TitleHeader__TitleText"
        i = string.find(source, tag)

    if i == -1:
        tag = "title-block__title"
        i = string.find(source, tag)

    if i != -1:
        title = searchForPlus(source, tag)
        title = searchForPlus(title, "\">")
        i = string.find(title, "<")
        title = stripText(title[0:i])
        vw.setTitle(title)


    # Find Copyright date
    i = string.find(source, "/year/")

    if i != -1:
        date = searchForPlus(source, "/year/")
        i = string.find(date, "/")
        vw.setCopyrightDate(stripText(date[0:i]))


    # Find Copyright date
    i = string.find(source, ">Release date<")

    if i != -1:
        date = searchForPlus(source, ">Release date<")
        date = searchForPlus(date, "href=\"")
        date = searchForPlus(date, "\">")
        i = string.find(date, "<")
        date = stripText(date[0:i])

        i = string.find(date, "(")

        if i != -1:
            date = stripText(date[0:i])

        vw.setCopyrightDate(date)


    # Find US Rating
    i = string.find(source, ">Certificate:<")

    if i != -1:
        rating = searchForPlus(source, ">Certificate:<")
        rating = searchForPlus(rating, "<span>")
        i = string.find(rating, "<")
        rating = stripText(rating[0:i])
        rating = string.upper(rating) + " (MPAA)"
        vw.setCertification(rating)


    # Find US Rating
    i = string.find(source, ">Motion Picture Rating (MPAA)<")

    if i != -1:
        rating = searchForPlus(source, ">Motion Picture Rating (MPAA)<")
        rating = searchForPlus(rating, "class=\"ipc-metadata-list-item__list-content-item\"")
        rating = searchForPlus(rating, ">")
        i = string.find(rating, "<")
        rating = stripText(rating[0:i])
        rating = string.upper(rating) + " (MPAA)"
        vw.setCertification(rating)


    # Find Director
    i = string.find(source, ">Director:<")

    if i != -1:
        director = searchForPlus(source, ">Director:<")
        director = searchForPlus(director, "href")
        director = searchForPlus(director, ">")
        i = string.find(director, "<")
        director = stripText(director[0:i])
        vw.setDirector(director)


    # Find Director
    i = string.find(source, ">Director<")

    if i != -1:
        director = searchForPlus(source, ">Director<")
        director = searchForPlus(director, "href")
        director = searchForPlus(director, ">")
        i = string.find(director, "<")
        director = stripText(director[0:i])
        vw.setDirector(director)


    # Find writers
    tag = ">Writers:<"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Writers<"
        i = string.find(source, tag)

    if i != -1:
        writers = searchForPlus(source, tag)
        i = string.find(writers, "</div>")
        writers = stripText(writers[0:i])

        screenwriter = ""
        author = ""
        writer = ""

        while (searchFor(writers, "href") != None):
            writers = searchForPlus(writers, "href")

            i = string.find(writers, ">")

            if i == -1:
                break
            
            writers = searchForPlus(writers, ">")
            i = string.find(writers, "<")
            tempWriter = stripText(writers[0:i])
            tempType = ""

            i = string.find(writers, "(")
            j = string.find(writers, ")")

            if i != -1:
                tempType = stripText(writers[i:j+1])

            writerType = 0

            if string.find(tempType, "more credit") != -1:
                continue

            if string.find(tempType, "(novel)") != -1:
                writerType = 1

            if string.find(tempType, "(book)") != -1:
                writerType = 1

            if string.find(tempType, "(story") != -1:
                writerType = 2

            if string.find(tempType, "(short story") != -1:
                writerType = 2

            if string.find(tempType, "(based on the short story by") != -1:
                writerType = 2

            if writerType == 0:
                if screenwriter == "":
                    screenwriter = tempWriter
                    vw.setScreenwriter(screenwriter)
            elif writerType == 1:
                if author == "":
                    author = tempWriter
                    vw.setAuthor(author)
                    vw.setBook(title)
            elif writerType == 2:
                if writer == "":
                    writer = tempWriter
                    vw.setWriter(writer)


    # Find Release Date
    i = string.find(source, ">Release Date:<")

    if i != -1:
        date = searchForPlus(source, ">Release Date:<")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        i = string.find(date, "(")

        if i != -1:
            date = stripText(date[0:i])

        vw.setReleaseDate(date)


    # Find Category
    tag = ">Genres:<"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Genres<"
        i = string.find(source, tag)

    if i != -1:
        categories = searchForPlus(source, tag)
        i = string.find(categories, "</div>")
        categories = stripText(categories[0:i])
        count = 0

        while (searchFor(categories, "href") != None):
            categories = searchForPlus(categories, "href")
            categories = searchForPlus(categories, ">")
            i = string.find(categories, "<")

            next = stripText(categories[0:i])

            if next != "more":
                if count == 0:
                    vw.setCategory1(next)
                elif count == 1:
                    vw.setCategory2(next)
                elif count == 2:
                    vw.setCategory3(next)

            count = count + 1


    # Find Comments
    i = string.find(source, ">Storyline<")

    if i != -1:
        comments = searchForPlus(source, ">Storyline<")
        comments = searchForPlus(comments, "<div")
        i = string.find(comments, "<")
        comments = stripText(comments[0:i])
        vw.setProductInfo(comments)

    i = string.find(source, "class=\"plot_summary \"")

    if i != -1:
        comments = searchForPlus(source, "class=\"plot_summary \"")
        comments = searchForPlus(comments, "class=\"summary_text\"")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</div>")
        vw.setProductInfo(stripText(comments[0:i]))

    i = string.find(source, ">Plot:<")

    if i != -1:
        plot = searchForPlus(source, ">Plot:<")
        plot = searchForPlus(plot, "\">")
        i = string.find(plot, "<")
        vw.setProductInfo(stripText(plot[0:i]))

    i = string.find(source, "meta property=\"og:description\"")

    if i != -1:
        plot = searchForPlus(source, "meta property=\"og:description\"")
        plot = searchForPlus(plot, "content=\"")
        i = string.find(plot, "\"")
        vw.setProductInfo(stripText(plot[0:i]))


    # Find Actors
    castTag = ">Cast<"
    i = string.find(source, castTag)

    if i == -1:
        castTag = ">Top cast<"
        i = string.find(source, castTag)

    if i != -1:
        actors = searchForPlus(source, castTag)
        i = string.find(actors, "</table>")
        actors = stripText(actors[0:i])

        i = string.find(actors, "class=\"ipc-metadata-list ipc-metadata-list--dividers-all StyledComponents__CastMetaDataList-y9ygcu-10 cbPPkN ipc-metadata-list--base\"")

        if 1 != -1:
            actors = stripText(actors[0:i])

        while (searchFor(actors, "href=\"/name/") != None):
            actors = searchForPlus(actors, "href=\"/name/")
            actors = searchForPlus(actors, ">")
            i = string.find(actors, "<")
            actor = stripText(actors[0:i])
            vw.setActor(actor)


    # Find Running time
    tag = ">Runtime:<"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Runtime<"
        i = string.find(source, tag)

    if i != -1:
        temp = searchForPlus(source, tag)
        temp = searchForPlus(temp, "class=\"ipc-metadata-list-item__list-content-item\"")
        temp = searchForPlus(temp, ">")
        i = string.find(temp, "<")
        running = stripText(temp[0:i])
        running = string.replace(running, "h ", " hour ")
        running = string.replace(running, "min", " min")
        print ">RUNNING=",running
        vw.setRunningTime(running)


    # Find Place
    tag = ">Country:<"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Country of origin<"
        i = string.find(source, tag)

    if i != -1:
        place = searchForPlus(source, tag)
        place = searchForPlus(place, "href")
        place = searchForPlus(place, ">")
        i = string.find(place, "<")
        vw.setPlace(stripText(place[0:i]))


    # Find Language
    tag = ">Language:<"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Language<"
        i = string.find(source, tag)

    if i != -1:
        language = searchForPlus(source, tag)
        language = searchForPlus(language, "href")
        language = searchForPlus(language, ">")
        i = string.find(language, "<")
        vw.setLanguage(stripText(language[0:i]))


    # Find Color
    tag = ">Color:<"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Color<"
        i = string.find(source, tag)

    if i != -1:
        color = searchForPlus(source, tag)
        color = searchForPlus(color, "href")
        color = searchForPlus(color, ">")
        i = string.find(color, "<")
        vw.setColor(stripText(color[0:i]))


    # Find Aspect Ratio
    tag = ">Aspect Ratio:<"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Aspect ratio<"
        i = string.find(source, tag)

    if i != -1:
        aspect = searchForPlus(source, tag)
        aspect = searchForPlus(aspect, "class=\"ipc-metadata-list-item__list-content-item\"")
        aspect = searchForPlus(aspect, ">")
        i = string.find(aspect, "<")
        vw.setAspectRatio(stripText(aspect[0:i]))


    # Find Sound
    i = string.find(source, ">Sound Mix:<")

    if i != -1:
        sound = searchForPlus(source, ">Sound Mix:<")
        sound = searchForPlus(sound, "href")
        sound = searchForPlus(sound, ">")
        i = string.find(sound, "<")
        sound = stripText(sound[0:i])
        vw.setSound(sound)


