# This Python file uses the following encoding: iso-8859-1
# Barnes and Noble video scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    vw.setDefaultRegion("Region 2")
    vw.setDefaultLanguage("English")
    vw.setCurrencySymbol("R")

    i = string.find(source, ">Showing ")

    if i != -1:
        source = searchForPlus(source, ">Showing ")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText("http://www.loot.co.za" + source[0:i])
        url = string.replace(url, "&amp;", "&")
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    # Main extraction
    # Find Image
    i = string.find(source, "id=\"imagePreview0\"")

    if i != -1:
        image = searchForPlus(source, "id=\"imagePreview0\"")
        image = searchForPlus(image, "href=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "ImageNA")

        if i != -1:
            image = ""
        else:
            if image.startswith("http") == 0:
                image = "https:" + image

        vw.setImage1(image)
        vw.setLargeImage1(image)


    # Find Category
    tag = "> > <"
    i = string.find(source, tag)

    if i != -1:
        category = searchForPlus(source, tag)
        category = searchForPlus(category, "href")
        category = searchForPlus(category, ">")
        i = string.find(category, "<")
        vw.setCategory1(stripText(category[0:i]))


    # Find Title
    source = searchForPlus(source, "<table class=\"content\">")
    source = searchForPlus(source, "class=\"title\"")
    source = searchForPlus(source, "<em>")
    i = string.find(source, "<")
    title = stripText(source[0:i])

    i = string.find(title, "(")

    if i != -1:
        title = stripText(title[0:i])

    vw.setTitle(title)


    # Find Actors
    i = string.find(source, ">Actors:<")

    if i != -1:
        actors = searchForPlus(source, ">Actors:<")
        actors = searchForPlus(actors, "<td>")
        i = string.find(actors, "</td>")
        actors = stripText(actors[0:i]) + "&#8226;"

        while (searchFor(actors, "&#8226;") != None):
            i = string.find(actors, "&#8226;")
            actor = stripText(actors[0:i])
            vw.setActor(actor)
            actors = searchForPlus(actors, "&#8226;")

    i = string.find(source, ">Performers:<")

    if i != -1:
        actors = searchForPlus(source, ">Performers:<")
        actors = searchForPlus(actors, "<td>")
        i = string.find(actors, "</td>")
        actors = stripText(actors[0:i]) + "&#8226;"

        while (searchFor(actors, "&#8226;") != None):
            i = string.find(actors, "&#8226;")
            actor = stripText(actors[0:i])
            vw.setActor(actor)
            actors = searchForPlus(actors, "&#8226;")


    # Find Format
    i = string.find(source, ">Format:<")

    if i != -1:
        format = searchForPlus(source, ">Format:<")
        format = searchForPlus(format, "alt='")
        i = string.find(format, "'")
        format = stripText(format[0:i])
        vw.setFormat(format)


    # Find Rating
    i = string.find(source, "class=\"stars\"")

    if i != -1:
        rating = searchForPlus(source, "class=\"stars\"")
        rating = searchForPlus(rating, "/img/Stars")
        i = string.find(rating, ".")
        rating = stripText(rating[0:i])

        if rating == "1":
            vw.setMyRating("0.5 Stars")

        if rating == "2":
            vw.setMyRating("1 Stars")

        if rating == "3":
            vw.setMyRating("1.5 Stars")

        if rating == "4":
            vw.setMyRating("2 Stars")

        if rating == "5":
            vw.setMyRating("2.5 Stars")

        if rating == "6":
            vw.setMyRating("3 Stars")

        if rating == "7":
            vw.setMyRating("3.5 Stars")

        if rating == "8":
            vw.setMyRating("4 Stars")

        if rating == "9":
            vw.setMyRating("4.5 Stars")

        if rating == "10":
            vw.setMyRating("5 Stars")


    # Find List price
    i = string.find(source, ">List price:<")

    if i != -1:
        listprice = searchFor(source, ">List price:<")
        listprice = searchFor(listprice, "R")
        i = string.find(listprice, "<")
        vw.setListPrice(stripText(listprice[0:i]))


    # Find Retail Price (value)
    i = string.find(source, ">Loot Price:<")

    if i != -1:
        value = searchFor(source, ">Loot Price:<")
        value = searchFor(value, "R")
        i = string.find(value, "<")
        value = stripText(value[0:i])

        i = string.find(value, " ")

        if i != -1:
            i = string.find(value, " ")
            value = stripText(value[0:i])

        vw.setItemValue(value)

        vw.setPurchasePrice(vw.getItemValue())
        vw.setPurchaseDate(Date())
        vw.setPurchasePlace(vw.getSource())


    # Find Release Date
    i = string.find(source, ">Release&nbsp;date:<")

    if i != -1:
        date = searchForPlus(source, ">Release&nbsp;date:<")
        date = searchForPlus(date, "<td>")
        i = string.find(date, "<")
        vw.setReleaseDate(date[0:i])


    # Find MPAA rating
    i = string.find(source, ">Age&nbsp;restriction:<")

    if i != -1:
        mpaa = searchForPlus(source, ">Age&nbsp;restriction:<")
        mpaa = searchForPlus(mpaa, "<td>")
        i = string.find(mpaa, "<")
        mpaa = stripText(mpaa[0:i])
        vw.setCertification(mpaa)


    # Find Product information
    comments = ""
    i = string.find(source, "id=\"tab-1\"")

    if i != -1:
        info = searchForPlus(source, "id=\"tab-1\"")
        info = searchForPlus(info, ">")
        i = string.find(info, "</div")
        info = stripText(info[0:i])

        if comments == "":
            comments = info;
        else:
            comments = comments + "\n\n" + info;

    if comments != "":
        vw.setProductInfo(comments)


    # Find Studio
    i = string.find(source, ">Studio:<")

    if i != -1:
        studio = searchForPlus(source, ">Studio:<")
        studio = searchForPlus(studio, "<td>")
        i = string.find(studio, "<")
        vw.setStudio(stripText(studio[0:i]))


    # Region
    i = string.find(source, ">Region&nbsp;encoding:<")

    if i != -1:
        region = searchForPlus(source, ">Region&nbsp;encoding:<")
        region = searchForPlus(region, "'>")
        i = string.find(region, "<")
        region = stripText(region[0:i])

        i = string.find(region, ".")

        if i != -1:
            region = stripText(region[0:i])

        if region == "Region A":
            region = "Blu-ray Region A"

        if region == "Region B":
            region = "Blu-ray Region B"

        if region == "Region C":
            region = "Blu-ray Region C"

        vw.setRegion(region)


    # Find aspect ratio
    i = string.find(source, ">Video&nbsp;format:<")

    if i != -1:
        ar = searchForPlus(source, ">Video&nbsp;format:<")
        ar = searchForPlus(ar, "<td>")
        i = string.find(ar, "<")
        ar = stripText(ar[0:i])
        vw.setAspectRatio(ar)


    # Find Sound
    i = string.find(source, ">Audio&nbsp;format:<")

    if i != -1:
        sound = searchForPlus(source, ">Audio&nbsp;format:<")
        sound = searchForPlus(sound, "<td>")
        i = string.find(sound, "<")
        sound = stripText(sound[0:i])
        vw.setSound(sound)


    # Find Language
    i = string.find(source, ">Language")

    if i != -1:
        language = searchForPlus(source, ">Language")
        language = searchForPlus(language, "<td>")
        i = string.find(language, "<")
        language = stripText(language[0:i])

        i = string.find(language, "&#8226;")

        if i != -1:
            language = stripText(language[0:i])

        vw.setLanguage(language)


    # Find Subtitles
    i = string.find(source, ">Subtitles:<")

    if i != -1:
        vw.setSubtitled("True")


    # Find Running Time
    i = string.find(source, ">Running&nbsp;time:<")

    if i != -1:
        running = searchForPlus(source, ">Running&nbsp;time:<")
        running = searchForPlus(running, "<td>")
        i = string.find(running, "<")
        running = stripText(running[0:i])
        running = string.replace(running, ",", "")
        vw.setRunningTime(running)


    # Find Barcode
    i = string.find(source, ">Barcode:<")

    if i != -1:
        upc = searchForPlus(source, ">Barcode:<")
        upc = searchForPlus(upc, "<td>")
        i = string.find(upc, "<")
        upc = stripText(upc[0:i])
        vw.setUPC(upc)

        





try:
    vw.setVideoObject(Video)
    extract(source)
finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
