# This Python file uses the following encoding: iso-8859-1
# Michael's Movie Mayhem video scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment
from    vwimdbex  import extract as extract2

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    vw.setDefaultPlace("US")
    vw.setDefaultRegion("Region 1")
    vw.setDefaultLanguage("English")
    vw.setCurrencySymbol("$")


    # Find Price
    i = string.find(source, "<!--lowest price-->")

    if i != -1:
        value = stripText(source[i-50:])
        i = string.find(value, "$")

        if i != -1:
            value = searchFor(value, "$")
            i = string.find(value, "<")
            value = stripText(value[0:i])
            i = string.find(value, "!")

            if i != -1:
                value = stripText(value[0:i])

        vw.setItemValue(value)

        vw.setPurchasePrice(vw.getItemValue())
        vw.setPurchaseDate(Date())
        vw.setPurchasePlace(vw.getSource())


    # Find Title
    i = string.find(source, ">Title: <")

    if i == -1:
        title = ""
        return

    title = searchForPlus(source, ">Title: <")
    title = searchForPlus(title, "<td>")

    if title.startswith("<a href="):
        title = searchForPlus(title, "'>")

    i = string.find(title, "<")
    title = stripText(title[0:i])

    i = string.rfind(title, "(")

    if i != -1:
        format = stripText(title[i+1:])
        title = stripText(title[0:i])

        i = string.find(format, ")")

        if i != -1:
            format = stripText(format[0:i])

        i = string.find(format, " ")

        if i != -1:
            format = stripText(format[i:])

        vw.setFormat(format)


    vw.setTitle(title)


    # Find title & IMDB URL
    i = string.find(source, "imdb_popup.php")

    if i != -1:
        titleURL = searchFor(source, "imdb_popup.php")
        i = string.find(titleURL, "\"")
        titleURL = "http://dvdlist.kazart.com/" + stripText(titleURL[0:i])
        i = string.find(titleURL, "'")

        if i != -1:
            titleURL = stripText(titleURL[0:i])
    else:
        titleURL = ""

    i = string.find(source, "redirect_to_imdb.php")

    if i != -1:
        imdbURL = searchFor(source, "redirect_to_imdb.php")
        i = string.find(imdbURL, "\"")
        imdbURL = "http://dvdlist.kazart.com/" + stripText(imdbURL[0:i])
        i = string.find(imdbURL, "'")

        if i != -1:
            imdbURL = stripText(imdbURL[0:i])
    else:
        imdbURL = ""


    # Find Copyright date
    i = string.find(source, ">Year: <")

    if i != -1:
        date = searchForPlus(source, ">Year: <")
        date = searchForPlus(date, "<td>")
        i = string.find(date, "<")
        date = stripText(date[0:i])

        i = string.find(date, "&nbsp;")

        if i != -1:
            date = stripText(date[0:i])

        vw.setCopyrightDate(date)


    # Find Studio
    i = string.find(source, ">Studio: <")

    if i != -1:
        source = searchForPlus(source, ">Studio: <")
        source = searchForPlus(source, "<td>")
        source = searchForPlus(source, "'>")
        i = string.find(source, "<")
        vw.setStudio(stripText(source[0:i]))


    # Find Category
    i = string.find(source, ">Genre: <")

    if i != -1:
        source = searchForPlus(source, ">Genre: <")
        source = searchForPlus(source, "<td>")
        i = string.find(source, "<")
        vw.setCategory1(stripText(source[0:i]))


    # Find Sound
    i = string.find(source, ">Sound: <")

    if i != -1:
        source = searchForPlus(source, ">Sound: <")
        source = searchForPlus(source, "<td>")
        i = string.find(source, "<")
        vw.setSound(stripText(source[0:i]))


    # Find Rating
    i = string.find(source, ">Rating: <")

    if i != -1:
        source = searchForPlus(source, ">Rating: <")
        source = searchForPlus(source, "<td>")
        i = string.find(source, "<")
        vw.setCertification(stripText(source[0:i]))


    # Find Widescreen
    i = string.find(source, ">Version: <")

    if i != -1:
        source = searchForPlus(source, ">Version: <")
        source = searchForPlus(source, "<td>")
        i = string.find(source, "<")
        temp = stripText(source[0:i])

        if string.find(temp, "Anamorphic") != -1:
            vw.setAnamorphic("true")

        if string.find(temp, "LBX") != -1:
            vw.setAspectRatio("Widescreen")
            temp = searchForPlus(temp, "LBX")

            if temp.startswith(","):
                temp = searchForPlus(temp, ",")
                i = string.find(temp, "<")
                temp = stripText(temp[0:i])

                i = string.find(temp, "(")

                if i != -1:
                    temp = stripText(temp[0:i])

                i = string.find(temp, "&nbsp;")

                if i != -1:
                    temp = stripText(temp[0:i])

                vw.setAspectRatio("Widescreen " + temp)


        if string.find(temp, "Letterbox") != -1:
            vw.setAspectRatio("Widescreen")


    # Find Release date
    i = string.find(source, ">Release: <")

    if i != -1:
        source = searchForPlus(source, ">Release: <")
        source = searchForPlus(source, "<td>")
        i = string.find(source, "<")
        vw.setReleaseDate(stripText(source[0:i]))


    # Find UPC Code
    i = string.find(source, ">UPC: <")

    if i != -1:
        source = searchForPlus(source, ">UPC: <")
        source = searchForPlus(source, "<td>")
        i = string.find(source, "<")
        vw.setUPC(stripText(source[0:i]))


    # Find MMM Image
    i = string.find(source, "target='Cover'")

    if i != -1:
        image = searchForPlus(source, "target='Cover'")
        image = searchForPlus(image, "<IMG SRC=")
        i = string.find(image, " ")
        vw.setImage1(stripText(image[0:i]))

    i = string.find(source, "Large=")

    if i != -1:
        image = searchForPlus(source, "Large=")
        i = string.find(image, "&")
        vw.setLargeImage1(stripText(image[0:i]))


    # Retrieve IMDb data
    if titleURL == "":
        return

    http = HTTPConnection()
    http.resetReferer();
    http.blockForLoad();
    source = http.getContents(titleURL)
    t2 = open(vw.getLogsDir() + "trace2.html", "w")
    t2.write(source)
    t2.close()

    imageref = "http://www.imdb.com"


    # Find Image
    i = string.find(source, "<IMG SRC=")

    if (i != -1):
        source = searchForPlus(source, "<IMG SRC=")
        i = string.find(source, " ")
        vw.setImage1("http://dvdlist.kazart.com/" + stripText(source[0:i]))


    # Find Director
    i = string.find(source, ">Directed by:<")

    if i != -1:
        source = searchForPlus(source, ">Directed by:<")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        vw.setDirector(stripText(source[0:i]))


    # Find Actors
    i = string.find(source, ">Starring:<")

    if i != -1:
        source = searchForPlus(source, ">Starring:<")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        actors = stripText(source[0:i])

        while (actors != ""):
            i = string.find(actors, ",")

            if i != -1:
                actor = stripText(actors[0:i])
                actors = searchForPlus(actors, ",")
            else:
                actor = actors
                actors = ""

            i = string.rfind(actor, " ")

            if (i != -1):
                actor = stripText(actor[i:]) + ", " + stripText(actor[0:i])

            if imdbURL == "":
                # Don't have IMDb URL, get actors from MMM 
                vw.setActor(actor)


    # Find user rating
    i = string.find(source, ">IMDb Rating:<")

    if i != -1:
        source = searchForPlus(source, ">IMDb Rating:<")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        vw.setMyRating(stripText(source[0:i]) + " (IMDB)")


    # Find user comments
    i = string.find(source, ">Plot:<")

    if i != -1:
        source = searchForPlus(source, ">Plot:<")
        source = searchForPlus(source, ">")
        i = string.find(source, "</P>")
        vw.setProductInfo(stripText(source[0:i]))


    if imdbURL == "":
        return

    http = HTTPConnection()
    http.resetReferer();
    http.blockForLoad();
    source = http.getContents(imdbURL)

    i = string.find(source, "URL=")

    if i == -1:
        return

    imdbURL = searchForPlus(source, "URL=")
    i = string.find(imdbURL, "\"")
    imdbURL = stripText(imdbURL[0:i])

    http = HTTPConnection()
        
    try:
        http.setGenericUserAgent()
    except:
        print "Unable to set UA"

    http.blockForLoad();
    source = http.getContents(imdbURL)
    t2 = open(vw.getLogsDir() + "trace3.html", "w")
    t2.write(source)
    t2.close()

    extract2(source)





try:
    vw.setVideoObject(Video)
    extract(source)
finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
