# This Python file uses the following encoding: iso-8859-1
# Amazon US, UK, CA video scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    vw.setDefaultPlace("US")
    vw.setDefaultRegion("Region 1")
    vw.setDefaultLanguage("English")

    cSymbol = "$"
    vw.setCurrencySymbol(cSymbol)


    # Main Extraction
    # Find Title
    tag = "og:title"
    title = searchForPlus(source, tag)
    title = searchForPlus(title, "content=\"")
    i = string.find(title, "\"")
    title = stripText(title[0:i])
    vw.setTitle(title)

    # Advance to main content
    tag = "\"@context\":\""
    source = searchForPlus(source, tag)


    # Find Image
    tag = "\"image\":"

    i = string.find(source, tag)

    if i != -1:
        image = searchForPlus(source, tag)
        image = searchForPlus(image, "\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])
        vw.setImage1(image)
        vw.setLargeImage1(image)

    # Find Copyright date
    i = string.find(source, "\"dateCreated\"")

    if i != -1:
        date = searchForPlus(source, "\"dateCreated\"")
        date = searchForPlus(date, ":")
        i = string.find(date, ",")
        date = stripText(date[0:i])
        vw.setCopyrightDate(date)

    # Find Certification
    i = string.find(source, "\"contentRating\"")

    if i != -1:
        cert = searchForPlus(source, "\"contentRating\"")
        cert = searchForPlus(cert, "\"")
        i = string.find(cert, "\"")
        cert = stripText(cert[0:i])
        vw.setCertification(cert)

    # Find Product Info
    i = string.find(source, "\"description\"")

    if i != -1:
        info = searchForPlus(source, "\"description\"")
        info = searchForPlus(info, "\"")
        i = string.find(info, "\",\"")
        info = stripText(info[0:i])
        vw.setProductInfo(info)

    # Actors
    i = string.find(source, "\"actor\"")

    if i != -1:
        actors = searchForPlus(source, "\"actor\"")
        actors = searchForPlus(actors, "[")
        i = string.find(actors, "]")
        actors = stripText(actors[0:i])

        while (searchFor(actors, "\"name\"") != None):
            actors = searchForPlus(actors, "\"name\"")
            actors = searchForPlus(actors, "\"")
            i = string.find(actors, "\"")
            actor = stripText(actors[0:i])

            vw.setActor(actor)

    # Find Director
    i = string.find(source, "\"director\"")

    if i != -1:
        director = searchForPlus(source, "\"director\"")
        director = searchForPlus(director, "\"name\"")
        director = searchForPlus(director, "\"")
        i = string.find(director, "\"")
        director = stripText(director[0:i])
        vw.setDirector(director)

    # Find Trailer
    i = string.find(source, "\"Trailer\"")

    if i != -1:
        trailer = searchForPlus(source, "\"Trailer\"")
        trailer = searchForPlus(trailer, "\"embedUrl\"")
        trailer = searchForPlus(trailer, "\"")
        i = string.find(trailer, "\"")
        trailer = stripText(trailer[0:i])
        vw.setMediaURL(trailer)




try:
    vw.setVideoObject(Video)
    extract(source)

finally:
    if os.path.exists(vw.getDocsDir() + "vwuserexit.py"):
        execfile(vw.getDocsDir() + "vwuserexit.py") in globals()
